using System.Collections.Generic;
using System.Text.Json.Serialization;

namespace Adaptation.FileHandlers.Priority;

#nullable enable

public class Settings
{

    [JsonConstructor]
    public Settings(int digits,
                    string parentDirectory,
                    int priorities,
                    int priorityGroups,
                    string sourceFileFilter,
                    string sourceFileLocation,
                    string targetFileLocation)
    {
        Digits = digits;
        ParentDirectory = parentDirectory;
        Priorities = priorities;
        PriorityGroups = priorityGroups;
        SourceFileFilter = sourceFileFilter;
        SourceFileLocation = sourceFileLocation;
        TargetFileLocation = targetFileLocation;
    }

    public int Digits { get; } // [JsonPropertyName("Digits")]
    public string ParentDirectory { get; } // [JsonPropertyName("ParentDirectory")]
    public int Priorities { get; } // [JsonPropertyName("Priorities")]
    public int PriorityGroups { get; } // [JsonPropertyName("PriorityGroups")]
    public string SourceFileFilter { get; } // [JsonPropertyName("SourceFileFilter")]
    public string SourceFileLocation { get; } // [JsonPropertyName("SourceFileLocation")]
    public string TargetFileLocation { get; } // [JsonPropertyName("TargetFileLocation")]

}

[JsonSourceGenerationOptions(WriteIndented = true)]
[JsonSerializable(typeof(Dictionary<int, Settings>))]
internal partial class SettingsDictionarySourceGenerationContext : JsonSerializerContext
{
}