var _chat = {};
var _site = '';
var _apiUrl = '';
var _toggle = true;
var _username = '';
var _machineId = '';
var _windowLocationHRef = '';
var _connectionHubStartDone = false;

function compareFunctionSortOrder(a, b) {
    return a.SortOrder - b.SortOrder;
}

function compareFunctionParentId(a, b) {
    return a.ParentId - b.ParentId || a.Id - b.Id;
}

function compareFunctionWeightedShortestJobFirst(a, b) {
    if (b.WeightedShortestJobFirst === '&nbsp;') {
        return -1;
    }
    return b.WeightedShortestJobFirst - a.WeightedShortestJobFirst;
}

function getState(state) {
    var result;
    if (state == undefined)
        result = "9-Null";
    else if (state === "New")
        result = `1-${state}`;
    else if (state === "Active")
        result = `2-${state}`;
    else if (state === "Resolved")
        result = `3-${state}`;
    else if (state === "Closed")
        result = `4-${state}`;
    else if (state === "Removed")
        result = `5-${state}`;
    else
        result = `8-${state}`;
    return result;
}

function getPriority(workItemType, priority, sortPriorityGroup) {
    var result;
    if (workItemType === "Bug")
        result = "0-Bug {0}";
    else if (priority == undefined || priority === 0)
        result = "9-Null {0}";
    else if (priority === 1)
        result = `${priority}-High {${sortPriorityGroup}}`;
    else if (priority === 2)
        result = `${priority}-Med {${sortPriorityGroup}}`;
    else if (priority === 3)
        result = `${priority}-Low {${sortPriorityGroup}}`;
    else if (priority === 4)
        result = `${priority}-TBD {4}`;
    else
        result = "8-Not {0}";
    return result;
}

function getNotifications(x, aggregation) {
    var result;
    if (aggregation == undefined || aggregation.Notifications == undefined || aggregation.Notifications.length === 0)
        result = "&nbsp;";
    else {
        result = '';
        aggregation.Notifications.forEach(element => {
            const username = element.username == null ? 'user' : element.username;
            if (element.value === 1) {
                result += 'Highest ' + username + '|';
            }
            else if (element.value === 2) {
                result += 'High ' + username + '|';
            }
            else if (element.value === 3) {
                result += 'Medium ' + username + '|';
            }
            else if (element.value === 4) {
                result += 'Low ' + username + '|';
            }
            else if (element.value === 5) {
                result += 'Lowest ' + username + '|';
            }
            else {
                result += element.value + ' ' + username + '|';
            }
        });
        result = result.substring(0, result.length - 1);
        result = result.replaceAll('|', '<br />');
    }
    return result;
}

function myRound(value, factor) {
    return (Math.round((value + Number.EPSILON) * factor) / factor).toFixed(2);
}

function updateRecordCoD(b, r, t, c, e, w, workItem, dataB) {
    if (workItem != undefined) {
        var data = dataB == undefined ? undefined : dataB[workItem.Id];
        if (data == undefined) {
            workItem.Effort = "&nbsp;";
            workItem.BusinessValue = "&nbsp;";
            workItem.TimeCriticality = "&nbsp;";
            workItem.RiskReductionMinusOpportunityEnablement = "&nbsp;";
            workItem.CoD = "&nbsp;";
            workItem.WeightedShortestJobFirst = "&nbsp;";
            workItem.Priority = getPriority(workItem.WorkItemType, 4, 0);
            workItem.EffortNotifications = "&nbsp;";
            workItem.BusinessValueNotifications = "&nbsp;";
            workItem.TimeCriticalityNotifications = "&nbsp;";
            workItem.RiskReductionMinusOpportunityEnablementNotifications = "&nbsp;";
            workItem.SortOrder = 0;
        }
        else {
            workItem.Effort = data.Effort == undefined || data.Effort.FibonacciAverage == undefined ? "&nbsp;" : myRound(data.Effort.FibonacciAverage, 100);
            workItem.BusinessValue = data.BusinessValue == undefined || data.BusinessValue.FibonacciAverage == undefined ? "&nbsp;" : myRound(data.BusinessValue.FibonacciAverage, 100);
            workItem.TimeCriticality = data.TimeCriticality == undefined || data.TimeCriticality.FibonacciAverage == undefined ? "&nbsp;" : myRound(data.TimeCriticality.FibonacciAverage, 100);
            workItem.RiskReductionMinusOpportunityEnablement = data.RiskReductionOpportunityEnablement == undefined || data.RiskReductionOpportunityEnablement.FibonacciAverage == undefined ? "&nbsp;" : myRound(data.RiskReductionOpportunityEnablement.FibonacciAverage, 100);
            workItem.CoD = data.CostOfDelay == undefined ? "&nbsp;" : myRound(data.CostOfDelay, 100);
            workItem.WeightedShortestJobFirst = data.WeightedShortestJobFirst == undefined ? "&nbsp;" : myRound(data.WeightedShortestJobFirst, 100);
            workItem.Priority = data.SortPriority == undefined ? getPriority(workItem.WorkItemType, 4, 0) : getPriority(workItem.WorkItemType, data.SortPriority, data.SortPriorityGroup);
            workItem.EffortNotifications = data.Effort == undefined ? "&nbsp;" : getNotifications(e, data.Effort);
            workItem.BusinessValueNotifications = data.BusinessValue == undefined ? "&nbsp;" : getNotifications(b, data.BusinessValue);
            workItem.TimeCriticalityNotifications = data.TimeCriticality == undefined ? "&nbsp;" : getNotifications(t, data.TimeCriticality);
            workItem.RiskReductionMinusOpportunityEnablementNotifications = data.RiskReductionOpportunityEnablement == undefined ? "&nbsp;" : getNotifications(r, data.RiskReductionOpportunityEnablement);
            workItem.SortOrder = data.SortOrder == undefined ? 0 : data.SortOrder;
        }
    }
}

function updateRecordParent(parent, workItem) {
    if (parent == undefined) {
        workItem.ParentId = 9999999;
        workItem.ParentTitle = null;
        workItem.ParentState = null;
        workItem.ParentCoD = 9999999;
    }
    else {
        workItem.ParentId = parent.Id;
        workItem.ParentCoD = parent.CoD;
        workItem.ParentTitle = parent.Title;
        workItem.ParentState = getState(parent.State);
    }
}

function getRecords(b, r, t, c, e, w, data, dataB) {
    var parent;
    var workItem;
    var records = [];
    for (var i = 0; i < data.length; i++) {
        parent = data[i].Parent;
        workItem = data[i].WorkItem;
        if (workItem.WorkItemType !== 'Feature')
            continue;
        if (workItem.State !== 'Active' && workItem.State !== 'New')
            continue;
        if (workItem.Tags != null && workItem.Tags.includes("Ignore"))
            continue;
        if ((_windowLocationHRef.indexOf('=LEO') > -1 && workItem.AreaPath !== 'ART SPS\\LEO') || (_windowLocationHRef.indexOf('=MES') > -1 && workItem.AreaPath !== 'ART SPS\\MES'))
            continue;
        updateRecordParent(parent, workItem);
        updateRecordCoD(b, r, t, c, e, w, parent, null);
        updateRecordCoD(b, r, t, c, e, w, workItem, dataB);
        workItem.State = getState(workItem.State);
        records.push(workItem);
    }
    if (_windowLocationHRef.indexOf('=WSJF') > -1) {
        records.sort(compareFunctionWeightedShortestJobFirst);
    }
    else if (_windowLocationHRef.indexOf('=LIVE') > -1) {
        records.sort(compareFunctionSortOrder);
    }
    else {
        records.sort(compareFunctionParentId);
    }
    return records;
}

function sendValue(fromHtml, element, page, id) {
    var notification = {
        id: id,
        machineId: _machineId,
        page: page,
        site: _site,
        time: new Date().getTime(),
        username: _username,
        value: element.value,
    };
    if (fromHtml && notification.value !== "9") {
        $("#AllTextarea").hide();
        document.getElementById('AllTextarea').value = '';
        $.post(_apiUrl, notification)
            .done(function (msg) {
                console.log("Posted value of " + notification.value + " for " + id + " on page " + page + " " + msg);
                if (!_connectionHubStartDone) {
                    console.warn("Error data not sent!");
                }
                else {
                    if (_chat.connection.lastError != undefined)
                        console.warn("Last Error:\r\n\r\n" + _chat.connection.lastError);
                    _chat.server.notifyAll(notification)
                        .done(function () {
                            console.log("Posted value of " + notification.value + " for " + id + " on page " + page);
                        })
                        .fail(function (errorThrown) {
                            if (errorThrown == undefined || errorThrown.message == undefined || errorThrown.stack == undefined) {
                                console.warn("Error posting!");
                            }
                            else {
                                console.warn(errorThrown.message + "\r\n\r\n" + errorThrown.stack);
                            }
                        });
                }
            })
            .fail(function (_, textStatus, _) {
                console.warn(textStatus);
            });
    }
}

function setRecords(fromHtml, b, r, t, c, e, w, workItems) {
    var record;
    var lineA = "";
    var lineB = "";
    var lineC = "";
    var text = 'Id\tRisk Reduction and/or Opportunity Enablement\tTime Criticality\tBusiness Value\tCoD\tEffort\tWSJF\tState\tPriority\tRequester\tAssigned To\tSystem\r\n';
    var html = '<tr><th>Parent Id</th><th>Parent Title</th><th>Id</th><th>Requester</th><th>Title</th><th>Assigned To</th><th>System(s)</th><th>State</th><th>Priority</th><th>Risk Reduction and/or Opportunity Enablement</th><th>Time Criticality</th><th>Business Value</th><th>Cost of Delay (CoD)</th><th>Effort</th><th>WSJF</th></tr>';
    for (var i = 0; i < workItems.length; i++) {
        record = workItems[i];
        text += record.Id + '\t' +
            record.RiskReductionMinusOpportunityEnablement + '\t' +
            record.TimeCriticality + '\t' +
            record.BusinessValue + '\t' +
            record.CoD + '\t' +
            record.Effort + '\t' +
            record.WeightedShortestJobFirst + '\t' +
            record.State.split('-')[0] + '\t' +
            record.Priority.split('-')[0] + '\t' +
            record.Requester + '\t' +
            record.AssignedTo + '\t' +
            record.Tags + '\r\n';
        lineA = '<tr id="tr' + record.Id + '"><td>' + '<a target="_blank" href="https://tfs.intra.infineon.com/tfs/FactoryIntegration/ART%20SPS/_workitems/edit/' + record.ParentId + '">' + record.ParentId + "</a>" +
            '</td><td>' + record.ParentTitle +
            '</td><td>' + '<a target="_blank" href="https://tfs.intra.infineon.com/tfs/FactoryIntegration/ART%20SPS/_workitems/edit/' + record.Id + '">' + record.Id + "</a>" +
            '</td><td>' + record.Requester +
            '</td><td>' + record.Title +
            '</td><td>' + record.AssignedTo +
            '</td><td>' + record.Tags +
            '</td><td>' + record.State +
            '</td><td>' + record.Priority +
            '</td><td><span id=' + r.page + record.Id + '>' + record.RiskReductionMinusOpportunityEnablementNotifications + '</span><br />' +
            '<select class="select" onchange="sendValue(' + fromHtml + ', this, \'' + r.page + '\', ' + record.Id + ')">' +
            '<option value="9">Unknown</option>' +
            '<option value="1">Highest (Most ' + r.description + ')</option>' +
            '<option value="2">High</option>' +
            '<option value="3">Medium</option>' +
            '<option value="4">Low</option>' +
            '<option value="5">Lowest</option>' +
            '</td><td><span id=' + t.page + record.Id + '>' + record.TimeCriticalityNotifications + '</span><br />' +
            '<select class="select" onchange="sendValue(' + fromHtml + ', this, \'' + t.page + '\', ' + record.Id + ')">' +
            '<option value="9">Unknown</option>' +
            '<option value="1">Highest (Most ' + t.description + ')</option>' +
            '<option value="2">High</option>' +
            '<option value="3">Medium</option>' +
            '<option value="4">Low</option>' +
            '<option value="5">Lowest</option>' +
            '</td><td><span id=' + b.page + record.Id + '>' + record.BusinessValueNotifications + '</span><br />' +
            '<select class="select" onchange="sendValue(' + fromHtml + ', this, \'' + b.page + '\', ' + record.Id + ')">' +
            '<option value="9">Unknown</option>' +
            '<option value="1">Highest (Most ' + b.description + ')</option>' +
            '<option value="2">High</option>' +
            '<option value="3">Medium</option>' +
            '<option value="4">Low</option>' +
            '<option value="5">Lowest</option>' +
            '</td><td><span id=' + c.page + record.Id + '>' + record.CoD + '</span>' +
            '</td><td><span id=' + e.page + record.Id + '>' + record.EffortNotifications + '</span><br />';
        if (!fromHtml || _windowLocationHRef.indexOf('=EFFORT') === -1) {
            lineB = '';
        }
        else {
            lineB = '<select class="select" onchange="sendValue(' + fromHtml + ', this, \'' + e.page + '\', ' + record.Id + ')">' +
                '<option value="9">Unknown</option>' +
                '<option value="1">Highest (Most ' + e.description + ')</option>' +
                '<option value="2">High</option>' +
                '<option value="3">Medium</option>' +
                '<option value="4">Low</option>' +
                '<option value="5">Lowest</option>';
        }
        lineC = '</td><td><span id=' + w.page + record.Id + '>' + record.WeightedShortestJobFirst + '</span>' +
            '</td></tr>';
        if (!fromHtml)
            console.log(text);
        html += lineA + lineB + lineC;
    }
    if (fromHtml) {
        document.getElementById('HeaderGrid').innerHTML = html.replaceAll('>null<', '>&nbsp;<');
        if (_windowLocationHRef.indexOf('=WSJF') === -1) {
            document.getElementById('AllTextarea').value = text.replaceAll('null', '').replaceAll('&nbsp;', '');
        }
        else {
            _toggle = !_toggle;
            $(".select").hide();
            $("#AllTextarea").hide();
        }
    }
}

function updateSite(c, w) {
    if (_windowLocationHRef.indexOf('=LEO') > -1) {
        _site = 'LEO';
        document.title = document.title.replace('Infineon', 'HiRel (Leominster)');
        document.getElementById('siteHeader').innerText = 'HiRel (Leominster)';
    }
    else if (_windowLocationHRef.indexOf('=MES') > -1) {
        _site = 'MES';
        document.title = document.title.replace('Infineon', 'Mesa');
        document.getElementById('siteHeader').innerText = 'Mesa';
    }
    else {
        _site = 'Infineon';
        document.title = document.title.replace('Infineon', 'Infineon');
        document.getElementById('siteHeader').innerText = 'Infineon';
    }
    if (_windowLocationHRef.indexOf('=WSJF') > -1) {
        document.getElementById('th-span').innerHTML = w.th + ' sorted by WSJF';
    }
    else if (_windowLocationHRef.indexOf('=LIVE') > -1) {
        document.getElementById('th-span').innerHTML = c.th + ' sorted by CoD';
    }
    else if (_windowLocationHRef.indexOf('=EFFORT') > -1) {
        document.getElementById('th-span').innerHTML = c.th + ' sorted by Parent Id';
    }
    else {
        document.getElementById('th-span').innerHTML = c.th + ' sorted by Parent Id';
    }
}

function setDocument(fromHtml, b, r, t, c, e, w, dataA, dataB) {
    var records = getRecords(b, r, t, c, e, w, dataA, dataB);
    console.log(dataA.length);
    if (dataA.length > 0)
        console.log(dataA[0]);
    setRecords(fromHtml, b, r, t, c, e, w, records);
    $("#toggle").click(function () {
        if (_toggle)
            $(".select").hide();
        else
            $(".select").show();
        _toggle = !_toggle;
        try {
            _chat.server.send("name", new Date().getTime().toString());
        } catch (error) {
            console.error(error);
        }
    });
}

function highlight(el, i) {
    el.before("<tr/>")
    el.prev()
        .width(el.width())
        .height(el.height())
        .css({
            "position": "absolute",
            "background-color": "#ffff99",
            "opacity": ".9"
        })
        .fadeOut(1000 * i);
}

function updateWorkItem(b, r, t, c, e, w, page, workItem) {
    console.log(workItem);
    var x = null;
    var aggregation = null;
    if (page === b.page) {
        x = b;
        aggregation = workItem.BusinessValue;
    }
    else if (page === r.page) {
        x = r;
        aggregation = workItem.RiskReductionOpportunityEnablement;
    }
    else if (page === t.page) {
        x = t;
        aggregation = workItem.TimeCriticality;
    }
    else if (page === e.page) {
        x = e;
        aggregation = workItem.Effort;
    }
    if (x == undefined)
        console.warn("Error with page!");
    else {
        $('#' + x.page + workItem.Id).text('!' + myRound(aggregation.FibonacciAverage, 100));
        if (workItem.WeightedShortestJobFirst != undefined) {
            $('#' + w.page + workItem.Id).text('!' + myRound(workItem.WeightedShortestJobFirst, 100));
        }
        if (workItem.CostOfDelay != undefined) {
            var element = $('#' + c.page + workItem.Id);
            element.text('!' + myRound(workItem.CostOfDelay, 100));
            if (_windowLocationHRef.indexOf('=LIVE') > -1) {
                if (workItem.SortBeforeId != undefined) {
                    var found = 0;
                    var row = element.parents("tr:first");
                    var next = row;
                    for (var i = 0; i < 150; i++) {
                        next = next.next();
                        if (next == undefined)
                            break;
                        if (next.attr('id') != 'tr' + workItem.SortBeforeId)
                            continue;
                        console.log("Moved " + i + " down");
                        row.insertAfter(next);
                        found = i;
                        break;
                    }
                    if (!found) {
                        var prev = row;
                        for (var i = 0; i < 150; i++) {
                            prev = prev.prev();
                            if (prev == undefined)
                                break;
                            if (prev.attr('id') != 'tr' + workItem.SortBeforeId)
                                continue;
                            console.log("Moved " + i + " up");
                            row.insertAfter(prev);
                            found = i;
                            break;
                        }
                    }
                    if (found != 0) {
                        highlight(row, found);
                    }
                    else {
                        console.log("Not found!");
                    }
                }
            }
        }
    }
};

function setupSignalR(b, r, t, c, e, w, signalRUrl) {
    $.connection.hub.logging = true;
    $.connection.hub.url = signalRUrl;
    _chat = $.connection.weightedShortestJobFirstHub;
    if (_chat == undefined || _chat.server == undefined) {
        console.warn('Error within handshake!');
    }
    else {
        _chat.client.updateWorkItem = function (page, workItem) {
            updateWorkItem(b, r, t, c, e, w, page, workItem);
        };
        // $.connection.hub.start({ transport: 'longPolling' })
        $.connection.hub.start()
            .done(function () {
                _connectionHubStartDone = true;
            })
            .fail(function (errorThrown) {
                _connectionHubStartDone = false;
                if (errorThrown == undefined || errorThrown.message == undefined || errorThrown.stack == undefined) {
                    console.warn("Error starting connection!");
                }
                else {
                    console.warn(errorThrown.message + "\r\n" + errorThrown.stack);
                }
            });
    }
}

function initIndex(fromHtml, username, machineId, windowLocationHRef, workItems, b, r, t, c, e, w, apiUrl, signalRUrl) {
    _apiUrl = apiUrl;
    _username = username;
    _machineId = machineId;
    _windowLocationHRef = windowLocationHRef;
    if (!fromHtml) {
        console.log(b);
        console.log(r);
        console.log(t);
        console.log(c);
        console.log("Done :)");
    }
    else {
        updateSite(c, w);
        setupSignalR(b, r, t, c, e, w, signalRUrl);
        $.getJSON(workItems.b, { _: new Date().getTime() }, function (dataB) {
            $.getJSON(workItems.a, { _: new Date().getTime() }, function (dataA) {
                setDocument(fromHtml, b, r, t, c, e, w, dataA, dataB);
            });
        });
    }
}

// #region Example

function getExampleDataA() {
    return [
        {
            "WorkItem": {
                "ActivatedDate": "2024-07-23T19:09:08.443Z",
                "AreaPath": "ART SPS\\LEO",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": 20,
                "ChangedDate": "2024-10-23T18:39:10.833Z",
                "ClosedDate": null,
                "CommentCount": 3,
                "CreatedDate": "2024-04-03T18:53:45.32Z",
                "Description": "<div>This feature is to implement the standard UWM solution in LEO with the ability to receive emaps from source wafer fab when shipments are made to Leominster.&nbsp; </div><div><br> </div><div><span style=\"display:inline !important;\">Supports adoption of target system standards.&nbsp; &nbsp;</span><br> </div><div><span style=\"display:inline !important;\"><br></span> </div>",
                "Effort": 26,
                "Id": 47093,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.1",
                "Parent": 109728,
                "Priority": 2,
                "Relations": [],
                "Requester": "Pagkaliwangan Angelo (PSS HiRel OP ENG)",
                "ResolvedDate": "2024-10-08T23:21:42.017Z",
                "Revision": 24,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Resolved",
                "Tags": "ART MSI PDM; ART OES MMS; UWM",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "UWM @ LEO - Setup",
                "Violation": null,
                "WeightedShortestJobFirst": 1,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-24T17:48:28.74Z",
                "AreaPath": "ART SPS\\LEO",
                "AssignedTo": "Phares Mike (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-24T17:48:28.74Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-09T18:24:44.023Z",
                "Description": "<div><div style=\"box-sizing:border-box;\">This feature is to implement the standard UWM solution in LEO with the ability to receive emaps from source wafer fab when shipments are made to Leominster.&nbsp; </div><div style=\"box-sizing:border-box;\"><span style=\"display:inline !important;\"><br></span> </div><div style=\"box-sizing:border-box;\"><span style=\"display:inline !important;\">Includes dependencies on other ART and IT OS.&nbsp;&nbsp;</span><br> </div><div style=\"box-sizing:border-box;\"><br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\"><span style=\"box-sizing:border-box;display:inline !important;\">Supports adoption of target system standards.&nbsp; &nbsp;</span> </div><br> </div>",
                "Effort": null,
                "Id": 109728,
                "IterationPath": "ART SPS",
                "Parent": null,
                "Priority": 2,
                "Relations": [],
                "Requester": "Pagkaliwangan Angelo (PSS HiRel OP ENG)",
                "ResolvedDate": null,
                "Revision": 12,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Active",
                "Tags": null,
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "UWM @LEO",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": 2304,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-08-09T19:19:32.167Z",
                "Description": "<div>Account for Extended/Multiple HOLD's </div><div><br> </div><div>Account for instances of extended hold or multiple hold's in FabTime. Currently only a single hold event is captured.<br> </div>Sharpens FabTime lot movement tracking by accounting for all HOLD possibilities. Impacts cycle time.",
                "Effort": 3987,
                "Id": 109733,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 3,
                "Relations": [],
                "Requester": "Fuentes Jessica (FE MES P OPR)",
                "ResolvedDate": null,
                "Revision": 22,
                "RiskReductionMinusOpportunityEnablement": 2304,
                "StartDate": null,
                "State": "New",
                "Tags": "FabTime; OI",
                "TargetDate": null,
                "TimeCriticality": 2607,
                "Title": "12 - Account for Extended/Multiple HOLD's",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": 2228,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-08-09T19:22:14.047Z",
                "Description": "<div>Missing check for supplier label at FQA when material has been converted to MU wafers&nbsp; </div><div><br> </div><div>From Matt: &quot;A situation occurred last week that highlighted a gap in our FQA label check scan of supplier labels/RDS labels for lots being converted to MUs. <br> </div>RDS#277820 failed the scan because the supplier lot# did not match our OI records. Don investigat",
                "Effort": 2987,
                "Id": 109734,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 2,
                "Relations": [],
                "Requester": "Fuentes Jessica (FE MES P OPR)",
                "ResolvedDate": null,
                "Revision": 23,
                "RiskReductionMinusOpportunityEnablement": 2228,
                "StartDate": null,
                "State": "New",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": 2531,
                "Title": "273 - Missing check for supplier label at FQA when material has been converted to MU wafers",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": 2152,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-08-09T19:28:24.18Z",
                "Description": "<div>Need ability to do PM on Cleans tools </div><div><br> </div><div>In response to ICO-20-34_DI Water Resin High Sodium_8D we need to setup an automatic flag for Cleans tools PM’s and believe that the Reactor PM structure would work good<br> </div>Would it be possible to take the Reactor PM section of which I have supplied screensh",
                "Effort": 2228,
                "Id": 109735,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 3,
                "Relations": [],
                "Requester": "Henderson Susan (FE MES FM)",
                "ResolvedDate": null,
                "Revision": 20,
                "RiskReductionMinusOpportunityEnablement": 2152,
                "StartDate": null,
                "State": "New",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": 2456,
                "Title": "433 - Need ability to do PM on Cleans tools",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": 2076,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-08-09T19:32:05.113Z",
                "Description": "<div>Need small interface for the user to edit the Cleaner - Carrier IDs </div><div><br> </div><div>Also, I would like to address an issue that occurs every time a carrier gets pulled when it’s bad/damaged. When this occurs it generally takes a while to get the “NEW” carrier ID in the OI system and to have the actual carrier tags created by facilities.<br> </div>",
                "Effort": 3911,
                "Id": 109736,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 2,
                "Relations": [],
                "Requester": "Holland Justin (FE MES P OPR SH C)",
                "ResolvedDate": null,
                "Revision": 24,
                "RiskReductionMinusOpportunityEnablement": 2076,
                "StartDate": null,
                "State": "New",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": 2380,
                "Title": "440 - Need small interface for the user to edit the Cleaner - Carrier IDs",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Tucker Chase (CSC FI SPS MESLEO)",
                "BusinessValue": 2000,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-08-09T19:36:25.713Z",
                "Description": "Ensure pre-clean signature is present before allowing Load via Mobile Scanner<br>&nbsp;<br>When an RDS is getting created, a flag shall be set to indicate that a Pre-Clean is required.  Unfortunately, that flag did not get set as expected.<br><br>The user used the bar code scanner for the VER &amp; LOAD and both signatures got saved without the Pre-Clean",
                "Effort": 1304,
                "Id": 109737,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 2,
                "Relations": [],
                "Requester": "Holland Justin (FE MES P OPR SH C)",
                "ResolvedDate": null,
                "Revision": 21,
                "RiskReductionMinusOpportunityEnablement": 2000,
                "StartDate": null,
                "State": "New",
                "Tags": "OI; Smart Scanner",
                "TargetDate": null,
                "TimeCriticality": 2304,
                "Title": "497 - Ensure pre-clean signature is present before allowing Load via Mobile Scanner",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-09-12T22:49:38.823Z",
                "AreaPath": "ART SPS\\LEO",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-24T17:20:25.48Z",
                "ClosedDate": "2024-10-23T22:52:15.493Z",
                "CommentCount": 0,
                "CreatedDate": "2024-08-13T22:10:29.843Z",
                "Description": "<div><div style=\"box-sizing:border-box;\">Umbrella Epic to capture demand on capacity for Operations support including; admin tasks, user setup, issues and incidents, routine updates/upgrades, systems monitoring, vendor engagement, production meetings, on-call support.&nbsp; </div><div style=\"box-sizing:border-box;\"><br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\">Breakdown of activities is not required. </div><br> </div>",
                "Effort": null,
                "Id": 110437,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.4",
                "Parent": 109725,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": "2024-10-23T22:52:15.493Z",
                "Revision": 9,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-07-31T22:00:00Z",
                "State": "Closed",
                "Tags": "OSF",
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": 1,
                "Title": "LEO Operations Support PI3",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:08:34.2Z",
                "AreaPath": "ART SPS\\LEO",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-07T17:08:34.2Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-09T18:01:23.153Z",
                "Description": "<div><div style=\"box-sizing:border-box;\">Umbrella Epic to capture demand on capacity for Operations support including; admin tasks, user setup, issues and incidents, routine updates/upgrades, systems monitoring, vendor engagement, production meetings, on-call support.&nbsp; </div><div style=\"box-sizing:border-box;\"><br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\">Breakdown of activities is not required. </div><br> </div>",
                "Effort": null,
                "Id": 109725,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 8,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "LEO Operations Support",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-08-14T20:19:29.277Z",
                "AreaPath": "ART SPS\\LEO",
                "AssignedTo": "Belasco Bradd (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-12-17T08:13:04.197Z",
                "ClosedDate": "2024-12-17T08:13:04.197Z",
                "CommentCount": 1,
                "CreatedDate": "2024-08-13T22:24:16.36Z",
                "Description": "<div>upgrade the OS and application on a PoC server in the IFX network while release on EC is pending </div>",
                "Effort": null,
                "Id": 110438,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.2",
                "Parent": 109726,
                "Priority": 2,
                "Relations": [],
                "Requester": "Pagkaliwangan Angelo (PSS HiRel OP ENG)",
                "ResolvedDate": "2024-12-17T08:13:04.197Z",
                "Revision": 14,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-07-10T22:00:00Z",
                "State": "Closed",
                "Tags": "YieldHUB",
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "YieldHub RHEL9 upgrade - PoC",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2024-08-09T18:10:38.49Z",
                "AreaPath": "ART SPS\\LEO",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-07T17:08:47.7Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-09T18:10:30.717Z",
                "Description": "<div><div style=\"box-sizing:border-box;\">Umbrella Epic to capture demand on capacity and visibility of efforts required by IT OS or FI Process Framework.&nbsp;<br> </div><div style=\"box-sizing:border-box;\"><br> </div><div style=\"box-sizing:border-box;\">Examples are: Stealth migration, Win 206 OS upgrade, RHEL upgrade, Creation of UA Orderables, Establishing Service Products and the support processes.&nbsp; </div><div style=\"box-sizing:border-box;\"><br> </div><div style=\"box-sizing:border-box;\">Features should be created for specific topics.&nbsp; </div><br> </div>",
                "Effort": null,
                "Id": 109726,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 2,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 9,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "LEO Compliance",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-10-10T12:01:00.053Z",
                "AreaPath": "ART SPS\\LEO",
                "AssignedTo": "Belasco Bradd (CSC FI SPS MESLEO)",
                "BusinessValue": 4,
                "ChangedDate": "2024-10-29T01:05:04.443Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-08-13T22:34:01.67Z",
                "Description": "<div>Implement the RHEL 9 OS and YieldHUB upgrade on the EC network and successfully complete all unit and user testing scenarios.&nbsp; When finished we should be ready to schedule the go-live </div><div><br> </div>",
                "Effort": 2,
                "Id": 110439,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": 109726,
                "Priority": 2,
                "Relations": [],
                "Requester": "Pagkaliwangan Angelo (PSS HiRel OP ENG)",
                "ResolvedDate": null,
                "Revision": 19,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-10-27T23:00:00Z",
                "State": "Active",
                "Tags": "YieldHUB",
                "TargetDate": "2025-01-16T23:00:00Z",
                "TimeCriticality": 6,
                "Title": "YieldHub RHEL 9 upgrade - Production Install and Buyoff",
                "Violation": null,
                "WeightedShortestJobFirst": 5,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2024-08-09T18:10:38.49Z",
                "AreaPath": "ART SPS\\LEO",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-07T17:08:47.7Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-09T18:10:30.717Z",
                "Description": "<div><div style=\"box-sizing:border-box;\">Umbrella Epic to capture demand on capacity and visibility of efforts required by IT OS or FI Process Framework.&nbsp;<br> </div><div style=\"box-sizing:border-box;\"><br> </div><div style=\"box-sizing:border-box;\">Examples are: Stealth migration, Win 206 OS upgrade, RHEL upgrade, Creation of UA Orderables, Establishing Service Products and the support processes.&nbsp; </div><div style=\"box-sizing:border-box;\"><br> </div><div style=\"box-sizing:border-box;\">Features should be created for specific topics.&nbsp; </div><br> </div>",
                "Effort": null,
                "Id": 109726,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 2,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 9,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "LEO Compliance",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-08-14T22:34:39.08Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": 11200,
                "ChangedDate": "2025-01-24T17:16:34.84Z",
                "ClosedDate": "2024-10-24T04:18:20.1Z",
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:34:27.607Z",
                "Description": "<div><div style=\"box-sizing:border-box;\">Umbrella Epic to capture demand on capacity for Operations support including; admin tasks, user setup, issues and incidents, routine updates/upgrades, systems monitoring, vendor engagement, production meetings, on-call support.&nbsp; </div><div style=\"box-sizing:border-box;\"><br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\">Breakdown of activities is not required. </div><br><br> </div>",
                "Effort": 19700,
                "Id": 110732,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.4",
                "Parent": 110730,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": "2024-10-24T04:18:20.1Z",
                "Revision": 19,
                "RiskReductionMinusOpportunityEnablement": 11200,
                "StartDate": null,
                "State": "Closed",
                "Tags": "Mesa; OI",
                "TargetDate": null,
                "TimeCriticality": 11800,
                "Title": "MES Operations Support PI3",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2024-08-14T22:26:48.44Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-07T17:05:52.08Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:26:41.517Z",
                "Description": "<div><div style=\"box-sizing:border-box;\">Umbrella Epic to capture demand on capacity for Operations support including; admin tasks, user setup, issues and incidents, routine updates/upgrades, systems monitoring, vendor engagement, production meetings, on-call support.&nbsp; </div><div style=\"box-sizing:border-box;\"><br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\">Breakdown of activities is not required. </div><br> </div>",
                "Effort": null,
                "Id": 110730,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 10,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Operations Support",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Tucker Chase (CSC FI SPS MESLEO)",
                "BusinessValue": 13076,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:21:59.927Z",
                "Description": "Create a service to allow multiple PSN&nbsp;to be updated with new thickness and resistivity values by the mean of a template or check box list<br>&nbsp;<br>ensure service updates both PSN tables in OI ",
                "Effort": 8152,
                "Id": 110737,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 2,
                "Relations": [],
                "Requester": "Cousten Mark (FE MES P UPE)",
                "ResolvedDate": null,
                "Revision": 16,
                "RiskReductionMinusOpportunityEnablement": 13000,
                "StartDate": null,
                "State": "New",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": 8835,
                "Title": "503 - Create a service to allow multiple PSN to be updated with new thickness and resistivity values by the mean of a template",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": 8228,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:22:54.597Z",
                "Description": "Do not allow wafers to move to the outbound box unless the RDS has been closed (same as GaN) - need business process change approval<br>&nbsp;<br>We have collectively had an issue for a while with Epi-Pro WMO’s at FQA. There are times when the operators have something that isn’t properly signed out (typically ROTR results) but they are still able to sign out the post epi section.  The end result is",
                "Effort": 3835,
                "Id": 110738,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 2,
                "Relations": [],
                "Requester": "Holland Justin (FE MES P OPR SH C)",
                "ResolvedDate": null,
                "Revision": 19,
                "RiskReductionMinusOpportunityEnablement": 8228,
                "StartDate": null,
                "State": "New",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": 2759,
                "Title": "507 - Do not allow wafers to move to the outbound box unless the RDS has been closed (same as GaN) - need business process chan",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Tucker Chase (CSC FI SPS MESLEO)",
                "BusinessValue": 20380,
                "ChangedDate": "2025-01-23T21:15:51.727Z",
                "ClosedDate": "2025-01-23T21:15:51.727Z",
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:24:03.567Z",
                "Description": null,
                "Effort": 1228,
                "Id": 110740,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": 110729,
                "Priority": 1,
                "Relations": [],
                "Requester": "McIntyre Juanita (FE MES QM)",
                "ResolvedDate": "2025-01-23T21:15:51.727Z",
                "Revision": 31,
                "RiskReductionMinusOpportunityEnablement": 20456,
                "StartDate": null,
                "State": "Closed",
                "Tags": "Fab Approval",
                "TargetDate": null,
                "TimeCriticality": 20456,
                "Title": "545 - Set up Change Control (PCRB) and MRB Modules",
                "Violation": null,
                "WeightedShortestJobFirst": 14,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": 1911,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:30:53.227Z",
                "Description": null,
                "Effort": 13000,
                "Id": 110741,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 2,
                "Relations": [],
                "Requester": "Henderson Susan (FE MES FM)",
                "ResolvedDate": null,
                "Revision": 18,
                "RiskReductionMinusOpportunityEnablement": 1911,
                "StartDate": null,
                "State": "New",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": 2152,
                "Title": "597 - Automate Category selection for Reactor State Change Over (S) based on PSN of prev/next lot",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": 1835,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:34:26.37Z",
                "Description": "Equip State tracking overhaul in OI and rebuild mapping in FabTime - Non Reactor <br>&nbsp;<br>Align with Todd C, Peyton C and Mark C on the requirements<br>",
                "Effort": 20076,
                "Id": 110742,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 2,
                "Relations": [],
                "Requester": "Cousten Mark (FE MES P UPE)",
                "ResolvedDate": null,
                "Revision": 19,
                "RiskReductionMinusOpportunityEnablement": 1835,
                "StartDate": null,
                "State": "New",
                "Tags": "FabTime; OI",
                "TargetDate": null,
                "TimeCriticality": 2076,
                "Title": "610 - Equip State tracking overhaul in OI and rebuild mapping in FabTime - Non Reactor",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": 1759,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:34:30.39Z",
                "Description": "Methodically test OI forms for fields lacking data validations; e.g. Unload Qty, Unload Date/Time<br>&nbsp;<br>6/9/24 - keep per Justin<br>OI doesn't always validate data entry, allowing bad dates/qtys/etc to be recorded. ",
                "Effort": 20380,
                "Id": 110743,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 2,
                "Relations": [],
                "Requester": "Holland Justin (FE MES P OPR SH C)",
                "ResolvedDate": null,
                "Revision": 18,
                "RiskReductionMinusOpportunityEnablement": 1759,
                "StartDate": null,
                "State": "New",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": 2000,
                "Title": "636 - Methodically test OI forms for fields lacking data validations; e.g. Unload Qty, Unload Date/Time",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": 1683,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:34:35.03Z",
                "Description": "Modify OI to allow generic login and validate user based on badge scan at time of transaction.  This is consistent with other sites.  The feasibility/risk needs to be validated with assistance from SRP<br>&nbsp;<br>OI User Access requiring Operator (all staff) to logon to the client with their netwotk credentials is inefficient and drives the &quot;workaround&quot; of using the OI thick client as a second session. ",
                "Effort": 20456,
                "Id": 110744,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 2,
                "Relations": [],
                "Requester": "Fuentes Jessica (FE MES P OPR)",
                "ResolvedDate": null,
                "Revision": 18,
                "RiskReductionMinusOpportunityEnablement": 1683,
                "StartDate": null,
                "State": "New",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": 1987,
                "Title": "637 - Modify OI to allow generic login and validate user based on badge scan at time of transaction.  This is consistent with o",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Tucker Chase (CSC FI SPS MESLEO)",
                "BusinessValue": 1607,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:34:38.25Z",
                "Description": "Export to PDF and Print from New SSR Report<br>&nbsp;<br>Create a method to export the data table to PDF",
                "Effort": 3152,
                "Id": 110745,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 2,
                "Relations": [],
                "Requester": "Becker Chad (FE MES QM)",
                "ResolvedDate": null,
                "Revision": 17,
                "RiskReductionMinusOpportunityEnablement": 1607,
                "StartDate": null,
                "State": "New",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": 1911,
                "Title": "681 - Export to PDF and Print from New SSR Report",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": 1531,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:34:41.797Z",
                "Description": "Create metrology import routines for SPV, for post PM qualification (for daily verifications)<br>&nbsp;<br>To facilitate verification monitoring of SPV tool.",
                "Effort": 5683,
                "Id": 110746,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 2,
                "Relations": [],
                "Requester": "McChesney Peyton (FE MES P UPE)",
                "ResolvedDate": null,
                "Revision": 20,
                "RiskReductionMinusOpportunityEnablement": 1531,
                "StartDate": null,
                "State": "New",
                "Tags": "EAF; IQS; OI",
                "TargetDate": null,
                "TimeCriticality": 1835,
                "Title": "698 - Create metrology import routines for SPV, for post PM qualification (for daily verifications)",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": 1456,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:34:45.297Z",
                "Description": "Update Metrology Limits function doesn't account reactor based metrology frequency<br>&nbsp;<br>Function was built for 1 WO, on 1 Reactor functionality whereas the frequency for Res. Testing frequency needs to based on the run no per reactor",
                "Effort": 8987,
                "Id": 110747,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 2,
                "Relations": [],
                "Requester": "Clark Kelly (FE MES P UPE SH)",
                "ResolvedDate": null,
                "Revision": 19,
                "RiskReductionMinusOpportunityEnablement": 1456,
                "StartDate": null,
                "State": "New",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": 1759,
                "Title": "706 - Update Metrology Limits function doesn't account reactor based metrology frequency",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Tucker Chase (CSC FI SPS MESLEO)",
                "BusinessValue": 1380,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:35:55.097Z",
                "Description": "Batch recipe update for queued lots<br>&nbsp;<br>Utilizing existing functionality to update single lot recipe parameters from PSN, create a batch selection and update function",
                "Effort": 2911,
                "Id": 110748,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 2,
                "Relations": [],
                "Requester": "Cousten Mark (FE MES P UPE)",
                "ResolvedDate": null,
                "Revision": 16,
                "RiskReductionMinusOpportunityEnablement": 1380,
                "StartDate": null,
                "State": "New",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": 1683,
                "Title": "710 - Batch recipe update for queued lots",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": 1304,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:35:56.473Z",
                "Description": "Make available non-ec data from OI to E2<br>&nbsp;<br>replacement for EBS project",
                "Effort": 13683,
                "Id": 110749,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 2,
                "Relations": [],
                "Requester": "Becker Chad (FE MES QM)",
                "ResolvedDate": null,
                "Revision": 17,
                "RiskReductionMinusOpportunityEnablement": 1304,
                "StartDate": null,
                "State": "New",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": 1607,
                "Title": "711 - Make available non-ec data from OI to E2",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": 1228,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:35:57.477Z",
                "Description": "Create a new tool mode to indicate that a tool is ready to be used, but not being used by production<br>&nbsp;<br>There are tools, such as the BAGGERS(lot packaging tools) that would be physically removed from production, repaired, then left undeployed until needed. The request is to have a mode for non-reactor equipment that would indicate a tool has been repaired, ",
                "Effort": 1835,
                "Id": 110750,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 2,
                "Relations": [],
                "Requester": "Henderson Susan (FE MES FM)",
                "ResolvedDate": null,
                "Revision": 19,
                "RiskReductionMinusOpportunityEnablement": 1228,
                "StartDate": null,
                "State": "New",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": 1531,
                "Title": "714 - Create a new tool mode to indicate that a tool is ready to be used, but not being used by production",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": 1152,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:35:58.56Z",
                "Description": "Automate the operator passdown<br>&nbsp;<br>A lot of information on the operator passdown is information that has to be retyped, but can easily be brought into the passdown automatically like the daily passdown.",
                "Effort": 3304,
                "Id": 110751,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 1,
                "Relations": [],
                "Requester": "Holland Justin (FE MES P OPR SH C)",
                "ResolvedDate": null,
                "Revision": 25,
                "RiskReductionMinusOpportunityEnablement": 1152,
                "StartDate": null,
                "State": "New",
                "Tags": "Mesa Reporting Services; OI",
                "TargetDate": "2024-02-26T19:00:00Z",
                "TimeCriticality": 1456,
                "Title": "716 - Automate the operator passdown",
                "Violation": null,
                "WeightedShortestJobFirst": 1,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-08-14T23:43:55.527Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-13T16:08:23.073Z",
                "ClosedDate": "2024-10-02T22:31:27.37Z",
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:43:35.2Z",
                "Description": "<div>complete upgrade plan including&nbsp; </div><div><ul><li>which servers, who responsible </li> </ul> </div><div><ul><li>IPU or traditional upgrade&nbsp; </li> </ul> </div><div><ul><li>dependencies and timing </li> </ul> </div>",
                "Effort": null,
                "Id": 110753,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.4",
                "Parent": 110752,
                "Priority": 3,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": "2024-10-02T22:31:27.37Z",
                "Revision": 10,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "Windows",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Windows 2016 upgrade - planning",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2024-09-12T22:55:00.607Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-07T17:06:05.113Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T23:41:08.26Z",
                "Description": "<div>Identify, plan, test and implement server upgrades to 2022 as mandated by IT OS </div>",
                "Effort": null,
                "Id": 110752,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 3,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 8,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-01T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2025-12-18T23:00:00Z",
                "TimeCriticality": null,
                "Title": "Windows 2016 upgrade",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2025-01-23T22:27:29.79Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Tucker Chase (CSC FI SPS MESLEO)",
                "BusinessValue": 1076,
                "ChangedDate": "2025-01-23T22:27:29.79Z",
                "ClosedDate": "2025-01-23T22:27:29.79Z",
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:46:15.407Z",
                "Description": "Add in additional filtering to the OI Wizard Status screen<br>&nbsp;<br>filter by reactor type, status, etc",
                "Effort": 2759,
                "Id": 110754,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": 110729,
                "Priority": 1,
                "Relations": [],
                "Requester": "Henderson Susan (FE MES FM)",
                "ResolvedDate": "2025-01-23T22:27:29.79Z",
                "Revision": 26,
                "RiskReductionMinusOpportunityEnablement": 1076,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI Web Services",
                "TargetDate": "2024-03-01T19:00:00Z",
                "TimeCriticality": 1380,
                "Title": "723 - Add in additional filtering to the OI Wizard Status screen",
                "Violation": null,
                "WeightedShortestJobFirst": 1,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Tucker Chase (CSC FI SPS MESLEO)",
                "BusinessValue": 13683,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:46:16.797Z",
                "Description": null,
                "Effort": 5456,
                "Id": 110755,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 2,
                "Relations": [],
                "Requester": "Henderson Susan (FE MES FM)",
                "ResolvedDate": null,
                "Revision": 16,
                "RiskReductionMinusOpportunityEnablement": 8987,
                "StartDate": null,
                "State": "New",
                "Tags": "Mesa Reporting Services",
                "TargetDate": null,
                "TimeCriticality": 13531,
                "Title": "727 - Tool Uptime Report",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Tucker Chase (CSC FI SPS MESLEO)",
                "BusinessValue": 2683,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:46:18.157Z",
                "Description": "Automate Maintenance Passdown<br>&nbsp;<br>input on the passdown comes from and includes comments/state changes made in OI.  Passdown is a option to add comments",
                "Effort": 5607,
                "Id": 110756,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 2,
                "Relations": [],
                "Requester": "Henderson Susan (FE MES FM)",
                "ResolvedDate": null,
                "Revision": 16,
                "RiskReductionMinusOpportunityEnablement": 2683,
                "StartDate": null,
                "State": "New",
                "Tags": "Mesa Reporting Services",
                "TargetDate": null,
                "TimeCriticality": 2683,
                "Title": "728 - Automate Maintenance Passdown",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": 2607,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:46:19.39Z",
                "Description": "Require and log overrides for ALL users for manual data entry at all metrology entry steps<br>&nbsp;<br>Currently at unload metrology overrides are only required for users not designated as an operator. If the user is designated as a Lead, supervisor, or engineer the data can be manually entered without logging an override. We can change the code to prompt ",
                "Effort": 8911,
                "Id": 110757,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 2,
                "Relations": [],
                "Requester": "Fuentes Jessica (FE MES P OPR)",
                "ResolvedDate": null,
                "Revision": 17,
                "RiskReductionMinusOpportunityEnablement": 2607,
                "StartDate": null,
                "State": "New",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": 8759,
                "Title": "730 - Require and log overrides for ALL users for manual data entry at all metrology entry steps",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": 2531,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:46:20.757Z",
                "Description": "Tool Verification Completion Report<br>&nbsp;<br>Give users the ability to look up completed verifications per tool set within a period of time.",
                "Effort": 3759,
                "Id": 110758,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 2,
                "Relations": [],
                "Requester": "McChesney Peyton (FE MES P UPE)",
                "ResolvedDate": null,
                "Revision": 18,
                "RiskReductionMinusOpportunityEnablement": 2531,
                "StartDate": null,
                "State": "New",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": 3304,
                "Title": "735 - Tool Verification Completion Report",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": 2456,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:46:21.947Z",
                "Description": "Simplify logging of calibration and verifications into one UI.<br>&nbsp;<br>Request is to not have to go to two different locations to sign off verifications and calibrations. The request is specifically for the SPV but it would make more sense to do this for all non-reactors. Possibly take the concept of the reactor status form ",
                "Effort": 5380,
                "Id": 110759,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 2,
                "Relations": [],
                "Requester": "McChesney Peyton (FE MES P UPE)",
                "ResolvedDate": null,
                "Revision": 19,
                "RiskReductionMinusOpportunityEnablement": 2456,
                "StartDate": null,
                "State": "New",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": 3228,
                "Title": "736 - Simplify logging of calibration and verifications into one UI.",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Phares Mike (CSC FI SPS MESLEO)",
                "BusinessValue": 2380,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:46:23.037Z",
                "Description": "Data collection for Film Sense without SECS/GEM<br>&nbsp;<br>Setup Film Sense CEP and collect data from CEP Web UI",
                "Effort": 20000,
                "Id": 110760,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 2,
                "Relations": [],
                "Requester": "McChesney Peyton (FE MES P UPE)",
                "ResolvedDate": null,
                "Revision": 17,
                "RiskReductionMinusOpportunityEnablement": 2380,
                "StartDate": null,
                "State": "New",
                "Tags": "EAF",
                "TargetDate": null,
                "TimeCriticality": 3152,
                "Title": "737 - Data collection for Film Sense without SECS/GEM",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-10-17T17:13:34.323Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Tucker Chase (CSC FI SPS MESLEO)",
                "BusinessValue": 17300,
                "ChangedDate": "2024-10-25T18:16:19.73Z",
                "ClosedDate": "2024-10-25T18:16:19.73Z",
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:46:23.98Z",
                "Description": "Eliminate the seconds to minutes conversion in the Recipe form for the Bake Time and Etch Time parameters<br>&nbsp;<br>Production department would like to standardize these parameters to seconds(decimal values) so everything will read similar",
                "Effort": 10500,
                "Id": 110761,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.4",
                "Parent": 110729,
                "Priority": 1,
                "Relations": [],
                "Requester": "Clark Kelly (FE MES P UPE SH)",
                "ResolvedDate": "2024-10-25T18:16:19.73Z",
                "Revision": 19,
                "RiskReductionMinusOpportunityEnablement": 16300,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": "2024-03-08T19:00:00Z",
                "TimeCriticality": 17000,
                "Title": "738 - Eliminate the seconds to minutes conversion in the Recipe form for the Bake Time and Etch Time parameters",
                "Violation": null,
                "WeightedShortestJobFirst": 676,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Tucker Chase (CSC FI SPS MESLEO)",
                "BusinessValue": 3000,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:46:24.97Z",
                "Description": "Add a loading icon to ECN popup submit<br>&nbsp;<br>There are some location where forms are submitted that would benefit from a loading icon to inform the user that background processes are occuring",
                "Effort": 5531,
                "Id": 110762,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 2,
                "Relations": [],
                "Requester": "McIntyre Juanita (FE MES QM)",
                "ResolvedDate": null,
                "Revision": 17,
                "RiskReductionMinusOpportunityEnablement": 3000,
                "StartDate": null,
                "State": "New",
                "Tags": "Fab Approval",
                "TargetDate": null,
                "TimeCriticality": 3000,
                "Title": "747 - Add a loading icon to ECN popup submit",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-21T21:05:39.223Z",
                "ClosedDate": "2024-09-20T00:37:10.45Z",
                "CommentCount": 2,
                "CreatedDate": "2024-08-14T23:46:25.927Z",
                "Description": "Improper Full box reject logic - EPP<br>&nbsp;<br>Cassette logged 3 prod wafer test usage and 23 scrap. Prod wafer test usage is considered product scrap. OI saw 26 wafers scrapped and auto-rejected the box. Box actually had 2 good wafers in it and was in fact not a whole box reject.",
                "Effort": 3,
                "Id": 110763,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 110729,
                "Priority": 1,
                "Relations": [],
                "Requester": "Holland Justin (FE MES P OPR SH C)",
                "ResolvedDate": "2024-09-20T00:37:10.45Z",
                "Revision": 13,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-09-13T01:25:30Z",
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": "2024-09-20T00:37:00Z",
                "TimeCriticality": 2,
                "Title": "754 - Improper Full box reject logic - EPP",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Tucker Chase (CSC FI SPS MESLEO)",
                "BusinessValue": 2987,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:46:27.3Z",
                "Description": "Allow corrective action approvals to be reassigned<br>&nbsp;<br>Give administrators the ability to reassign the designated approver for corrective actions. And ensure this prevents lock out.",
                "Effort": 8531,
                "Id": 110764,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 2,
                "Relations": [],
                "Requester": "McIntyre Juanita (FE MES QM)",
                "ResolvedDate": null,
                "Revision": 17,
                "RiskReductionMinusOpportunityEnablement": 2987,
                "StartDate": null,
                "State": "New",
                "Tags": "Fab Approval",
                "TargetDate": null,
                "TimeCriticality": 2987,
                "Title": "767 - Allow corrective action approvals to be reassigned",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Tucker Chase (CSC FI SPS MESLEO)",
                "BusinessValue": 2911,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:46:28.183Z",
                "Description": "D5/D6/D7 Validation needs approve/reject buttons like other steps<br>&nbsp;<br>The D5/D6/D7 validation section currently works in two parts. First the check box is toggled by an approved user, then after a page refresh the approve reject buttons appear. Other sections have the check box for information purposes only. The approval is",
                "Effort": 8759,
                "Id": 110765,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 2,
                "Relations": [],
                "Requester": "McIntyre Juanita (FE MES QM)",
                "ResolvedDate": null,
                "Revision": 17,
                "RiskReductionMinusOpportunityEnablement": 2911,
                "StartDate": null,
                "State": "New",
                "Tags": "Fab Approval",
                "TargetDate": null,
                "TimeCriticality": 2911,
                "Title": "768 - D5/D6/D7 Validation needs approve/reject buttons like other steps",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Phares Mike (CSC FI SPS MESLEO)",
                "BusinessValue": 2835,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:46:29.167Z",
                "Description": null,
                "Effort": 13987,
                "Id": 110766,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 2,
                "Relations": [],
                "Requester": "Carrier Todd (FE MES P UPE)",
                "ResolvedDate": null,
                "Revision": 18,
                "RiskReductionMinusOpportunityEnablement": 2835,
                "StartDate": null,
                "State": "New",
                "Tags": "EAF; IQS",
                "TargetDate": null,
                "TimeCriticality": 2835,
                "Title": "771 - Change SRP data collection to use two measurements to calculate averages per curve section",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2025-01-16T19:48:42.677Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": 2759,
                "ChangedDate": "2025-01-16T19:48:42.677Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:46:30.22Z",
                "Description": null,
                "Effort": 3683,
                "Id": 110767,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": 110729,
                "Priority": 1,
                "Relations": [],
                "Requester": "Holland Justin (FE MES P OPR SH C)",
                "ResolvedDate": null,
                "Revision": 28,
                "RiskReductionMinusOpportunityEnablement": 2759,
                "StartDate": null,
                "State": "Active",
                "Tags": "OI Web Services",
                "TargetDate": null,
                "TimeCriticality": 8683,
                "Title": "772 - add sort and filter options to Material Track report in Web Services.  Ensure in good printable form",
                "Violation": null,
                "WeightedShortestJobFirst": 2,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": 8152,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:46:32.89Z",
                "Description": null,
                "Effort": 8683,
                "Id": 110768,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 1,
                "Relations": [],
                "Requester": "McIntyre Juanita (FE MES QM)",
                "ResolvedDate": null,
                "Revision": 22,
                "RiskReductionMinusOpportunityEnablement": 8152,
                "StartDate": "2024-05-02T07:00:00Z",
                "State": "New",
                "Tags": "Fab Approval",
                "TargetDate": "2024-03-25T19:00:00Z",
                "TimeCriticality": 8607,
                "Title": "775 - Automatically adjust D5/D6/D7 Due Date to latest action item ECD. Also adjust D5/D6/D7 validation due date to two weeks after the last action item",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": 3076,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:46:33.85Z",
                "Description": null,
                "Effort": 3607,
                "Id": 110769,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 2,
                "Relations": [],
                "Requester": "Fuentes Jessica (FE MES P OPR)",
                "ResolvedDate": null,
                "Revision": 17,
                "RiskReductionMinusOpportunityEnablement": 3076,
                "StartDate": null,
                "State": "New",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": 3987,
                "Title": "776 - Move FQA Packaging Challenge calibration to the new PM system so that email notifications are sent regardless if a user i",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2025-01-16T14:31:49.963Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Phares Mike (CSC FI SPS MESLEO)",
                "BusinessValue": 8000,
                "ChangedDate": "2025-01-21T16:02:59.463Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:46:36.26Z",
                "Description": "<div>Add &quot;CA Standard Type&quot; field in Corrective Action (CA) module. Possible selections: IATF16949, ISO14001, ISO45001<br> </div>&nbsp;<br>Create field in DB, add validation on CA creation, allow modification by Requestor",
                "Effort": 3531,
                "Id": 110770,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": 110729,
                "Priority": 1,
                "Relations": [],
                "Requester": "McIntyre Juanita (FE MES QM)",
                "ResolvedDate": "2025-01-16T14:31:49.963Z",
                "Revision": 26,
                "RiskReductionMinusOpportunityEnablement": 8000,
                "StartDate": null,
                "State": "Resolved",
                "Tags": "Fab Approval",
                "TargetDate": "2024-08-30T19:00:00Z",
                "TimeCriticality": 3911,
                "Title": "780 - Add \"CA Standard Type\" field in Corrective Action (CA) module. Possible selections: IATF16949, ISO14001, ISO45001",
                "Violation": null,
                "WeightedShortestJobFirst": 1,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Tucker Chase (CSC FI SPS MESLEO)",
                "BusinessValue": 3607,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T23:46:37.083Z",
                "Description": "Manually executing ECN training does not clear previous groups<br>&nbsp;<br>When an administrator manually executes an ECN training, they are shown a list of the groups currently included in the training. If they clear this list and add new groups, the previous groups are still included in the new training assignment. ",
                "Effort": 8607,
                "Id": 110771,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 2,
                "Relations": [],
                "Requester": "McIntyre Juanita (FE MES QM)",
                "ResolvedDate": null,
                "Revision": 16,
                "RiskReductionMinusOpportunityEnablement": 3683,
                "StartDate": null,
                "State": "New",
                "Tags": "Fab Approval",
                "TargetDate": null,
                "TimeCriticality": 3835,
                "Title": "783 - Manually executing ECN training does not clear previous groups",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": 3531,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:46:37.873Z",
                "Description": null,
                "Effort": 8456,
                "Id": 110772,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 2,
                "Relations": [],
                "Requester": "McIntyre Juanita (FE MES QM)",
                "ResolvedDate": null,
                "Revision": 17,
                "RiskReductionMinusOpportunityEnablement": 3607,
                "StartDate": null,
                "State": "New",
                "Tags": "Fab Approval",
                "TargetDate": null,
                "TimeCriticality": 3759,
                "Title": "785 - When an ECN/TECN is cancelled, the comments are not being recorded in the audit log",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": 3456,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:46:38.883Z",
                "Description": "Deactivating user should remove them from all training groups and any active training tasks<br>&nbsp;<br>There are two methods for deactivating a user in Fab Approval. One method performs the requested actions. The other does not. This request would reconcile these different outcomes.",
                "Effort": 8380,
                "Id": 110773,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 2,
                "Relations": [],
                "Requester": "McIntyre Juanita (FE MES QM)",
                "ResolvedDate": null,
                "Revision": 17,
                "RiskReductionMinusOpportunityEnablement": 3531,
                "StartDate": null,
                "State": "New",
                "Tags": "Fab Approval",
                "TargetDate": null,
                "TimeCriticality": 3683,
                "Title": "786 - Deactivating user should remove them from all training groups and any active training tasks",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": 3380,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:46:39.67Z",
                "Description": "Fix root cause of invalid lots showing up in makeup inventory report<br>&nbsp;<br>Makeup wafer records are being written to the MAKEUP_WAFERS table when an RDS record is reused/reassigned and was previously a makeup cassette. This triggers a write to the WO_MAT table on the old associated record which propogates to the MAKEUP_WAFERS ta",
                "Effort": 1076,
                "Id": 110774,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 2,
                "Relations": [],
                "Requester": "Fuentes Jessica (FE MES P OPR)",
                "ResolvedDate": null,
                "Revision": 17,
                "RiskReductionMinusOpportunityEnablement": 3456,
                "StartDate": null,
                "State": "New",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": 3607,
                "Title": "796 - Fix root cause of invalid lots showing up in makeup inventory report",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": 3228,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:46:50.6Z",
                "Description": "When creating an NCR for a lot on hold, the save process is blocked and the user must navigate away from the current form back to the Pre-Epi form to take the lot off of hold. A method of taking the lot off of hold from the NCR form would avoid this.&nbsp;<br>&nbsp;<br>Create a dedicated dialog form for hold transactions that can be called from any form and integrate this into the NCR work flow.",
                "Effort": 2835,
                "Id": 110776,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 2,
                "Relations": [],
                "Requester": "Holland Justin (FE MES P OPR SH C)",
                "ResolvedDate": null,
                "Revision": 17,
                "RiskReductionMinusOpportunityEnablement": 3304,
                "StartDate": null,
                "State": "New",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": 3456,
                "Title": "798 - When creating an NCR for a lot on hold, the save process is blocked and the user must navigate away from the current form",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": 3152,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:46:51.663Z",
                "Description": "When an RDS is locked by another user and is viewed by another user, OI presents a series of dialog messages regarding the lock that must be clicked through in order to view the form. Ideally users would only receive one dialog message informing them that<br>&nbsp;<br>Remove additional lock dialog messages from RDS forms. ",
                "Effort": 2531,
                "Id": 110777,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 2,
                "Relations": [],
                "Requester": "Holland Justin (FE MES P OPR SH C)",
                "ResolvedDate": null,
                "Revision": 17,
                "RiskReductionMinusOpportunityEnablement": 3228,
                "StartDate": null,
                "State": "New",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": 3380,
                "Title": "799 - When an RDS is locked by another user and is viewed by another user, OI presents a series of dialog messages regarding th",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-09-12T21:35:41.753Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Phares Mike (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-21T23:59:00.007Z",
                "ClosedDate": "2024-10-03T14:22:45.34Z",
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:46:52.59Z",
                "Description": "collect temp data in fab areas and import to SPC charts<br>&nbsp;<br>see 8D for TCL thickness impacted by air temp ",
                "Effort": 5,
                "Id": 110778,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.4",
                "Parent": 110729,
                "Priority": 1,
                "Relations": [],
                "Requester": "Becker Chad (FE MES QM)",
                "ResolvedDate": "2024-10-03T14:22:45.34Z",
                "Revision": 20,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-09-14T00:37:01Z",
                "State": "Closed",
                "Tags": "EAF; EDA; InfinityQS",
                "TargetDate": "2024-10-03T14:22:00Z",
                "TimeCriticality": 1,
                "Title": "801 - Collect temp data in fab areas and import to SPC charts",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Ouellette Jonathan (CSC FI SPS MESLEO)",
                "BusinessValue": 20304,
                "ChangedDate": "2025-01-16T16:16:18.99Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:46:54.07Z",
                "Description": "Test Wafer Tracking - Phase 2 (Data Collection with Prod Runs)<br>&nbsp;<br>Integrate Test Wafer Tracking enhancements from phase 1 with Production Runs. Via the RDS load screen in OI and the RDS load functionality from the Smart Scanners",
                "Effort": 8304,
                "Id": 110779,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": 110729,
                "Priority": 1,
                "Relations": [],
                "Requester": "Becker Chad (FE MES QM)",
                "ResolvedDate": null,
                "Revision": 34,
                "RiskReductionMinusOpportunityEnablement": 20380,
                "StartDate": null,
                "State": "Active",
                "Tags": "OI; Smart Scanner",
                "TargetDate": null,
                "TimeCriticality": 13683,
                "Title": "803 - Test Wafer Tracking - Phase 2 (Data Collection with Prod Runs)",
                "Violation": null,
                "WeightedShortestJobFirst": 2,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-12-17T07:46:09.727Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Tucker Chase (CSC FI SPS MESLEO)",
                "BusinessValue": 13759,
                "ChangedDate": "2024-12-17T07:46:09.727Z",
                "ClosedDate": "2024-12-17T07:46:09.727Z",
                "CommentCount": 2,
                "CreatedDate": "2024-08-14T23:46:57.55Z",
                "Description": "Notify operator after SPV test to reload production recipe for HTR reactors<br>&nbsp;<br>Production recipe is not automatically reloaded on HTR reactors after SPV test is done. This has led to running entire cassettes with the test recipe by accident. This improvement would remind the operator to change the recipe in the reactor to the correc",
                "Effort": 3000,
                "Id": 110780,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.2",
                "Parent": 110729,
                "Priority": 1,
                "Relations": [],
                "Requester": "Holland Justin (FE MES P OPR SH C)",
                "ResolvedDate": "2024-12-17T07:46:09.727Z",
                "Revision": 21,
                "RiskReductionMinusOpportunityEnablement": 13835,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": "2025-02-21T19:00:00Z",
                "TimeCriticality": 20228,
                "Title": "810 - Notify operator after SPV test to reload production recipe for HTR reactors",
                "Violation": null,
                "WeightedShortestJobFirst": 4,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": 3911,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:46:58.36Z",
                "Description": "Create a report for Open WO's and WO's closed <br>&nbsp;<br>Reports needed for work orders that are opened. Then a report for WO's closed within a timespan.",
                "Effort": 2456,
                "Id": 110781,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 2,
                "Relations": [],
                "Requester": "Dockery Joseph (FE CF OPC MM EPI)",
                "ResolvedDate": null,
                "Revision": 17,
                "RiskReductionMinusOpportunityEnablement": 3911,
                "StartDate": null,
                "State": "New",
                "Tags": "Mesa Reporting Services",
                "TargetDate": null,
                "TimeCriticality": 5076,
                "Title": "811 - Create a report for Open WO's and WO's closed",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-10-28T14:49:13.56Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Ouellette Jonathan (CSC FI SPS MESLEO)",
                "BusinessValue": 3835,
                "ChangedDate": "2024-12-17T07:59:55.22Z",
                "ClosedDate": "2024-12-17T07:59:55.22Z",
                "CommentCount": 2,
                "CreatedDate": "2024-08-14T23:46:59.243Z",
                "Description": null,
                "Effort": 2380,
                "Id": 110782,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.1",
                "Parent": 110729,
                "Priority": 2,
                "Relations": [],
                "Requester": "Solis Javier (FE MES FM)",
                "ResolvedDate": "2024-12-17T07:59:55.22Z",
                "Revision": 33,
                "RiskReductionMinusOpportunityEnablement": 3835,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": 5000,
                "Title": "813 - Scrubbers need a maint schedule in OI",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-08-29T22:41:25.65Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": 8304,
                "ChangedDate": "2024-11-01T01:29:04.823Z",
                "ClosedDate": "2024-11-01T01:29:04.823Z",
                "CommentCount": 2,
                "CreatedDate": "2024-08-14T23:47:00.327Z",
                "Description": "",
                "Effort": 1380,
                "Id": 110783,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.1",
                "Parent": 125997,
                "Priority": 1,
                "Relations": [],
                "Requester": "Holland Justin (FE MES P OPR SH C)",
                "ResolvedDate": "2024-11-01T01:29:04.823Z",
                "Revision": 30,
                "RiskReductionMinusOpportunityEnablement": 8380,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI; SAP",
                "TargetDate": null,
                "TimeCriticality": 8987,
                "Title": "Ability to convert finished goods cassettes into makeup boxes and vice versa.",
                "Violation": null,
                "WeightedShortestJobFirst": 5,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2024-10-02T19:06:58.08Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Ouellette Jonathan (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-20T16:04:38.93Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-10-02T16:14:01.85Z",
                "Description": "<div><span style=\"display:inline !important;\">Track rework from FG inv</span><br style=\"box-sizing:border-box;\"><span style=\"display:inline !important;\">&nbsp;</span><br style=\"box-sizing:border-box;\"><span style=\"display:inline !important;\">Consolidation of requests 56, 325, 628, 766 and 802. All identify at least one use-case for Rework from FG.</span><br> </div>",
                "Effort": null,
                "Id": 125997,
                "IterationPath": "ART SPS\\2024\\PI3",
                "Parent": null,
                "Priority": 2,
                "Relations": [],
                "Requester": "Holland Justin (FE MES P OPR SH C)",
                "ResolvedDate": null,
                "Revision": 10,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Active",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "OpenInsight Finished Goods Re-Processing",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-08-22T17:46:00.023Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Ouellette Jonathan (IT FI MES)",
                "BusinessValue": 2,
                "ChangedDate": "2024-09-24T18:21:04.427Z",
                "ClosedDate": "2024-09-18T15:45:48.69Z",
                "CommentCount": 2,
                "CreatedDate": "2024-08-14T23:47:01.347Z",
                "Description": "Build into Packaging routine a way of identifieing which bagger was used (R or L)<br>&nbsp;<br>Possibly tie into the trilam scan with a .R or .L and log to lot history or INV Actions.",
                "Effort": 1,
                "Id": 110784,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.2",
                "Parent": 110729,
                "Priority": 1,
                "Relations": [],
                "Requester": "Holland Justin (MFG SHIFT 3)",
                "ResolvedDate": "2024-09-18T15:45:48.69Z",
                "Revision": 10,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": 3,
                "Title": "816 - Build into Packaging routine a way of identifying which bagger was used (R or L)",
                "Violation": null,
                "WeightedShortestJobFirst": 3,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": 20000,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:47:02.11Z",
                "Description": "Rework intrusive maintenance checklists to use a small set of process flows rather than individually marking each reactor service as 'intrusive'. (prove-in)<br>&nbsp;<br>The current design for generating an intrusive maintenance checklist in NICA is triggered by the reactor services being marked as either intrusive or not intrusive. This change would mark each service with an optional process flow that can be refereneced ",
                "Effort": 13607,
                "Id": 110785,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 1,
                "Relations": [],
                "Requester": "Fuentes Jessica (FE MES P OPR)",
                "ResolvedDate": null,
                "Revision": 25,
                "RiskReductionMinusOpportunityEnablement": 20076,
                "StartDate": null,
                "State": "New",
                "Tags": "OI; OI Web Services",
                "TargetDate": "2025-01-20T07:00:00Z",
                "TimeCriticality": 13987,
                "Title": "820 - Rework intrusive maintenance checklists to use a small set of process flows rather than individually marking each reactor",
                "Violation": null,
                "WeightedShortestJobFirst": 2,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": 5987,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:47:04.057Z",
                "Description": null,
                "Effort": 8835,
                "Id": 110787,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 1,
                "Relations": [],
                "Requester": "Holland Justin (FE MES P OPR SH C)",
                "ResolvedDate": null,
                "Revision": 23,
                "RiskReductionMinusOpportunityEnablement": 5987,
                "StartDate": null,
                "State": "New",
                "Tags": "OI",
                "TargetDate": "2025-01-20T07:00:00Z",
                "TimeCriticality": 8531,
                "Title": "824 - Restrict available reactor modes that are available to change to based on the the current reactor mode AND the current pr",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-10-14T17:16:25.187Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Ouellette Jonathan (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-21T21:13:09.327Z",
                "ClosedDate": "2024-10-14T17:16:25.187Z",
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:47:04.813Z",
                "Description": "Ready to Ship Report by Part Number and Prod Ord No<br>&nbsp;<br>The current ready to ship report (EXPORTS*READY_TO_SHIP) within OpenInsight is very slow and inflexible. Moving this into Fabtime would be ideal. ",
                "Effort": null,
                "Id": 110788,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.4",
                "Parent": 110729,
                "Priority": 2,
                "Relations": [],
                "Requester": "Elsbury Madonna (FE CF OPC MM EPI)",
                "ResolvedDate": "2024-10-14T17:16:25.187Z",
                "Revision": 14,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "FabTime",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "828 - Ready to Ship Report by Part Number and Prod Ord No",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Ouellette Jonathan (CSC FI SPS MESLEO)",
                "BusinessValue": 8835,
                "ChangedDate": "2024-12-17T07:39:14.093Z",
                "ClosedDate": null,
                "CommentCount": 2,
                "CreatedDate": "2024-08-14T23:47:06.27Z",
                "Description": "When an EPP work order closes, ensure unused WMO's are voided.<br>&nbsp;<br>At the close of EPP work orders, unused WMO records are abandoned and forgotten. They never get closed out and thus the records in Fabtime remain in WIP forever.",
                "Effort": 2304,
                "Id": 110790,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": 110729,
                "Priority": 1,
                "Relations": [],
                "Requester": "Fuentes Jessica (FE MES P OPR)",
                "ResolvedDate": null,
                "Revision": 25,
                "RiskReductionMinusOpportunityEnablement": 13152,
                "StartDate": null,
                "State": "New",
                "Tags": "OI",
                "TargetDate": "2025-01-20T07:00:00Z",
                "TimeCriticality": 8456,
                "Title": "830 - When an EPP work order closes, ensure unused WMO's are voided.",
                "Violation": null,
                "WeightedShortestJobFirst": 4,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Phares Mike (CSC FI SPS MESLEO)",
                "BusinessValue": 19200,
                "ChangedDate": "2025-01-07T17:18:26.037Z",
                "ClosedDate": "2025-01-07T17:18:26.037Z",
                "CommentCount": 3,
                "CreatedDate": "2024-08-14T23:47:07.03Z",
                "Description": "Implement SPC control of 4PP to HgCV Mean Delta for all ASM and HTR product<br>&nbsp;<br>Add new columns in 4PP IQS chart",
                "Effort": 19500,
                "Id": 110791,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.4",
                "Parent": 110729,
                "Priority": 1,
                "Relations": [],
                "Requester": "Becker Chad (FE MES QM)",
                "ResolvedDate": "2024-10-24T15:26:49.387Z",
                "Revision": 37,
                "RiskReductionMinusOpportunityEnablement": 19200,
                "StartDate": null,
                "State": "Closed",
                "Tags": "EAF; InfinityQS; OI",
                "TargetDate": null,
                "TimeCriticality": 19300,
                "Title": "831 - Implement SPC control of 4PP to HgCV Mean Delta for all ASM and HTR product",
                "Violation": null,
                "WeightedShortestJobFirst": 1,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-08-23T20:17:24.453Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-21T19:07:33.217Z",
                "ClosedDate": "2024-09-20T01:01:25.59Z",
                "CommentCount": 3,
                "CreatedDate": "2024-08-14T23:47:08.423Z",
                "Description": "Remove Std Dev result requirement from ADE 25 wafers(100% stratus) QA metrology tests. <br>&nbsp;<br><div>See RDS 634223 and COMM_QA_MET_RESULT lines 165 - 180. It appears the standard deviation max specification is dynamically set and is not defined at the PSN level.&nbsp;Per Justin H. the standard deviation result is no longer necessary because the form now validates&nbsp;whether each wafer is within spec or not. </div>",
                "Effort": 2,
                "Id": 110792,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 110729,
                "Priority": 1,
                "Relations": [],
                "Requester": "Holland Justin (FE MES P OPR SH C)",
                "ResolvedDate": "2024-09-20T01:01:25.59Z",
                "Revision": 13,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": "2024-09-20T01:01:00Z",
                "TimeCriticality": 3,
                "Title": "832 - Remove Std Dev result requirement from ADE 25 wafers(100% stratus) QA metrology tests.",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": 8759,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:47:09.153Z",
                "Description": "Auto add backside defect parameters when Virgin wafer button is clicked on the PRS Stage form.<br>&nbsp;<br>See RDS 634223 and COMM_QA_MET_RESULT lines 165 - 180. It appears the standard deviation max specification is dynamically set and is not defined at the PSN level.&nbsp;Per Justin H. the standard deviation result is no longer necessary because the form now vali",
                "Effort": 2152,
                "Id": 110793,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 2,
                "Relations": [],
                "Requester": "Cousten Mark (FE MES P UPE)",
                "ResolvedDate": null,
                "Revision": 16,
                "RiskReductionMinusOpportunityEnablement": 8835,
                "StartDate": null,
                "State": "New",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": 5228,
                "Title": "834 - Auto add backside defect parameters when Virgin wafer button is clicked on the PRS Stage form.",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-10-02T16:08:55.907Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Ouellette Jonathan (CSC FI SPS MESLEO)",
                "BusinessValue": 13000,
                "ChangedDate": "2024-11-04T21:30:17.743Z",
                "ClosedDate": "2024-11-04T21:30:17.743Z",
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:47:09.84Z",
                "Description": null,
                "Effort": 1152,
                "Id": 110794,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.1",
                "Parent": 110729,
                "Priority": 1,
                "Relations": [],
                "Requester": "Cousten Mark (FE MES P UPE)",
                "ResolvedDate": "2024-11-04T21:30:17.743Z",
                "Revision": 22,
                "RiskReductionMinusOpportunityEnablement": 13076,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": "2024-10-23T15:00:00Z",
                "TimeCriticality": 13380,
                "Title": "835 - PSN Activation validation. Include check for signatures.",
                "Violation": null,
                "WeightedShortestJobFirst": 8,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-12-17T07:48:12.53Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Tucker Chase (CSC FI SPS MESLEO)",
                "BusinessValue": 8683,
                "ChangedDate": "2024-12-17T13:28:52.073Z",
                "ClosedDate": null,
                "CommentCount": 4,
                "CreatedDate": "2024-08-14T23:47:10.56Z",
                "Description": "Prompt user for test wafer run on final cassette for HTR reactors.<br>&nbsp;<br><div>Prompt user to ask if a test wafer is required on the unload operation of the final cassette of an HTR work order only if the next work order is not the same PSN or there is no event scheduled next.&nbsp; </div>",
                "Effort": 2000,
                "Id": 110795,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": 110729,
                "Priority": 1,
                "Relations": [],
                "Requester": "Sperling Jonathon (FE MES P OPR SH A)",
                "ResolvedDate": null,
                "Revision": 33,
                "RiskReductionMinusOpportunityEnablement": 8759,
                "StartDate": null,
                "State": "Active",
                "Tags": "OI; OI Smart Scanner",
                "TargetDate": "2025-02-28T19:00:00Z",
                "TimeCriticality": 13759,
                "Title": "837 - Prompt user for test wafer run on final cassette for HTR reactors.",
                "Violation": null,
                "WeightedShortestJobFirst": 5,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": 3683,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:47:11.28Z",
                "Description": "<div>Modify auto-scheduler such that load operations of cassettes do not automatically cause the work order event to be considered engaged (active) and supersede previously scheduled work order events.<br> </div>&nbsp;<br>",
                "Effort": 8076,
                "Id": 110796,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 1,
                "Relations": [],
                "Requester": "Holland Justin (FE MES P OPR SH C)",
                "ResolvedDate": null,
                "Revision": 25,
                "RiskReductionMinusOpportunityEnablement": 3759,
                "StartDate": null,
                "State": "New",
                "Tags": "OI",
                "TargetDate": "2025-01-31T19:00:00Z",
                "TimeCriticality": 5456,
                "Title": "839 - Modify auto-scheduler such that load operations of cassettes do not automatically cause the work order event to be considered engaged (active) and supersede previously scheduled work order events",
                "Violation": null,
                "WeightedShortestJobFirst": 1,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": 13380,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 4,
                "CreatedDate": "2024-08-14T23:47:12Z",
                "Description": "<div><b><u>ON HOLD Per Human Error Initiative Team</u></b> </div><div><br> </div><div>Have in OI if the wafer counter equip goes down need to measure 2 wafers slots 1 &amp; 25. <br> </div>&nbsp;<br><div>Now that wafer counters are in place, the stratus QA metrology tests prescribed for slot 1 and 25 will be reduced to just slot 25. In the event that the FQA wafer counter for a given wafer size goes into an unproductive state, all unprocessed cassettes should have their prescribed metrology automatically updated such that both slots 1 and 25 are required. </div><div><br> </div>",
                "Effort": 8000,
                "Id": 110797,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 4,
                "Relations": [],
                "Requester": "Fuentes Jessica (FE MES P OPR)",
                "ResolvedDate": null,
                "Revision": 30,
                "RiskReductionMinusOpportunityEnablement": 13380,
                "StartDate": null,
                "State": "New",
                "Tags": "OI",
                "TargetDate": "2025-03-31T19:00:00Z",
                "TimeCriticality": 13607,
                "Title": "840 - Have in OI if the wafer counter equip goes down need to measure 2 wafers slots 1 & 25.",
                "Violation": null,
                "WeightedShortestJobFirst": 3,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-08-29T17:29:48.113Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": 8987,
                "ChangedDate": "2025-01-06T19:07:24.353Z",
                "ClosedDate": "2025-01-06T19:07:24.353Z",
                "CommentCount": 2,
                "CreatedDate": "2024-08-14T23:47:12.74Z",
                "Description": "Wrong RDS #'s entered. NCR created on wrong RDS. Wrong lot # was scrapped out. Possibly use of barcode scanners. Have a pop up block for validation with barcode scanner. If no scanner, undo NCR as an FI function. <br>&nbsp;<br>Prompt for RDS / WMO barcode scan when creating an NCR. If Barcode does not match the active RDS / WMO box in OI session, then throw error and abort NCR creation.",
                "Effort": 1456,
                "Id": 110798,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.2",
                "Parent": 110729,
                "Priority": 2,
                "Relations": [],
                "Requester": "Fuentes Jessica (FE MES P OPR)",
                "ResolvedDate": "2025-01-06T19:07:24.353Z",
                "Revision": 26,
                "RiskReductionMinusOpportunityEnablement": 8304,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": 8911,
                "Title": "841 - Wrong RDS #'s entered. NCR created on wrong RDS. Wrong lot # was scrapped out. Possibly use of barcode scanners. Have a p",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Ouellette Jonathan (CSC FI SPS MESLEO)",
                "BusinessValue": 2,
                "ChangedDate": "2024-10-21T21:12:49.257Z",
                "ClosedDate": "2024-09-12T17:23:40.623Z",
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:47:14.367Z",
                "Description": "Add the ability to place multiple lots (i.e., RDS or WM_OUT records) on hold at once instead of one at a time.<br>&nbsp;<br>Currently RDS cassettes can only be placed on hold within the RDS_PRE_EPI form and WM_OUT cassettes can only be placed on hold within the WM_OUT form. Add option to place on hold / take off hold to the NDW_RDS_QUERY and NDW_WM_OUT_QUICK_QUERY forms. Consider refactoring obj_WO_Mat('ToggleHold') function into a service module.",
                "Effort": 2,
                "Id": 110799,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.2",
                "Parent": 110729,
                "Priority": 1,
                "Relations": [],
                "Requester": "Holland Justin (FE MES P OPR SH C)",
                "ResolvedDate": "2024-09-12T17:23:40.623Z",
                "Revision": 13,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": 3,
                "Title": "842 - Add the ability to place multiple lots (i.e., RDS or WM_OUT records) on hold at once instead of one at a time.",
                "Violation": null,
                "WeightedShortestJobFirst": 3,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-12-17T07:53:10.31Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Ouellette Jonathan (CSC FI SPS MESLEO)",
                "BusinessValue": 13911,
                "ChangedDate": "2025-01-17T16:08:38.517Z",
                "ClosedDate": "2025-01-17T16:08:38.517Z",
                "CommentCount": 2,
                "CreatedDate": "2024-08-14T23:47:15.683Z",
                "Description": "Recreate a 5S task list similar to production for use in Shipping and Receiving area. This is the result of an audit finding.<br>&nbsp;<br>Recreate seperately what was created for Fab 5S tracking for use in Shipping and Receiving",
                "Effort": 1987,
                "Id": 110800,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.2",
                "Parent": 110729,
                "Priority": 1,
                "Relations": [],
                "Requester": "Eschenauer Scott (FE CF OPC MM EPI MLOG REC)",
                "ResolvedDate": "2024-12-17T07:53:10.31Z",
                "Revision": 26,
                "RiskReductionMinusOpportunityEnablement": 13987,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": "2025-01-20T07:00:00Z",
                "TimeCriticality": 8380,
                "Title": "843 - Recreate a 5S task list similar to production for use in Shipping and Receiving area. This is the result of an audit find",
                "Violation": null,
                "WeightedShortestJobFirst": 6,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2025-01-07T17:03:29.483Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Mitchem Dakota (CSC FI SPS MESLEO External)",
                "BusinessValue": 5076,
                "ChangedDate": "2025-01-22T23:15:20.397Z",
                "ClosedDate": "2025-01-22T23:15:20.397Z",
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:47:17.327Z",
                "Description": "Display percent complete for reactor prove in orders in NICA<br>&nbsp;<br>This request requires adding text when hovering over Active Reactor Prove In icon in OI that displays the percent complete of the NICA order. This request also requires a modification to the NICA API in OI Web Services to gather the percent complete and a",
                "Effort": 1911,
                "Id": 110801,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": 110729,
                "Priority": 1,
                "Relations": [],
                "Requester": "Marstein Daniel (FE MES P OPR SH D)",
                "ResolvedDate": "2025-01-22T23:15:20.397Z",
                "Revision": 30,
                "RiskReductionMinusOpportunityEnablement": 5076,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI; OI Web Services",
                "TargetDate": null,
                "TimeCriticality": 5304,
                "Title": "845 - Display percent complete for reactor prove in orders in NICA",
                "Violation": null,
                "WeightedShortestJobFirst": 3,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-11-18T22:30:21.253Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": 13987,
                "ChangedDate": "2025-01-06T18:06:25.597Z",
                "ClosedDate": "2025-01-06T18:06:25.597Z",
                "CommentCount": 6,
                "CreatedDate": "2024-08-14T23:47:19.363Z",
                "Description": "<div>Automate specific Aborts to trigger 100% Center Point Thickness at FQA stage and 100% surfscan at Unload stage. </div>",
                "Effort": 2076,
                "Id": 110803,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.2",
                "Parent": 110729,
                "Priority": 1,
                "Relations": [],
                "Requester": "Fuentes Jessica (FE MES P OPR)",
                "ResolvedDate": "2025-01-06T18:06:25.597Z",
                "Revision": 33,
                "RiskReductionMinusOpportunityEnablement": 20000,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI; OI Web Services",
                "TargetDate": "2025-05-31T19:00:00Z",
                "TimeCriticality": 13911,
                "Title": "852 - Automate specific Aborts to trigger 100% Center Point Thickness.",
                "Violation": null,
                "WeightedShortestJobFirst": 7,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": 5000,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:47:20.417Z",
                "Description": "Create reminders for all task types<br>&nbsp;<br>6/13/24 -bundle with MRB/PCRB modules <br>Currently, reminders are sent via email for only certain tasks. This request would make those reminders universal across all modules. ",
                "Effort": 5987,
                "Id": 110804,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 2,
                "Relations": [],
                "Requester": "McIntyre Juanita (FE MES QM)",
                "ResolvedDate": null,
                "Revision": 16,
                "RiskReductionMinusOpportunityEnablement": 5000,
                "StartDate": null,
                "State": "New",
                "Tags": "Fab Approval",
                "TargetDate": null,
                "TimeCriticality": 5380,
                "Title": "853 - Create reminders for all task types",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-11-27T16:06:48.167Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": 13228,
                "ChangedDate": "2025-01-16T19:47:22.507Z",
                "ClosedDate": "2025-01-07T16:51:32.71Z",
                "CommentCount": 2,
                "CreatedDate": "2024-08-14T23:47:21.17Z",
                "Description": "Trigger NICA order for OCAP checklist upon HgCV Monitor alarm from SPC<br>",
                "Effort": 1759,
                "Id": 110805,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.3",
                "Parent": 110729,
                "Priority": 1,
                "Relations": [],
                "Requester": "Fuentes Jessica (FE MES P OPR)",
                "ResolvedDate": "2025-01-07T16:51:32.71Z",
                "Revision": 40,
                "RiskReductionMinusOpportunityEnablement": 13456,
                "StartDate": null,
                "State": "Closed",
                "Tags": "NICA; OI; OI Web Services",
                "TargetDate": "2025-04-30T19:00:00Z",
                "TimeCriticality": 13835,
                "Title": "855 - Trigger NICA order for OCAP checklist upon HgCV Monitor alarm from SPC",
                "Violation": null,
                "WeightedShortestJobFirst": 13,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Ouellette Jonathan (CSC FI SPS MESLEO)",
                "BusinessValue": 8607,
                "ChangedDate": "2024-12-17T07:40:15.977Z",
                "ClosedDate": null,
                "CommentCount": 2,
                "CreatedDate": "2024-08-14T23:47:22.18Z",
                "Description": "Change method for determining eligble cassettes that can be peeled off. Look at Curr Status of all lots in a WO, then determine if they are pre-epi. If they are pre-epi they are eligible to be peeled off.<br>&nbsp;<br>Currently the method to determine eligible lots is rudementary. It starts by going from the end of a list of lots and stops once it detects a signature. This is a poor method because lots mid WO may have no signature and they are never evaluated to determ",
                "Effort": 5076,
                "Id": 110806,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": 110729,
                "Priority": 1,
                "Relations": [],
                "Requester": "Chow Bobby (FE CF OPC MM EPI)",
                "ResolvedDate": null,
                "Revision": 31,
                "RiskReductionMinusOpportunityEnablement": 8683,
                "StartDate": null,
                "State": "New",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": 13228,
                "Title": "856 - Change method for determining eligible cassettes that can be peeled off. Look at Curr Status of all lots in a WO, then det",
                "Violation": null,
                "WeightedShortestJobFirst": 3,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2025-01-22T18:20:25.997Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Ouellette Jonathan (CSC FI SPS MESLEO)",
                "BusinessValue": 8531,
                "ChangedDate": "2025-01-22T18:20:25.997Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:47:23.003Z",
                "Description": "Change peel off routine behavior to VOID peel off lots rather than delete them<br>&nbsp;<br>Currently OI deletes lots when they are peeled off. This is not good for data integrity. Change the method to void the lots AND change the VOID behavior to remove the quantities from the respective work orders",
                "Effort": 5835,
                "Id": 110807,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": 110729,
                "Priority": 1,
                "Relations": [],
                "Requester": "Chow Bobby (FE CF OPC MM EPI)",
                "ResolvedDate": null,
                "Revision": 32,
                "RiskReductionMinusOpportunityEnablement": 8607,
                "StartDate": null,
                "State": "Active",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": 13076,
                "Title": "857 - Change peel off routine behavior to VOID peel off lots rather than delete them",
                "Violation": null,
                "WeightedShortestJobFirst": 2,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-09-13T22:35:45.34Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Phares Mike (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-24T16:14:36.173Z",
                "ClosedDate": "2024-10-24T16:14:36.173Z",
                "CommentCount": 1,
                "CreatedDate": "2024-08-14T23:47:25.303Z",
                "Description": "Flag InfinityQS entries as disabled when entries have the same date time, rds and pns<br>&nbsp;<br>Use EAF to update sql server table column that indicates entry status",
                "Effort": 10,
                "Id": 110808,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.4",
                "Parent": 110729,
                "Priority": 3,
                "Relations": [],
                "Requester": "Clark Kelly (FE MES P UPE SH)",
                "ResolvedDate": "2024-10-18T01:04:36.423Z",
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "InfinityQS",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "859 - Flag InfinityQS entries as disabled when entries have the same date time, rds and pns",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Phares Mike (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-21T21:04:42.513Z",
                "ClosedDate": "2024-10-03T14:39:04.253Z",
                "CommentCount": 2,
                "CreatedDate": "2024-08-14T23:47:45.53Z",
                "Description": "Transfer data from BioRad Stratus without using deprecated SMBv1<br>&nbsp;<br>Windows 2016 is approching end of life and will be upgraded to 2019 or newer which will not support SMBv1",
                "Effort": null,
                "Id": 110809,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.2",
                "Parent": 110729,
                "Priority": 2,
                "Relations": [],
                "Requester": "Carrier Todd (FE MES P UPE)",
                "ResolvedDate": "2024-08-29T16:19:06.93Z",
                "Revision": 13,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-29T23:19:02Z",
                "State": "Closed",
                "Tags": "EAF",
                "TargetDate": "2024-10-03T14:39:00Z",
                "TimeCriticality": null,
                "Title": "860 - Transfer data from BioRad Stratus without using deprecated SMBv1",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-08-14T23:48:06.463Z",
                "AreaPath": "ART SPS\\LEO",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-24T17:31:51.033Z",
                "ClosedDate": "2024-10-02T22:15:51.673Z",
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T23:48:02.007Z",
                "Description": "<div><div style=\"box-sizing:border-box;\">complete upgrade plan including&nbsp; </div><div style=\"box-sizing:border-box;\"><ul style=\"box-sizing:border-box;padding:0px 0px 0px 40px;\"><li style=\"box-sizing:border-box;\">which servers, who responsible </li> </ul> </div><div style=\"box-sizing:border-box;\"><ul style=\"box-sizing:border-box;padding:0px 0px 0px 40px;\"><li style=\"box-sizing:border-box;\">IPU or traditional upgrade&nbsp; </li> </ul> </div><div style=\"box-sizing:border-box;\"><ul style=\"box-sizing:border-box;padding:0px 0px 0px 40px;\"><li style=\"box-sizing:border-box;\">dependencies and timing </li> </ul> </div><br> </div>",
                "Effort": null,
                "Id": 110810,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 109726,
                "Priority": 3,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": "2024-10-02T22:15:51.673Z",
                "Revision": 6,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-01T22:00:00Z",
                "State": "Closed",
                "Tags": "IT OS",
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "Windows 2016 upgrade - planning",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2024-08-09T18:10:38.49Z",
                "AreaPath": "ART SPS\\LEO",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-07T17:08:47.7Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-09T18:10:30.717Z",
                "Description": "<div><div style=\"box-sizing:border-box;\">Umbrella Epic to capture demand on capacity and visibility of efforts required by IT OS or FI Process Framework.&nbsp;<br> </div><div style=\"box-sizing:border-box;\"><br> </div><div style=\"box-sizing:border-box;\">Examples are: Stealth migration, Win 206 OS upgrade, RHEL upgrade, Creation of UA Orderables, Establishing Service Products and the support processes.&nbsp; </div><div style=\"box-sizing:border-box;\"><br> </div><div style=\"box-sizing:border-box;\">Features should be created for specific topics.&nbsp; </div><br> </div>",
                "Effort": null,
                "Id": 109726,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 2,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 9,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "LEO Compliance",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Phares Mike (CSC FI SPS MESLEO)",
                "BusinessValue": 8911,
                "ChangedDate": "2025-01-22T18:10:25Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-15T20:31:34.533Z",
                "Description": null,
                "Effort": 13835,
                "Id": 110976,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": 110729,
                "Priority": 2,
                "Relations": [],
                "Requester": "Becker Chad (FE MES QM)",
                "ResolvedDate": null,
                "Revision": 30,
                "RiskReductionMinusOpportunityEnablement": 8911,
                "StartDate": null,
                "State": "New",
                "Tags": "EAF; FDC",
                "TargetDate": null,
                "TimeCriticality": 13152,
                "Title": "SECS/GEM Reactor Logging",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-08-16T17:15:24.093Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Phares Mike (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-21T19:08:11.18Z",
                "ClosedDate": "2024-09-12T23:03:37.897Z",
                "CommentCount": 0,
                "CreatedDate": "2024-08-16T15:56:58.247Z",
                "Description": null,
                "Effort": null,
                "Id": 111123,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.1",
                "Parent": 110731,
                "Priority": 2,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": "2024-09-09T17:19:48.493Z",
                "Revision": 14,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-05T07:00:00Z",
                "State": "Closed",
                "Tags": "Ignore",
                "TargetDate": "2024-09-12T23:03:00Z",
                "TimeCriticality": null,
                "Title": "Migrate Backlog",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:01:55.633Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-07T17:01:55.633Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:28:09.19Z",
                "Description": "<div><div style=\"box-sizing:border-box;\">Umbrella Epic to capture demand on capacity and visibility of efforts required by IT OS or FI Process Framework.&nbsp;<br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\"><br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\">Examples are: Stealth migration, Win 206 OS upgrade, RHEL upgrade, Creation of UA Orderables, Establishing Service Products and the support processes.&nbsp; </div><div style=\"box-sizing:border-box;\"><br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\">Features should be created for specific topics.&nbsp; </div><br> </div>",
                "Effort": null,
                "Id": 110731,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 2,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 9,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Compliance",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-08-26T17:14:26.933Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Ouellette Jonathan (IT FI MES)",
                "BusinessValue": null,
                "ChangedDate": "2024-09-04T16:28:37.33Z",
                "ClosedDate": "2024-08-26T21:42:16.83Z",
                "CommentCount": 3,
                "CreatedDate": "2024-08-20T23:37:05.547Z",
                "Description": null,
                "Effort": null,
                "Id": 111547,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.2",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Becker Chad (QM)",
                "ResolvedDate": "2024-08-26T20:21:05.24Z",
                "Revision": 17,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "Mesa Reporting Services; OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "863 - Reactor uptime percentage on Mesa Reporting Services is incorrect/not in line with reporting standards.",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": null,
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-12-17T13:30:11.433Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Tucker Chase (CSC FI SPS MESLEO)",
                "BusinessValue": 8456,
                "ChangedDate": "2024-12-17T13:30:11.433Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-08-21T16:36:32.647Z",
                "Description": "Create method for re-shipping non-epp and epp lots when they return from customer for an RMA<br>&nbsp;<br>Currently there is no supported method to re-shipping lots that have returned for an RMA. These are lots that are returned from a customer and are shipped back out to the same customer withg the same part no",
                "Effort": 5759,
                "Id": 111882,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": 110729,
                "Priority": 1,
                "Relations": [],
                "Requester": "Quinones Debra (FE CF OPC MM EPI MLOG SHI)",
                "ResolvedDate": null,
                "Revision": 26,
                "RiskReductionMinusOpportunityEnablement": 8531,
                "StartDate": null,
                "State": "Active",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": 5911,
                "Title": "862 - Create method for re-shipping non-epp and epp lots when they return from customer for an RMA",
                "Violation": null,
                "WeightedShortestJobFirst": 2,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-08-22T15:21:04.253Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Tucker Chase (IT FI MES)",
                "BusinessValue": null,
                "ChangedDate": "2024-09-04T16:28:37.33Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-08-22T15:20:51.673Z",
                "Description": null,
                "Effort": null,
                "Id": 112291,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.1",
                "Parent": 110733,
                "Priority": 1,
                "Relations": [],
                "Requester": "Sperling Jonathon (MFG SHIFT 1)",
                "ResolvedDate": "2024-08-22T16:09:18.197Z",
                "Revision": 8,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Resolved",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Reactor Prove-In Override Possible Without Comment",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": {
                "ActivatedDate": "2024-08-14T22:50:20.577Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-20T22:14:16.06Z",
                "ClosedDate": "2024-09-12T22:51:47.317Z",
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:50:14.113Z",
                "Description": "<div>MES Operations Support </div>",
                "Effort": null,
                "Id": 110733,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.1",
                "Parent": 110732,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": "2024-09-12T22:51:47.317Z",
                "Revision": 5,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "Mesa",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "MES Operations Support 2024\\PI3\\Sprint 3.1",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "User Story"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-08-23T18:25:09.863Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-03T15:20:38.25Z",
                "ClosedDate": "2024-09-26T20:50:45.953Z",
                "CommentCount": 0,
                "CreatedDate": "2024-08-23T18:22:22.243Z",
                "Description": null,
                "Effort": null,
                "Id": 112541,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.1",
                "Parent": 110733,
                "Priority": 1,
                "Relations": [],
                "Requester": null,
                "ResolvedDate": "2024-08-23T18:25:09.863Z",
                "Revision": 9,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Wafer Counter input issue when Caps Lock is on",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": {
                "ActivatedDate": "2024-08-14T22:50:20.577Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-20T22:14:16.06Z",
                "ClosedDate": "2024-09-12T22:51:47.317Z",
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:50:14.113Z",
                "Description": "<div>MES Operations Support </div>",
                "Effort": null,
                "Id": 110733,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.1",
                "Parent": 110732,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": "2024-09-12T22:51:47.317Z",
                "Revision": 5,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "Mesa",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "MES Operations Support 2024\\PI3\\Sprint 3.1",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "User Story"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-08-26T20:51:38.773Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Ouellette Jonathan (IT FI MES)",
                "BusinessValue": null,
                "ChangedDate": "2024-09-04T16:28:37.33Z",
                "ClosedDate": "2024-08-28T21:00:59.46Z",
                "CommentCount": 1,
                "CreatedDate": "2024-08-26T17:08:17.623Z",
                "Description": null,
                "Effort": null,
                "Id": 112977,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.2",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Fuentes Jessica (MFG)",
                "ResolvedDate": "2024-08-27T23:39:32.86Z",
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "FabTime; OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Missing Inv. Transactions From WO_Mat Record",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": null,
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-08-29T16:39:11.513Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Ouellette Jonathan (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-07T16:24:28.993Z",
                "ClosedDate": "2024-09-10T21:49:49.87Z",
                "CommentCount": 0,
                "CreatedDate": "2024-08-27T17:52:00.47Z",
                "Description": "<div>When logging services generates a log file it does so at a pre-defined path. If the path doesn't exist it causes execution of the program to error out and halt. This request is to change Logging Services to create the directory structure defined in the logging path if it doesn't exist. </div>",
                "Effort": null,
                "Id": 113722,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.2",
                "Parent": 110729,
                "Priority": 2,
                "Relations": [],
                "Requester": "Fuentes Jessica (FE MES P OPR)",
                "ResolvedDate": "2024-09-10T21:49:49.87Z",
                "Revision": 4,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Logging Services File Creation",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-09-13T22:33:19.7Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Phares Mike (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-04T23:50:25.217Z",
                "ClosedDate": "2024-10-03T14:21:02.977Z",
                "CommentCount": 0,
                "CreatedDate": "2024-08-27T18:12:38.4Z",
                "Description": "<div>Add the wafer counter log output files to the Metrology Viewer for reporting </div>",
                "Effort": null,
                "Id": 113724,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 110729,
                "Priority": 2,
                "Relations": [],
                "Requester": "Holland Justin (FE MES P OPR SH C)",
                "ResolvedDate": "2024-10-03T14:21:02.977Z",
                "Revision": 14,
                "RiskReductionMinusOpportunityEnablement": 3,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI Metrology Viewer",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Wafer Counter in Metrology Viewer",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-08-29T22:45:09.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-21T17:05:53.003Z",
                "ClosedDate": "2024-10-02T16:50:53.75Z",
                "CommentCount": 0,
                "CreatedDate": "2024-08-27T19:38:39.107Z",
                "Description": "<div>Currently the mean time to repair (MTTR), mean time between failure (MTBF), and green to green (G2G) charts in Fabtime are incorrect and do not match data extracted from OpenInsight. </div>",
                "Effort": null,
                "Id": 113727,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 110729,
                "Priority": 1,
                "Relations": [],
                "Requester": "O'Toole Derek (FE MES P MNT SH)",
                "ResolvedDate": "2024-10-02T16:50:53.75Z",
                "Revision": 16,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "FabTime; OI",
                "TargetDate": null,
                "TimeCriticality": 1,
                "Title": "Enable MTTR, MTBF, and G2G Fabtime Charts",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-09-12T17:28:33.523Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Ouellette Jonathan (CSC FI SPS MESLEO)",
                "BusinessValue": 1,
                "ChangedDate": "2024-10-21T23:22:36.763Z",
                "ClosedDate": "2024-10-18T18:36:17.16Z",
                "CommentCount": 0,
                "CreatedDate": "2024-08-28T18:35:14.613Z",
                "Description": "<div>Currently notifications for scheduled PMs that are coming due, currently due, or overdue are limited to users on the current shift, next shift, and supervisors. There is a need for notifications to be sent to other groups as needed such as the engineering group.&nbsp; </div>",
                "Effort": 1,
                "Id": 114221,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 110729,
                "Priority": 1,
                "Relations": [],
                "Requester": "McChesney Peyton (FE MES P UPE)",
                "ResolvedDate": "2024-10-18T18:36:13.54Z",
                "Revision": 21,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-09-17T00:19:52Z",
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": "2024-09-29T22:00:00Z",
                "TimeCriticality": 1,
                "Title": "Enable configurable recipient list for PMs due",
                "Violation": null,
                "WeightedShortestJobFirst": 1,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-11-22T16:52:34.233Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Mitchem Dakota (CSC FI SPS MESLEO External)",
                "BusinessValue": 13304,
                "ChangedDate": "2024-12-03T18:56:09.333Z",
                "ClosedDate": "2024-12-03T18:56:09.333Z",
                "CommentCount": 1,
                "CreatedDate": "2024-09-03T19:04:53.517Z",
                "Description": "<div>Develop a service that monitors the status of COC files, both .pdf and .csv, in terms of generation, transmission, and availability.&nbsp; </div>",
                "Effort": 1607,
                "Id": 116442,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.2",
                "Parent": 110729,
                "Priority": 1,
                "Relations": [],
                "Requester": "Becker Chad (FE MES QM)",
                "ResolvedDate": "2024-12-03T18:56:09.333Z",
                "Revision": 30,
                "RiskReductionMinusOpportunityEnablement": 13304,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": 5531,
                "Title": "Monitor COC FTP File Repository",
                "Violation": null,
                "WeightedShortestJobFirst": 12,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-09-18T15:18:13.533Z",
                "AreaPath": "ART SPS\\LEO",
                "AssignedTo": "Phares Mike (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-23T18:38:48.75Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-09-06T16:53:11.393Z",
                "Description": "<div>Setup server infrastructure and install software to allow YODA to be used by other applications </div>",
                "Effort": null,
                "Id": 119184,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.4",
                "Parent": 128426,
                "Priority": 2,
                "Relations": [],
                "Requester": "Pagkaliwangan Angelo (PSS HiRel OP ENG)",
                "ResolvedDate": "2024-10-08T23:31:59.07Z",
                "Revision": 19,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Resolved",
                "Tags": "YODA",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "YODA @ LEO - Setup",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2024-12-12T23:55:49.07Z",
                "AreaPath": "ART SPS\\LEO",
                "AssignedTo": "Phares Mike (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-12-12T23:55:54.42Z",
                "ClosedDate": "2024-12-12T23:55:54.42Z",
                "CommentCount": 0,
                "CreatedDate": "2024-10-10T14:20:35.613Z",
                "Description": null,
                "Effort": null,
                "Id": 128426,
                "IterationPath": "ART SPS",
                "Parent": null,
                "Priority": 2,
                "Relations": [],
                "Requester": "Pagkaliwangan Angelo (PSS HiRel OP ENG)",
                "ResolvedDate": "2024-12-12T23:55:54.42Z",
                "Revision": 8,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "YODA",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "YODA @ LEO",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-09-18T15:17:48.013Z",
                "AreaPath": "ART SPS\\LEO",
                "AssignedTo": "Phares Mike (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-07T17:18:02.943Z",
                "ClosedDate": "2025-01-07T17:18:02.943Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-06T16:53:42.73Z",
                "Description": "<div>Using YODA servers with open Stealth communication I would like to do a PoC in EAF. </div>",
                "Effort": null,
                "Id": 119185,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.4",
                "Parent": 128425,
                "Priority": 2,
                "Relations": [],
                "Requester": "Pagkaliwangan Angelo (PSS HiRel OP ENG)",
                "ResolvedDate": "2024-10-18T15:24:21.807Z",
                "Revision": 17,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "EAF",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "EAF @ LEO - PoC",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2024-12-12T23:58:44.8Z",
                "AreaPath": "ART SPS\\LEO",
                "AssignedTo": "Phares Mike (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-12-12T23:58:44.8Z",
                "ClosedDate": "2024-12-12T23:58:44.8Z",
                "CommentCount": 0,
                "CreatedDate": "2024-10-10T14:19:54.8Z",
                "Description": null,
                "Effort": null,
                "Id": 128425,
                "IterationPath": "ART SPS",
                "Parent": null,
                "Priority": 2,
                "Relations": [],
                "Requester": "Pagkaliwangan Angelo (PSS HiRel OP ENG)",
                "ResolvedDate": "2024-12-12T23:58:44.8Z",
                "Revision": 7,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "EAF",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "EAF @ LEO",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": 5911,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-09-12T15:53:16.27Z",
                "Description": "<div><p style=\"margin:0in;font-size:11pt;font-family:Aptos, sans-serif;\"><span style=\"font-size:10.0pt;font-family:&quot;Arial&quot;,sans-serif;\">We\nwould also like to see if we can trigger the NICA checklist using the load lock\nstart up note added by maintenance once a load lock is recorded back up.</span> </p><p style=\"margin:0in;font-size:11pt;font-family:Aptos, sans-serif;\"><span style=\"font-size:10.0pt;font-family:&quot;Arial&quot;,sans-serif;\"><ol style=\"margin-bottom:0in;margin-top:0in;\" start=1 type=1>\n <li style=\"margin:0in 0in 0in 0.5in;font-size:11pt;font-family:Aptos, sans-serif;margin-left:0in;\"><span style=\"font-size:10.0pt;font-family:&quot;Arial&quot;,sans-serif;\">Placing load lock down</span> </li>\n <li style=\"margin:0in 0in 0in 0.5in;font-size:11pt;font-family:Aptos, sans-serif;margin-left:0in;\"><span style=\"font-size:10.0pt;font-family:&quot;Arial&quot;,sans-serif;\">Load lock repaired and start up note added (Triggers\n     NICA Checklist)</span> </li>\n <li style=\"margin:0in 0in 0in 0.5in;font-size:11pt;font-family:Aptos, sans-serif;margin-left:0in;\"><span style=\"font-size:10.0pt;font-family:&quot;Arial&quot;,sans-serif;\">NICA checklist completed, and removes asterisk</span> </li> </ol></span> </p> </div>",
                "Effort": 13531,
                "Id": 120987,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 1,
                "Relations": [],
                "Requester": "Sperling Jonathon (FE MES P OPR SH A)",
                "ResolvedDate": null,
                "Revision": 25,
                "RiskReductionMinusOpportunityEnablement": 5911,
                "StartDate": null,
                "State": "New",
                "Tags": "NICA; OI; OI Web Services",
                "TargetDate": null,
                "TimeCriticality": 5759,
                "Title": "Down Load Lock Recovery NICA Checklist Integration",
                "Violation": null,
                "WeightedShortestJobFirst": 1,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-09-12T17:33:53.127Z",
                "AreaPath": "ART SPS\\LEO",
                "AssignedTo": "Buuck Travis (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-13T17:35:19.39Z",
                "ClosedDate": "2024-10-03T14:51:36.547Z",
                "CommentCount": 1,
                "CreatedDate": "2024-09-12T16:26:26.35Z",
                "Description": "<div>enable printing from Camstar on a label for the reject bag, no known need for bar codes <br> </div>",
                "Effort": 5,
                "Id": 120990,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 109724,
                "Priority": 2,
                "Relations": [],
                "Requester": "Piermarini Alexander (PSS HiRel OP PROD MS)",
                "ResolvedDate": "2024-10-03T14:51:36.547Z",
                "Revision": 7,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "BC Labels; Camstar",
                "TargetDate": null,
                "TimeCriticality": 1,
                "Title": "271 - Print scrap labels",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:08:00.113Z",
                "AreaPath": "ART SPS\\LEO",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-07T17:08:00.113Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-09T17:56:59.233Z",
                "Description": "<div>Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp; </div>",
                "Effort": null,
                "Id": 109724,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "LEO Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-12-17T07:50:20.61Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Tucker Chase (CSC FI SPS MESLEO)",
                "BusinessValue": 20531,
                "ChangedDate": "2024-12-17T07:50:20.61Z",
                "ClosedDate": "2024-12-17T07:50:20.61Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-15T04:28:33.793Z",
                "Description": null,
                "Effort": 2607,
                "Id": 121511,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.2",
                "Parent": 110729,
                "Priority": 1,
                "Relations": [],
                "Requester": "Holland Justin (FE MES P OPR SH C)",
                "ResolvedDate": "2024-12-17T07:50:20.61Z",
                "Revision": 25,
                "RiskReductionMinusOpportunityEnablement": 20531,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": 20531,
                "Title": "Limit Biorad metrology upload to OI to only allow upload IF the recipe and pattern matches what is prescribed in the RDS_TEST or the WO_MAT_QA record",
                "Violation": null,
                "WeightedShortestJobFirst": 12,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-09-19T16:11:54.37Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-07T19:26:23.317Z",
                "ClosedDate": "2024-09-26T20:27:37.14Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-19T16:11:19.283Z",
                "Description": "<div>Post Migration remediation of bugs found in OI10 </div>",
                "Effort": null,
                "Id": 122826,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 110731,
                "Priority": 2,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": "2024-09-26T20:27:37.14Z",
                "Revision": 5,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "OI 10 Post Migration Remediation",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:01:55.633Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-07T17:01:55.633Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:28:09.19Z",
                "Description": "<div><div style=\"box-sizing:border-box;\">Umbrella Epic to capture demand on capacity and visibility of efforts required by IT OS or FI Process Framework.&nbsp;<br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\"><br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\">Examples are: Stealth migration, Win 206 OS upgrade, RHEL upgrade, Creation of UA Orderables, Establishing Service Products and the support processes.&nbsp; </div><div style=\"box-sizing:border-box;\"><br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\">Features should be created for specific topics.&nbsp; </div><br> </div>",
                "Effort": null,
                "Id": 110731,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 2,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 9,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Compliance",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-09-20T16:06:17.04Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-07T18:14:36.603Z",
                "ClosedDate": "2024-09-20T21:09:15.967Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-20T16:06:07.36Z",
                "Description": null,
                "Effort": null,
                "Id": 123054,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 122826,
                "Priority": 2,
                "Relations": [],
                "Requester": "O'Toole Derek (FE MES P MNT SH)",
                "ResolvedDate": "2024-09-20T16:06:17.04Z",
                "Revision": 5,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Reactor Log Report Hanging",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": {
                "ActivatedDate": "2024-09-19T16:11:54.37Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-07T19:26:23.317Z",
                "ClosedDate": "2024-09-26T20:27:37.14Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-19T16:11:19.283Z",
                "Description": "<div>Post Migration remediation of bugs found in OI10 </div>",
                "Effort": null,
                "Id": 122826,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 110731,
                "Priority": 2,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": "2024-09-26T20:27:37.14Z",
                "Revision": 5,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "OI 10 Post Migration Remediation",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-09-20T16:09:02.787Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-07T18:14:29.223Z",
                "ClosedDate": "2024-09-20T21:09:04.917Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-20T16:08:54.58Z",
                "Description": null,
                "Effort": null,
                "Id": 123055,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 122826,
                "Priority": 2,
                "Relations": [],
                "Requester": "O'Toole Derek (FE MES P MNT SH)",
                "ResolvedDate": "2024-09-20T16:09:02.787Z",
                "Revision": 6,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Reactor Log Report Form Broken",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": {
                "ActivatedDate": "2024-09-19T16:11:54.37Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-07T19:26:23.317Z",
                "ClosedDate": "2024-09-26T20:27:37.14Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-19T16:11:19.283Z",
                "Description": "<div>Post Migration remediation of bugs found in OI10 </div>",
                "Effort": null,
                "Id": 122826,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 110731,
                "Priority": 2,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": "2024-09-26T20:27:37.14Z",
                "Revision": 5,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "OI 10 Post Migration Remediation",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-10-21T16:45:13.723Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Phares Mike (CSC FI SPS MESLEO)",
                "BusinessValue": 14600,
                "ChangedDate": "2025-01-07T17:17:42.343Z",
                "ClosedDate": "2025-01-07T17:17:42.343Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-20T16:44:55.9Z",
                "Description": null,
                "Effort": 14100,
                "Id": 123056,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.4",
                "Parent": 110731,
                "Priority": 3,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": "2024-10-25T19:55:54.67Z",
                "Revision": 23,
                "RiskReductionMinusOpportunityEnablement": 14600,
                "StartDate": null,
                "State": "Closed",
                "Tags": "ADO",
                "TargetDate": null,
                "TimeCriticality": 15300,
                "Title": "ADO Reporting",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:01:55.633Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-07T17:01:55.633Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:28:09.19Z",
                "Description": "<div><div style=\"box-sizing:border-box;\">Umbrella Epic to capture demand on capacity and visibility of efforts required by IT OS or FI Process Framework.&nbsp;<br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\"><br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\">Examples are: Stealth migration, Win 206 OS upgrade, RHEL upgrade, Creation of UA Orderables, Establishing Service Products and the support processes.&nbsp; </div><div style=\"box-sizing:border-box;\"><br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\">Features should be created for specific topics.&nbsp; </div><br> </div>",
                "Effort": null,
                "Id": 110731,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 2,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 9,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Compliance",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Phares Mike (CSC FI SPS MESLEO)",
                "BusinessValue": 5228,
                "ChangedDate": "2025-01-22T18:11:18.98Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-09-20T16:46:13.073Z",
                "Description": null,
                "Effort": 5228,
                "Id": 123057,
                "IterationPath": "ART SPS",
                "Parent": 110731,
                "Priority": 3,
                "Relations": [],
                "Requester": "Cousten Mark (FE MES P UPE)",
                "ResolvedDate": null,
                "Revision": 32,
                "RiskReductionMinusOpportunityEnablement": 5228,
                "StartDate": null,
                "State": "New",
                "Tags": "EDA",
                "TargetDate": null,
                "TimeCriticality": 5683,
                "Title": "EA DataFramework v4.21.0",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:01:55.633Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-07T17:01:55.633Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:28:09.19Z",
                "Description": "<div><div style=\"box-sizing:border-box;\">Umbrella Epic to capture demand on capacity and visibility of efforts required by IT OS or FI Process Framework.&nbsp;<br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\"><br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\">Examples are: Stealth migration, Win 206 OS upgrade, RHEL upgrade, Creation of UA Orderables, Establishing Service Products and the support processes.&nbsp; </div><div style=\"box-sizing:border-box;\"><br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\">Features should be created for specific topics.&nbsp; </div><br> </div>",
                "Effort": null,
                "Id": 110731,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 2,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 9,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Compliance",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-11-12T19:24:54.8Z",
                "AreaPath": "ART SPS\\LEO",
                "AssignedTo": "Phares Mike (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-11-12T19:24:54.8Z",
                "ClosedDate": "2024-11-12T19:24:54.8Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-20T16:48:59.517Z",
                "Description": "<div>Completed with Mesa see Story&nbsp;123473 </div>",
                "Effort": null,
                "Id": 123058,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.1",
                "Parent": 109726,
                "Priority": 3,
                "Relations": [],
                "Requester": "Phares Mike (CSC FI SPS MESLEO)",
                "ResolvedDate": "2024-11-12T19:24:54.8Z",
                "Revision": 7,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "EDA",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "EA DataFramework v4.21.0",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2024-08-09T18:10:38.49Z",
                "AreaPath": "ART SPS\\LEO",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-07T17:08:47.7Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-09T18:10:30.717Z",
                "Description": "<div><div style=\"box-sizing:border-box;\">Umbrella Epic to capture demand on capacity and visibility of efforts required by IT OS or FI Process Framework.&nbsp;<br> </div><div style=\"box-sizing:border-box;\"><br> </div><div style=\"box-sizing:border-box;\">Examples are: Stealth migration, Win 206 OS upgrade, RHEL upgrade, Creation of UA Orderables, Establishing Service Products and the support processes.&nbsp; </div><div style=\"box-sizing:border-box;\"><br> </div><div style=\"box-sizing:border-box;\">Features should be created for specific topics.&nbsp; </div><br> </div>",
                "Effort": null,
                "Id": 109726,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 2,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 9,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "LEO Compliance",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-10-07T19:11:05.14Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Phares Mike (CSC FI SPS MESLEO)",
                "BusinessValue": 14400,
                "ChangedDate": "2024-11-18T22:00:45.117Z",
                "ClosedDate": "2024-11-18T22:00:45.117Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-20T16:51:12.013Z",
                "Description": null,
                "Effort": 11100,
                "Id": 123060,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.4",
                "Parent": 110731,
                "Priority": 3,
                "Relations": [],
                "Requester": "Cousten Mark (FE MES P UPE)",
                "ResolvedDate": "2024-10-28T14:48:52.73Z",
                "Revision": 23,
                "RiskReductionMinusOpportunityEnablement": 14400,
                "StartDate": null,
                "State": "Closed",
                "Tags": "EAF",
                "TargetDate": null,
                "TimeCriticality": 15100,
                "Title": "EAF Runtime Release v2.57.0",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:01:55.633Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-07T17:01:55.633Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:28:09.19Z",
                "Description": "<div><div style=\"box-sizing:border-box;\">Umbrella Epic to capture demand on capacity and visibility of efforts required by IT OS or FI Process Framework.&nbsp;<br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\"><br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\">Examples are: Stealth migration, Win 206 OS upgrade, RHEL upgrade, Creation of UA Orderables, Establishing Service Products and the support processes.&nbsp; </div><div style=\"box-sizing:border-box;\"><br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\">Features should be created for specific topics.&nbsp; </div><br> </div>",
                "Effort": null,
                "Id": 110731,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 2,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 9,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Compliance",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Phares Mike (CSC FI SPS MESLEO)",
                "BusinessValue": 5152,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-09-20T16:52:05.903Z",
                "Description": null,
                "Effort": 1683,
                "Id": 123061,
                "IterationPath": "ART SPS",
                "Parent": 110731,
                "Priority": 3,
                "Relations": [],
                "Requester": "Burboz Surge (IT OS IC WA AME)",
                "ResolvedDate": null,
                "Revision": 16,
                "RiskReductionMinusOpportunityEnablement": 5152,
                "StartDate": null,
                "State": "New",
                "Tags": "InfinityQS",
                "TargetDate": null,
                "TimeCriticality": 5607,
                "Title": "InfinityQS TLS 1.0 Error",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:01:55.633Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-07T17:01:55.633Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:28:09.19Z",
                "Description": "<div><div style=\"box-sizing:border-box;\">Umbrella Epic to capture demand on capacity and visibility of efforts required by IT OS or FI Process Framework.&nbsp;<br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\"><br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\">Examples are: Stealth migration, Win 206 OS upgrade, RHEL upgrade, Creation of UA Orderables, Establishing Service Products and the support processes.&nbsp; </div><div style=\"box-sizing:border-box;\"><br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\">Features should be created for specific topics.&nbsp; </div><br> </div>",
                "Effort": null,
                "Id": 110731,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 2,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 9,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Compliance",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-09-23T23:56:19.383Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-07T18:14:13.42Z",
                "ClosedDate": "2024-09-26T20:27:06.353Z",
                "CommentCount": 2,
                "CreatedDate": "2024-09-20T16:57:32.56Z",
                "Description": null,
                "Effort": null,
                "Id": 123062,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 122826,
                "Priority": 2,
                "Relations": [],
                "Requester": "Siers Madeline (FE CF OPC MM EPI MLOG REC)",
                "ResolvedDate": "2024-09-26T20:27:06.353Z",
                "Revision": 8,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "PTO Form Hanging",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": {
                "ActivatedDate": "2024-09-19T16:11:54.37Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-07T19:26:23.317Z",
                "ClosedDate": "2024-09-26T20:27:37.14Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-19T16:11:19.283Z",
                "Description": "<div>Post Migration remediation of bugs found in OI10 </div>",
                "Effort": null,
                "Id": 122826,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 110731,
                "Priority": 2,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": "2024-09-26T20:27:37.14Z",
                "Revision": 5,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "OI 10 Post Migration Remediation",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-09-23T23:55:39.913Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-07T18:13:54.563Z",
                "ClosedDate": "2024-09-23T23:55:39.913Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-20T16:59:42.723Z",
                "Description": null,
                "Effort": null,
                "Id": 123063,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 122826,
                "Priority": 2,
                "Relations": [],
                "Requester": null,
                "ResolvedDate": "2024-09-23T23:55:39.913Z",
                "Revision": 5,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "NDW_MAIN Menu Events Missing",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": {
                "ActivatedDate": "2024-09-19T16:11:54.37Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-07T19:26:23.317Z",
                "ClosedDate": "2024-09-26T20:27:37.14Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-19T16:11:19.283Z",
                "Description": "<div>Post Migration remediation of bugs found in OI10 </div>",
                "Effort": null,
                "Id": 122826,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 110731,
                "Priority": 2,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": "2024-09-26T20:27:37.14Z",
                "Revision": 5,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "OI 10 Post Migration Remediation",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-09-23T21:15:05.207Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Phares Mike (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-16T17:15:30.36Z",
                "ClosedDate": "2024-10-16T17:15:30.36Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-20T18:24:22.997Z",
                "Description": null,
                "Effort": null,
                "Id": 123068,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.4",
                "Parent": 110729,
                "Priority": 1,
                "Relations": [],
                "Requester": "Clark Nikolas (FE MES P OPR SH A)",
                "ResolvedDate": "2024-10-03T14:30:45.36Z",
                "Revision": 12,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "EAF; OI",
                "TargetDate": null,
                "TimeCriticality": 2,
                "Title": "Speed up BioRad Stratus Data Transfer",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-10-10T17:46:44.803Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-15T16:54:00.333Z",
                "ClosedDate": "2024-10-15T16:54:00.333Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-20T18:53:04.813Z",
                "Description": null,
                "Effort": null,
                "Id": 123071,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.4",
                "Parent": 110736,
                "Priority": 1,
                "Relations": [],
                "Requester": null,
                "ResolvedDate": "2024-10-15T16:54:00.333Z",
                "Revision": 8,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Restore supplement notifications",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": {
                "ActivatedDate": "2024-10-09T19:01:29.81Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-20T22:14:44.74Z",
                "ClosedDate": "2024-10-24T04:17:48.943Z",
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:54:04.393Z",
                "Description": "<div>MES Operations Support </div>",
                "Effort": null,
                "Id": 110736,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.4",
                "Parent": 110732,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": "2024-10-24T04:17:48.943Z",
                "Revision": 5,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "Mesa",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "MES Operations Support 2024\\PI3\\Sprint 3.4",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "User Story"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-09-20T21:11:19.997Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-07T18:14:00.96Z",
                "ClosedDate": "2024-09-20T21:11:19.997Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-20T21:11:12.62Z",
                "Description": null,
                "Effort": null,
                "Id": 123074,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 122826,
                "Priority": 2,
                "Relations": [],
                "Requester": "Cousten Mark (FE MES P UPE)",
                "ResolvedDate": "2024-09-20T21:11:19.997Z",
                "Revision": 5,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Prod Spec Query Form Broken",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": {
                "ActivatedDate": "2024-09-19T16:11:54.37Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-07T19:26:23.317Z",
                "ClosedDate": "2024-09-26T20:27:37.14Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-19T16:11:19.283Z",
                "Description": "<div>Post Migration remediation of bugs found in OI10 </div>",
                "Effort": null,
                "Id": 122826,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 110731,
                "Priority": 2,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": "2024-09-26T20:27:37.14Z",
                "Revision": 5,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "OI 10 Post Migration Remediation",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-09-20T21:20:05Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-07T18:13:31.297Z",
                "ClosedDate": "2024-09-20T21:20:13.467Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-20T21:16:15.24Z",
                "Description": null,
                "Effort": null,
                "Id": 123075,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 122826,
                "Priority": 2,
                "Relations": [],
                "Requester": "Munoz Tiffany (FE MES P OPR SH B)",
                "ResolvedDate": "2024-09-20T21:20:13.467Z",
                "Revision": 7,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Employee Badge Printing Not Working",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": {
                "ActivatedDate": "2024-09-19T16:11:54.37Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-07T19:26:23.317Z",
                "ClosedDate": "2024-09-26T20:27:37.14Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-19T16:11:19.283Z",
                "Description": "<div>Post Migration remediation of bugs found in OI10 </div>",
                "Effort": null,
                "Id": 122826,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 110731,
                "Priority": 2,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": "2024-09-26T20:27:37.14Z",
                "Revision": 5,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "OI 10 Post Migration Remediation",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-09-20T21:26:40.993Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-07T18:15:21.33Z",
                "ClosedDate": "2024-09-20T21:26:40.993Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-20T21:26:28.37Z",
                "Description": null,
                "Effort": null,
                "Id": 123076,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 122826,
                "Priority": 2,
                "Relations": [],
                "Requester": "Sperling Jonathon (FE MES P OPR SH A)",
                "ResolvedDate": "2024-09-20T21:26:40.993Z",
                "Revision": 5,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Supplement Prompt being presented on EpiPro Runs when not assigned",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": {
                "ActivatedDate": "2024-09-19T16:11:54.37Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-07T19:26:23.317Z",
                "ClosedDate": "2024-09-26T20:27:37.14Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-19T16:11:19.283Z",
                "Description": "<div>Post Migration remediation of bugs found in OI10 </div>",
                "Effort": null,
                "Id": 122826,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 110731,
                "Priority": 2,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": "2024-09-26T20:27:37.14Z",
                "Revision": 5,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "OI 10 Post Migration Remediation",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-09-20T22:47:29.86Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-07T18:15:26.87Z",
                "ClosedDate": "2024-09-20T22:47:29.86Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-20T22:47:04.87Z",
                "Description": null,
                "Effort": null,
                "Id": 123077,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 122826,
                "Priority": 2,
                "Relations": [],
                "Requester": "Sperling Jonathon (FE MES P OPR SH A)",
                "ResolvedDate": "2024-09-20T22:47:29.86Z",
                "Revision": 4,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Supplements are not able to be assigned to multiple lots at once",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": {
                "ActivatedDate": "2024-09-19T16:11:54.37Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-07T19:26:23.317Z",
                "ClosedDate": "2024-09-26T20:27:37.14Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-19T16:11:19.283Z",
                "Description": "<div>Post Migration remediation of bugs found in OI10 </div>",
                "Effort": null,
                "Id": 122826,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 110731,
                "Priority": 2,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": "2024-09-26T20:27:37.14Z",
                "Revision": 5,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "OI 10 Post Migration Remediation",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-09-20T22:54:40.86Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Ouellette Jonathan (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-07T18:13:24.96Z",
                "ClosedDate": "2024-09-20T22:54:40.86Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-20T22:54:30.06Z",
                "Description": null,
                "Effort": null,
                "Id": 123079,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 122826,
                "Priority": 2,
                "Relations": [],
                "Requester": null,
                "ResolvedDate": "2024-09-20T22:54:40.86Z",
                "Revision": 5,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Some services not showing up in Service Manager",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": {
                "ActivatedDate": "2024-09-19T16:11:54.37Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-07T19:26:23.317Z",
                "ClosedDate": "2024-09-26T20:27:37.14Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-19T16:11:19.283Z",
                "Description": "<div>Post Migration remediation of bugs found in OI10 </div>",
                "Effort": null,
                "Id": 122826,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 110731,
                "Priority": 2,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": "2024-09-26T20:27:37.14Z",
                "Revision": 5,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "OI 10 Post Migration Remediation",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-09-20T22:57:21.887Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Ouellette Jonathan (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-07T18:13:03.79Z",
                "ClosedDate": "2024-09-20T22:57:21.887Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-20T22:57:05.14Z",
                "Description": null,
                "Effort": null,
                "Id": 123080,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 122826,
                "Priority": 2,
                "Relations": [],
                "Requester": null,
                "ResolvedDate": "2024-09-20T22:57:21.887Z",
                "Revision": 5,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Material Track not showing all work orders",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": {
                "ActivatedDate": "2024-09-19T16:11:54.37Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-07T19:26:23.317Z",
                "ClosedDate": "2024-09-26T20:27:37.14Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-19T16:11:19.283Z",
                "Description": "<div>Post Migration remediation of bugs found in OI10 </div>",
                "Effort": null,
                "Id": 122826,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 110731,
                "Priority": 2,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": "2024-09-26T20:27:37.14Z",
                "Revision": 5,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "OI 10 Post Migration Remediation",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-09-20T22:59:43.813Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Ouellette Jonathan (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-07T18:12:48.173Z",
                "ClosedDate": "2024-09-20T22:59:43.813Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-20T22:59:37.337Z",
                "Description": null,
                "Effort": null,
                "Id": 123081,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 122826,
                "Priority": 2,
                "Relations": [],
                "Requester": null,
                "ResolvedDate": "2024-09-20T22:59:43.813Z",
                "Revision": 6,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "COC files are not getting created",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": {
                "ActivatedDate": "2024-09-19T16:11:54.37Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-07T19:26:23.317Z",
                "ClosedDate": "2024-09-26T20:27:37.14Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-19T16:11:19.283Z",
                "Description": "<div>Post Migration remediation of bugs found in OI10 </div>",
                "Effort": null,
                "Id": 122826,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 110731,
                "Priority": 2,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": "2024-09-26T20:27:37.14Z",
                "Revision": 5,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "OI 10 Post Migration Remediation",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-09-20T23:02:38.82Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-07T18:13:37.94Z",
                "ClosedDate": "2024-09-20T23:02:38.82Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-20T23:02:32.157Z",
                "Description": null,
                "Effort": null,
                "Id": 123082,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 122826,
                "Priority": 2,
                "Relations": [],
                "Requester": null,
                "ResolvedDate": "2024-09-20T23:02:38.82Z",
                "Revision": 4,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Internal OI Messaging Form Issue",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": {
                "ActivatedDate": "2024-09-19T16:11:54.37Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-07T19:26:23.317Z",
                "ClosedDate": "2024-09-26T20:27:37.14Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-19T16:11:19.283Z",
                "Description": "<div>Post Migration remediation of bugs found in OI10 </div>",
                "Effort": null,
                "Id": 122826,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 110731,
                "Priority": 2,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": "2024-09-26T20:27:37.14Z",
                "Revision": 5,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "OI 10 Post Migration Remediation",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-09-20T23:04:15.01Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-07T18:13:43.34Z",
                "ClosedDate": "2024-09-20T23:04:15.01Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-20T23:04:00.02Z",
                "Description": null,
                "Effort": null,
                "Id": 123083,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 122826,
                "Priority": 2,
                "Relations": [],
                "Requester": "Sperling Jonathon (FE MES P OPR SH A)",
                "ResolvedDate": "2024-09-20T23:04:15.01Z",
                "Revision": 4,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Long Load time when signing RDS load using barcode scanners",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": {
                "ActivatedDate": "2024-09-19T16:11:54.37Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-07T19:26:23.317Z",
                "ClosedDate": "2024-09-26T20:27:37.14Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-19T16:11:19.283Z",
                "Description": "<div>Post Migration remediation of bugs found in OI10 </div>",
                "Effort": null,
                "Id": 122826,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 110731,
                "Priority": 2,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": "2024-09-26T20:27:37.14Z",
                "Revision": 5,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "OI 10 Post Migration Remediation",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-09-20T23:07:05.89Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-07T18:15:16.09Z",
                "ClosedDate": "2024-09-20T23:07:05.89Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-20T23:06:57.143Z",
                "Description": null,
                "Effort": null,
                "Id": 123084,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 122826,
                "Priority": 2,
                "Relations": [],
                "Requester": "Yazzie Caroline (FE CF OPC MM EPI MLOG REC)",
                "ResolvedDate": "2024-09-20T23:07:05.89Z",
                "Revision": 4,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Receiving Form Error",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": {
                "ActivatedDate": "2024-09-19T16:11:54.37Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-07T19:26:23.317Z",
                "ClosedDate": "2024-09-26T20:27:37.14Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-19T16:11:19.283Z",
                "Description": "<div>Post Migration remediation of bugs found in OI10 </div>",
                "Effort": null,
                "Id": 122826,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 110731,
                "Priority": 2,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": "2024-09-26T20:27:37.14Z",
                "Revision": 5,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "OI 10 Post Migration Remediation",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-09-20T23:09:14.217Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-07T18:13:49.1Z",
                "ClosedDate": "2024-09-20T23:09:14.217Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-20T23:09:07.2Z",
                "Description": null,
                "Effort": null,
                "Id": 123085,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 122826,
                "Priority": 2,
                "Relations": [],
                "Requester": null,
                "ResolvedDate": "2024-09-20T23:09:14.217Z",
                "Revision": 4,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "NCR Multiselect not working",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": {
                "ActivatedDate": "2024-09-19T16:11:54.37Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-07T19:26:23.317Z",
                "ClosedDate": "2024-09-26T20:27:37.14Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-19T16:11:19.283Z",
                "Description": "<div>Post Migration remediation of bugs found in OI10 </div>",
                "Effort": null,
                "Id": 122826,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 110731,
                "Priority": 2,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": "2024-09-26T20:27:37.14Z",
                "Revision": 5,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "OI 10 Post Migration Remediation",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-09-20T23:11:57.103Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-07T18:15:10.527Z",
                "ClosedDate": "2024-09-20T23:11:57.103Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-20T23:11:45.77Z",
                "Description": null,
                "Effort": null,
                "Id": 123086,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 122826,
                "Priority": 2,
                "Relations": [],
                "Requester": null,
                "ResolvedDate": "2024-09-20T23:11:57.103Z",
                "Revision": 4,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Reactor Mode Change Freezing Up",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": {
                "ActivatedDate": "2024-09-19T16:11:54.37Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-07T19:26:23.317Z",
                "ClosedDate": "2024-09-26T20:27:37.14Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-19T16:11:19.283Z",
                "Description": "<div>Post Migration remediation of bugs found in OI10 </div>",
                "Effort": null,
                "Id": 122826,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 110731,
                "Priority": 2,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": "2024-09-26T20:27:37.14Z",
                "Revision": 5,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "OI 10 Post Migration Remediation",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-09-20T23:17:02.1Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-07T18:14:06.603Z",
                "ClosedDate": "2024-09-20T23:17:02.1Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-20T23:16:53.42Z",
                "Description": null,
                "Effort": null,
                "Id": 123087,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 122826,
                "Priority": 2,
                "Relations": [],
                "Requester": null,
                "ResolvedDate": "2024-09-20T23:17:02.1Z",
                "Revision": 4,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "PTI, PTO, and Packaging forms hanging",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": {
                "ActivatedDate": "2024-09-19T16:11:54.37Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-07T19:26:23.317Z",
                "ClosedDate": "2024-09-26T20:27:37.14Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-19T16:11:19.283Z",
                "Description": "<div>Post Migration remediation of bugs found in OI10 </div>",
                "Effort": null,
                "Id": 122826,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 110731,
                "Priority": 2,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": "2024-09-26T20:27:37.14Z",
                "Revision": 5,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "OI 10 Post Migration Remediation",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-09-20T23:19:11.733Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Ouellette Jonathan (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-07T18:12:56.997Z",
                "ClosedDate": "2024-09-20T23:19:11.733Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-20T23:19:00.933Z",
                "Description": null,
                "Effort": null,
                "Id": 123088,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 122826,
                "Priority": 2,
                "Relations": [],
                "Requester": null,
                "ResolvedDate": "2024-09-20T23:19:11.733Z",
                "Revision": 5,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "EpiPro RDS Layer Tab Issue",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": {
                "ActivatedDate": "2024-09-19T16:11:54.37Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-07T19:26:23.317Z",
                "ClosedDate": "2024-09-26T20:27:37.14Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-19T16:11:19.283Z",
                "Description": "<div>Post Migration remediation of bugs found in OI10 </div>",
                "Effort": null,
                "Id": 122826,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 110731,
                "Priority": 2,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": "2024-09-26T20:27:37.14Z",
                "Revision": 5,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "OI 10 Post Migration Remediation",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-09-20T23:21:07.41Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-07T18:14:21.347Z",
                "ClosedDate": "2024-09-20T23:21:12.99Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-20T23:20:58.873Z",
                "Description": null,
                "Effort": null,
                "Id": 123089,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 122826,
                "Priority": 2,
                "Relations": [],
                "Requester": null,
                "ResolvedDate": "2024-09-20T23:21:07.41Z",
                "Revision": 5,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Reactor Log Report Date Field Missing",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": {
                "ActivatedDate": "2024-09-19T16:11:54.37Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-07T19:26:23.317Z",
                "ClosedDate": "2024-09-26T20:27:37.14Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-19T16:11:19.283Z",
                "Description": "<div>Post Migration remediation of bugs found in OI10 </div>",
                "Effort": null,
                "Id": 122826,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 110731,
                "Priority": 2,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": "2024-09-26T20:27:37.14Z",
                "Revision": 5,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "OI 10 Post Migration Remediation",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-09-20T23:22:18.303Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-07T18:15:32.16Z",
                "ClosedDate": "2024-09-20T23:22:18.303Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-20T23:22:10.683Z",
                "Description": null,
                "Effort": null,
                "Id": 123090,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 122826,
                "Priority": 2,
                "Relations": [],
                "Requester": null,
                "ResolvedDate": "2024-09-20T23:22:18.303Z",
                "Revision": 4,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Wafer Count Metrics form not launching for some users",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": {
                "ActivatedDate": "2024-09-19T16:11:54.37Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-07T19:26:23.317Z",
                "ClosedDate": "2024-09-26T20:27:37.14Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-19T16:11:19.283Z",
                "Description": "<div>Post Migration remediation of bugs found in OI10 </div>",
                "Effort": null,
                "Id": 122826,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 110731,
                "Priority": 2,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": "2024-09-26T20:27:37.14Z",
                "Revision": 5,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "OI 10 Post Migration Remediation",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-09-20T23:24:18.083Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Ouellette Jonathan (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-07T18:13:10.437Z",
                "ClosedDate": "2024-09-20T23:24:18.083Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-20T23:23:58.97Z",
                "Description": null,
                "Effort": null,
                "Id": 123091,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 122826,
                "Priority": 2,
                "Relations": [],
                "Requester": "Sperling Jonathon (FE MES P OPR SH A)",
                "ResolvedDate": "2024-09-20T23:24:18.083Z",
                "Revision": 4,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "RDS_TEST deletion failures",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": {
                "ActivatedDate": "2024-09-19T16:11:54.37Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-07T19:26:23.317Z",
                "ClosedDate": "2024-09-26T20:27:37.14Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-19T16:11:19.283Z",
                "Description": "<div>Post Migration remediation of bugs found in OI10 </div>",
                "Effort": null,
                "Id": 122826,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": 110731,
                "Priority": 2,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": "2024-09-26T20:27:37.14Z",
                "Revision": 5,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "OI 10 Post Migration Remediation",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-09-23T15:13:19.27Z",
                "AreaPath": "ART SPS\\LEO",
                "AssignedTo": "Buuck Travis (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-17T17:07:32.49Z",
                "ClosedDate": "2024-10-17T17:07:32.49Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-23T15:11:07.17Z",
                "Description": "<div>Requested by Bruce C, to aid in new Xray equipment purchase discussion. </div><div>9/23/24 TB - In UAT as of today. </div>",
                "Effort": null,
                "Id": 123460,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.4",
                "Parent": 109724,
                "Priority": 2,
                "Relations": [],
                "Requester": "Cordio Bruce (PSS HiRel QM QA)",
                "ResolvedDate": "2024-10-17T17:07:32.49Z",
                "Revision": 6,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "Tableau",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "New Tableau report 'Teststep_Fail_by_Package'",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:08:00.113Z",
                "AreaPath": "ART SPS\\LEO",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-07T17:08:00.113Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-09T17:56:59.233Z",
                "Description": "<div>Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp; </div>",
                "Effort": null,
                "Id": 109724,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "LEO Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-09-26T22:12:19.307Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Ouellette Jonathan (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-04T18:30:01.397Z",
                "ClosedDate": "2024-10-04T18:30:01.397Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-26T19:18:45.65Z",
                "Description": null,
                "Effort": null,
                "Id": 124441,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": null,
                "Priority": 4,
                "Relations": [],
                "Requester": null,
                "ResolvedDate": "2024-09-26T22:12:21.2Z",
                "Revision": 6,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": null,
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "FQA Wafer thickness not highlighting MU wafers",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": null,
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-10-01T21:28:52.847Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Ouellette Jonathan (CSC FI SPS MESLEO)",
                "BusinessValue": 1,
                "ChangedDate": "2024-10-08T18:07:46.42Z",
                "ClosedDate": "2024-10-08T18:07:46.42Z",
                "CommentCount": 0,
                "CreatedDate": "2024-09-27T23:02:30.58Z",
                "Description": "<div>Migrate Villach parts to from old Epi Parts to ZPVM Epi Part numbers </div>",
                "Effort": 1,
                "Id": 124703,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.4",
                "Parent": 125999,
                "Priority": 1,
                "Relations": [],
                "Requester": "Cousten Mark (FE MES P UPE)",
                "ResolvedDate": "2024-10-08T18:07:46.42Z",
                "Revision": 5,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": 1,
                "Title": "ZPVM Part Number Migration",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": null,
                "ChangedDate": "2024-10-16T17:59:06.267Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-10-02T16:22:39.967Z",
                "Description": null,
                "Effort": null,
                "Id": 125999,
                "IterationPath": "ART SPS",
                "Parent": null,
                "Priority": 4,
                "Relations": [],
                "Requester": null,
                "ResolvedDate": null,
                "Revision": 9,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Removed",
                "Tags": null,
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "125999",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-10-07T19:30:50.183Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": 17500,
                "ChangedDate": "2024-10-25T15:35:14.803Z",
                "ClosedDate": "2024-10-25T15:35:14.803Z",
                "CommentCount": 0,
                "CreatedDate": "2024-10-02T16:58:16.033Z",
                "Description": "<div>Fabtime has the ability to generate charts based on a shift calendar, which enables additional reporting such as month-over-month, year-over-year, etc. OpenInsight needs to generate this shift calendar table based off of the fiscal year table and export it to the Scrape DB. </div>",
                "Effort": 10000,
                "Id": 126000,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.4",
                "Parent": 110729,
                "Priority": 1,
                "Relations": [],
                "Requester": "O'Toole Derek (FE MES P MNT SH)",
                "ResolvedDate": "2024-10-25T15:35:14.803Z",
                "Revision": 20,
                "RiskReductionMinusOpportunityEnablement": 17300,
                "StartDate": null,
                "State": "Closed",
                "Tags": "FabTime; OI",
                "TargetDate": null,
                "TimeCriticality": 17600,
                "Title": "Enable different time units",
                "Violation": null,
                "WeightedShortestJobFirst": 6765,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": 5835,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-10-02T18:54:42.607Z",
                "Description": null,
                "Effort": 13759,
                "Id": 126003,
                "IterationPath": "ART SPS",
                "Parent": 125995,
                "Priority": 2,
                "Relations": [],
                "Requester": "Fuentes Jessica (FE MES P OPR)",
                "ResolvedDate": null,
                "Revision": 17,
                "RiskReductionMinusOpportunityEnablement": 5835,
                "StartDate": null,
                "State": "New",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": 13456,
                "Title": "Tag Unsigning of RDS events as a Rework step.",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2024-10-08T18:18:28.39Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Ouellette Jonathan (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-20T16:04:30.89Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-10-02T16:13:40.957Z",
                "Description": null,
                "Effort": null,
                "Id": 125995,
                "IterationPath": "ART SPS",
                "Parent": null,
                "Priority": 2,
                "Relations": [],
                "Requester": "Fuentes Jessica (FE MES P OPR)",
                "ResolvedDate": null,
                "Revision": 10,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Active",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "OpenInsight WIP Remediation",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-10-10T16:41:33.59Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Ouellette Jonathan (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-11T20:06:11.227Z",
                "ClosedDate": "2024-10-10T16:41:33.59Z",
                "CommentCount": 0,
                "CreatedDate": "2024-10-02T18:55:42.813Z",
                "Description": null,
                "Effort": null,
                "Id": 126004,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.4",
                "Parent": 110729,
                "Priority": 2,
                "Relations": [],
                "Requester": "O'Toole Derek (FE MES P MNT SH)",
                "ResolvedDate": "2024-10-10T16:41:33.59Z",
                "Revision": 5,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Add tools to Fabtimes REACTOR_MODEs table",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": 5759,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-10-02T18:56:29.18Z",
                "Description": null,
                "Effort": 13152,
                "Id": 126005,
                "IterationPath": "ART SPS",
                "Parent": 125995,
                "Priority": 2,
                "Relations": [],
                "Requester": "Fuentes Jessica (FE MES P OPR)",
                "ResolvedDate": null,
                "Revision": 17,
                "RiskReductionMinusOpportunityEnablement": 5759,
                "StartDate": null,
                "State": "New",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": 8076,
                "Title": "Closure milestone for EpiPro RDS",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2024-10-08T18:18:28.39Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Ouellette Jonathan (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-20T16:04:30.89Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-10-02T16:13:40.957Z",
                "Description": null,
                "Effort": null,
                "Id": 125995,
                "IterationPath": "ART SPS",
                "Parent": null,
                "Priority": 2,
                "Relations": [],
                "Requester": "Fuentes Jessica (FE MES P OPR)",
                "ResolvedDate": null,
                "Revision": 10,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Active",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "OpenInsight WIP Remediation",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-10-02T18:59:39.577Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Ouellette Jonathan (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-05T00:44:15.18Z",
                "ClosedDate": "2024-10-05T00:44:15.18Z",
                "CommentCount": 0,
                "CreatedDate": "2024-10-02T18:59:33.403Z",
                "Description": null,
                "Effort": null,
                "Id": 126006,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": null,
                "Priority": 4,
                "Relations": [],
                "Requester": null,
                "ResolvedDate": "2024-10-05T00:44:15.18Z",
                "Revision": 7,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": null,
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Erroneous lots at packaging step in fabtime",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": null,
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": 20152,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-10-02T19:08:47.567Z",
                "Description": null,
                "Effort": 20304,
                "Id": 126007,
                "IterationPath": "ART SPS",
                "Parent": 125997,
                "Priority": 1,
                "Relations": [],
                "Requester": "Holland Justin (FE MES P OPR SH C)",
                "ResolvedDate": null,
                "Revision": 23,
                "RiskReductionMinusOpportunityEnablement": 20228,
                "StartDate": null,
                "State": "New",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": 20076,
                "Title": "2nd FQA verification needed for re-packaging and re-entry in cleanroom/PTO scan.",
                "Violation": null,
                "WeightedShortestJobFirst": 2,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2024-10-02T19:06:58.08Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Ouellette Jonathan (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-20T16:04:38.93Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-10-02T16:14:01.85Z",
                "Description": "<div><span style=\"display:inline !important;\">Track rework from FG inv</span><br style=\"box-sizing:border-box;\"><span style=\"display:inline !important;\">&nbsp;</span><br style=\"box-sizing:border-box;\"><span style=\"display:inline !important;\">Consolidation of requests 56, 325, 628, 766 and 802. All identify at least one use-case for Rework from FG.</span><br> </div>",
                "Effort": null,
                "Id": 125997,
                "IterationPath": "ART SPS\\2024\\PI3",
                "Parent": null,
                "Priority": 2,
                "Relations": [],
                "Requester": "Holland Justin (FE MES P OPR SH C)",
                "ResolvedDate": null,
                "Revision": 10,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Active",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "OpenInsight Finished Goods Re-Processing",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": 20076,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-10-02T19:10:56.847Z",
                "Description": null,
                "Effort": 20152,
                "Id": 126008,
                "IterationPath": "ART SPS",
                "Parent": 125997,
                "Priority": 2,
                "Relations": [],
                "Requester": "Holland Justin (FE MES P OPR SH C)",
                "ResolvedDate": null,
                "Revision": 17,
                "RiskReductionMinusOpportunityEnablement": 20152,
                "StartDate": null,
                "State": "New",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": 20000,
                "Title": "Allow for metrology on Return to Fab lots",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2024-10-02T19:06:58.08Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Ouellette Jonathan (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-20T16:04:38.93Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-10-02T16:14:01.85Z",
                "Description": "<div><span style=\"display:inline !important;\">Track rework from FG inv</span><br style=\"box-sizing:border-box;\"><span style=\"display:inline !important;\">&nbsp;</span><br style=\"box-sizing:border-box;\"><span style=\"display:inline !important;\">Consolidation of requests 56, 325, 628, 766 and 802. All identify at least one use-case for Rework from FG.</span><br> </div>",
                "Effort": null,
                "Id": 125997,
                "IterationPath": "ART SPS\\2024\\PI3",
                "Parent": null,
                "Priority": 2,
                "Relations": [],
                "Requester": "Holland Justin (FE MES P OPR SH C)",
                "ResolvedDate": null,
                "Revision": 10,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Active",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "OpenInsight Finished Goods Re-Processing",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2025-01-17T16:06:00.487Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Ouellette Jonathan (CSC FI SPS MESLEO)",
                "BusinessValue": 13152,
                "ChangedDate": "2025-01-20T21:58:55.097Z",
                "ClosedDate": "2025-01-20T21:58:55.097Z",
                "CommentCount": 2,
                "CreatedDate": "2024-10-02T19:11:47.45Z",
                "Description": null,
                "Effort": 5152,
                "Id": 126009,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": 125997,
                "Priority": 2,
                "Relations": [],
                "Requester": "Holland Justin (FE MES P OPR SH C)",
                "ResolvedDate": "2025-01-20T21:58:55.097Z",
                "Revision": 23,
                "RiskReductionMinusOpportunityEnablement": 13228,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": 13304,
                "Title": "Digitalize the Return To Fab Form",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2024-10-02T19:06:58.08Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Ouellette Jonathan (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-20T16:04:38.93Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-10-02T16:14:01.85Z",
                "Description": "<div><span style=\"display:inline !important;\">Track rework from FG inv</span><br style=\"box-sizing:border-box;\"><span style=\"display:inline !important;\">&nbsp;</span><br style=\"box-sizing:border-box;\"><span style=\"display:inline !important;\">Consolidation of requests 56, 325, 628, 766 and 802. All identify at least one use-case for Rework from FG.</span><br> </div>",
                "Effort": null,
                "Id": 125997,
                "IterationPath": "ART SPS\\2024\\PI3",
                "Parent": null,
                "Priority": 2,
                "Relations": [],
                "Requester": "Holland Justin (FE MES P OPR SH C)",
                "ResolvedDate": null,
                "Revision": 10,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Active",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "OpenInsight Finished Goods Re-Processing",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-10-02T22:54:27.697Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Ouellette Jonathan (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-02T22:54:29.857Z",
                "ClosedDate": "2024-10-02T22:54:29.857Z",
                "CommentCount": 0,
                "CreatedDate": "2024-10-02T22:31:44.943Z",
                "Description": null,
                "Effort": null,
                "Id": 126015,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": null,
                "Priority": 4,
                "Relations": [],
                "Requester": null,
                "ResolvedDate": "2024-10-02T22:54:27.697Z",
                "Revision": 5,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": null,
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Certain features of Mesa Reporting Services do not work in the fab",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": null,
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": 5607,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-10-03T00:06:12.38Z",
                "Description": null,
                "Effort": 20228,
                "Id": 126019,
                "IterationPath": "ART SPS",
                "Parent": 110731,
                "Priority": 2,
                "Relations": [],
                "Requester": "Becker Chad (FE MES QM)",
                "ResolvedDate": null,
                "Revision": 16,
                "RiskReductionMinusOpportunityEnablement": 5607,
                "StartDate": null,
                "State": "New",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": 5987,
                "Title": "Add extra digits to RDS Keys",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:01:55.633Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-07T17:01:55.633Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:28:09.19Z",
                "Description": "<div><div style=\"box-sizing:border-box;\">Umbrella Epic to capture demand on capacity and visibility of efforts required by IT OS or FI Process Framework.&nbsp;<br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\"><br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\">Examples are: Stealth migration, Win 206 OS upgrade, RHEL upgrade, Creation of UA Orderables, Establishing Service Products and the support processes.&nbsp; </div><div style=\"box-sizing:border-box;\"><br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\">Features should be created for specific topics.&nbsp; </div><br> </div>",
                "Effort": null,
                "Id": 110731,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 2,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 9,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Compliance",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": 13607,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-10-03T00:07:07.737Z",
                "Description": null,
                "Effort": 3228,
                "Id": 126020,
                "IterationPath": "ART SPS",
                "Parent": 126018,
                "Priority": 2,
                "Relations": [],
                "Requester": "Becker Chad (FE MES QM)",
                "ResolvedDate": null,
                "Revision": 16,
                "RiskReductionMinusOpportunityEnablement": 13759,
                "StartDate": null,
                "State": "New",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": 8304,
                "Title": "Remove deletion of RDS and related child records at new RDS creation",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2024-10-08T18:17:50.437Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Ouellette Jonathan (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-28T13:24:58.19Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-10-03T00:00:14.323Z",
                "Description": null,
                "Effort": null,
                "Id": 126018,
                "IterationPath": "ART SPS\\2024\\PI4",
                "Parent": null,
                "Priority": 2,
                "Relations": [],
                "Requester": "Becker Chad (FE MES QM)",
                "ResolvedDate": null,
                "Revision": 4,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Active",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "OI Archive",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": 13531,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-10-03T00:08:35.77Z",
                "Description": null,
                "Effort": 13304,
                "Id": 126021,
                "IterationPath": "ART SPS",
                "Parent": 126018,
                "Priority": 2,
                "Relations": [],
                "Requester": "Becker Chad (FE MES QM)",
                "ResolvedDate": null,
                "Revision": 16,
                "RiskReductionMinusOpportunityEnablement": 13683,
                "StartDate": null,
                "State": "New",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": 8228,
                "Title": "Build Method of Removing and Archiving RDS from Production OI",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2024-10-08T18:17:50.437Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Ouellette Jonathan (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-28T13:24:58.19Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-10-03T00:00:14.323Z",
                "Description": null,
                "Effort": null,
                "Id": 126018,
                "IterationPath": "ART SPS\\2024\\PI4",
                "Parent": null,
                "Priority": 2,
                "Relations": [],
                "Requester": "Becker Chad (FE MES QM)",
                "ResolvedDate": null,
                "Revision": 4,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Active",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "OI Archive",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": 13456,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-10-03T00:09:20.823Z",
                "Description": null,
                "Effort": 13228,
                "Id": 126022,
                "IterationPath": "ART SPS",
                "Parent": 126018,
                "Priority": 2,
                "Relations": [],
                "Requester": "Becker Chad (FE MES QM)",
                "ResolvedDate": null,
                "Revision": 16,
                "RiskReductionMinusOpportunityEnablement": 13607,
                "StartDate": null,
                "State": "New",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": 8152,
                "Title": "Build Method of de-archiving and archived RDS",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2024-10-08T18:17:50.437Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Ouellette Jonathan (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-28T13:24:58.19Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-10-03T00:00:14.323Z",
                "Description": null,
                "Effort": null,
                "Id": 126018,
                "IterationPath": "ART SPS\\2024\\PI4",
                "Parent": null,
                "Priority": 2,
                "Relations": [],
                "Requester": "Becker Chad (FE MES QM)",
                "ResolvedDate": null,
                "Revision": 4,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Active",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "OI Archive",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-10-03T18:04:44.33Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Phares Mike (CSC FI SPS MESLEO)",
                "BusinessValue": 13835,
                "ChangedDate": "2025-01-20T22:33:17.833Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-10-03T18:04:08.74Z",
                "Description": "<div><p style=\"margin:0in;font-size:11pt;font-family:Aptos, sans-serif;\"><span style=\"font-size:10.0pt;font-family:&quot;Arial&quot;,sans-serif;\">These\nare formulas that need corrected in the Production, 14pt thick only chart</span> </p><table width=664 style=\"width:498.0pt;margin-left:-.05pt;border-collapse:collapse;\">\n <tbody><tr style=\"height:13.8pt;\">\n  <td width=239 style=\"width:179.0pt;border:solid windowtext 1.0pt;padding:0in 5.4pt 0in 5.4pt;height:13.8pt;\">\n  <p style=\"margin:0in;font-size:11pt;font-family:Aptos, sans-serif;\"><b><span style=\"font-family:&quot;Arial&quot;,sans-serif;color:#1D1D1D;\">Test </span></b> </p>\n  </td>\n  <td width=121 style=\"width:91.0pt;border:solid windowtext 1.0pt;border-left:none;padding:0in 5.4pt 0in 5.4pt;height:13.8pt;\">\n  <p style=\"margin:0in;font-size:11pt;font-family:Aptos, sans-serif;\"><b><span style=\"font-family:&quot;Arial&quot;,sans-serif;color:#1D1D1D;\">Points: </span></b> </p>\n  </td>\n  <td width=221 style=\"width:166.0pt;border:solid windowtext 1.0pt;border-left:none;padding:0in 5.4pt 0in 5.4pt;height:13.8pt;\">\n  <p style=\"margin:0in;font-size:11pt;font-family:Aptos, sans-serif;\"><b><span style=\"font-family:&quot;Arial&quot;,sans-serif;color:#1D1D1D;\">Calculation</span></b> </p>\n  </td>\n  <td width=83 style=\"width:62.0pt;border:solid windowtext 1.0pt;border-left:none;padding:0in 5.4pt 0in 5.4pt;height:13.8pt;\">\n  <p style=\"margin:0in;font-size:11pt;font-family:Aptos, sans-serif;\"><span style=\"font-family:&quot;Arial&quot;,sans-serif;color:#1D1D1D;\">comments</span> </p>\n  </td>\n </tr>\n <tr style=\"height:13.8pt;\">\n  <td width=239 style=\"width:179.0pt;border:solid windowtext 1.0pt;border-top:none;padding:0in 5.4pt 0in 5.4pt;height:13.8pt;\">\n  <p style=\"margin:0in;font-size:11pt;font-family:Aptos, sans-serif;\"><span style=\"font-family:&quot;Arial&quot;,sans-serif;color:#1D1D1D;\">Thick Only R/2 Mean </span> </p>\n  </td>\n  <td width=121 style=\"width:91.0pt;border-top:none;border-left:none;border-bottom:solid windowtext 1.0pt;border-right:solid windowtext 1.0pt;padding:0in 5.4pt 0in 5.4pt;height:13.8pt;\">\n  <p style=\"margin:0in;font-size:11pt;font-family:Aptos, sans-serif;\"><span style=\"font-family:&quot;Arial&quot;,sans-serif;color:#1D1D1D;\">2, 3, 7, 8</span> </p>\n  </td>\n  <td width=221 style=\"width:166.0pt;border-top:none;border-left:none;border-bottom:solid windowtext 1.0pt;border-right:solid windowtext 1.0pt;padding:0in 5.4pt 0in 5.4pt;height:13.8pt;\">\n  <p style=\"margin:0in;font-size:11pt;font-family:Aptos, sans-serif;\"><span style=\"font-family:&quot;Arial&quot;,sans-serif;color:#1D1D1D;\">avg(ch(2),ch(3),ch(7),ch(8))</span> </p>\n  </td>\n  <td width=83 style=\"width:62.0pt;border-top:none;border-left:none;border-bottom:solid windowtext 1.0pt;border-right:solid windowtext 1.0pt;background:yellow;padding:0in 5.4pt 0in 5.4pt;height:13.8pt;\">\n  <p style=\"margin:0in;font-size:11pt;font-family:Aptos, sans-serif;\"><span style=\"font-family:&quot;Arial&quot;,sans-serif;color:#1D1D1D;\">test 18</span> </p>\n  </td>\n </tr>\n <tr style=\"height:13.8pt;\">\n  <td width=239 style=\"width:179.0pt;border:solid windowtext 1.0pt;border-top:none;padding:0in 5.4pt 0in 5.4pt;height:13.8pt;\">\n  <p style=\"margin:0in;font-size:11pt;font-family:Aptos, sans-serif;\"><span style=\"font-family:&quot;Arial&quot;,sans-serif;color:#1D1D1D;\">Thickness Only 5mm Edge Mean </span> </p>\n  </td>\n  <td width=121 style=\"width:91.0pt;border-top:none;border-left:none;border-bottom:solid windowtext 1.0pt;border-right:solid windowtext 1.0pt;padding:0in 5.4pt 0in 5.4pt;height:13.8pt;\">\n  <p style=\"margin:0in;font-size:11pt;font-family:Aptos, sans-serif;\"><span style=\"font-family:&quot;Arial&quot;,sans-serif;color:#1D1D1D;\">1, 10</span> </p>\n  </td>\n  <td width=221 style=\"width:166.0pt;border-top:none;border-left:none;border-bottom:solid windowtext 1.0pt;border-right:solid windowtext 1.0pt;padding:0in 5.4pt 0in 5.4pt;height:13.8pt;\">\n  <p style=\"margin:0in;font-size:11pt;font-family:Aptos, sans-serif;\"><span style=\"font-family:&quot;Arial&quot;,sans-serif;color:#1D1D1D;\">avg(ch(1),ch(10))</span> </p>\n  </td>\n  <td width=83 style=\"width:62.0pt;border-top:none;border-left:none;border-bottom:solid windowtext 1.0pt;border-right:solid windowtext 1.0pt;background:yellow;padding:0in 5.4pt 0in 5.4pt;height:13.8pt;\">\n  <p style=\"margin:0in;font-size:11pt;font-family:Aptos, sans-serif;\"><span style=\"font-family:&quot;Arial&quot;,sans-serif;color:#1D1D1D;\">test 19</span> </p>\n  </td>\n </tr>\n <tr style=\"height:13.8pt;\">\n  <td width=239 style=\"width:179.0pt;border:solid windowtext 1.0pt;border-top:none;padding:0in 5.4pt 0in 5.4pt;height:13.8pt;\">\n  <p style=\"margin:0in;font-size:11pt;font-family:Aptos, sans-serif;\"><span style=\"font-family:&quot;Arial&quot;,sans-serif;color:#1D1D1D;\">Thickness Only 3mm Edge Mean </span> </p>\n  </td>\n  <td width=121 style=\"width:91.0pt;border-top:none;border-left:none;border-bottom:solid windowtext 1.0pt;border-right:solid windowtext 1.0pt;padding:0in 5.4pt 0in 5.4pt;height:13.8pt;\">\n  <p style=\"margin:0in;font-size:11pt;font-family:Aptos, sans-serif;\"><span style=\"font-family:&quot;Arial&quot;,sans-serif;color:#1D1D1D;\">11, 12, 13, 14</span> </p>\n  </td>\n  <td width=221 style=\"width:166.0pt;border-top:none;border-left:none;border-bottom:solid windowtext 1.0pt;border-right:solid windowtext 1.0pt;padding:0in 5.4pt 0in 5.4pt;height:13.8pt;\">\n  <p style=\"margin:0in;font-size:11pt;font-family:Aptos, sans-serif;\"><span style=\"font-family:&quot;Arial&quot;,sans-serif;color:#1D1D1D;\">avg(ch(11):ch(14))</span> </p>\n  </td>\n  <td width=83 style=\"width:62.0pt;border-top:none;border-left:none;border-bottom:solid windowtext 1.0pt;border-right:solid windowtext 1.0pt;background:yellow;padding:0in 5.4pt 0in 5.4pt;height:13.8pt;\">\n  <p style=\"margin:0in;font-size:11pt;font-family:Aptos, sans-serif;\"><span style=\"font-family:&quot;Arial&quot;,sans-serif;color:#1D1D1D;\">test 20 </span> </p>\n  </td>\n </tr>\n <tr style=\"height:13.8pt;\">\n  <td width=239 style=\"width:179.0pt;border:solid windowtext 1.0pt;border-top:none;padding:0in 5.4pt 0in 5.4pt;height:13.8pt;\">\n  <p style=\"margin:0in;font-size:11pt;font-family:Aptos, sans-serif;\"><span style=\"font-family:&quot;Arial&quot;,sans-serif;color:#1D1D1D;\">5mm Edge % from R/2</span> </p>\n  </td>\n  <td width=121 style=\"width:91.0pt;border-top:none;border-left:none;border-bottom:solid windowtext 1.0pt;border-right:solid windowtext 1.0pt;padding:0in 5.4pt 0in 5.4pt;height:13.8pt;\">\n  <p style=\"margin:0in;font-size:11pt;font-family:Aptos, sans-serif;\"><span style=\"font-family:&quot;Arial&quot;,sans-serif;color:#1D1D1D;\">&nbsp;</span> </p>\n  </td>\n  <td width=221 style=\"width:166.0pt;border-top:none;border-left:none;border-bottom:solid windowtext 1.0pt;border-right:solid windowtext 1.0pt;padding:0in 5.4pt 0in 5.4pt;height:13.8pt;\">\n  <p style=\"margin:0in;font-size:11pt;font-family:Aptos, sans-serif;\"><span style=\"font-family:&quot;Arial&quot;,sans-serif;color:#1D1D1D;\">(((ch(19)-ch(18))/ch(18))*100)</span> </p>\n  </td>\n  <td width=83 style=\"width:62.0pt;border-top:none;border-left:none;border-bottom:solid windowtext 1.0pt;border-right:solid windowtext 1.0pt;padding:0in 5.4pt 0in 5.4pt;height:13.8pt;\">\n  <p style=\"margin:0in;font-size:11pt;font-family:Aptos, sans-serif;\"><span style=\"font-family:&quot;Arial&quot;,sans-serif;color:#1D1D1D;\">&nbsp;</span> </p>\n  </td>\n </tr>\n <tr style=\"height:13.8pt;\">\n  <td width=239 style=\"width:179.0pt;border:solid windowtext 1.0pt;border-top:none;padding:0in 5.4pt 0in 5.4pt;height:13.8pt;\">\n  <p style=\"margin:0in;font-size:11pt;font-family:Aptos, sans-serif;\"><span style=\"font-family:&quot;Arial&quot;,sans-serif;color:#1D1D1D;\">3mm Edge % from R/2</span> </p>\n  </td>\n  <td width=121 style=\"width:91.0pt;border-top:none;border-left:none;border-bottom:solid windowtext 1.0pt;border-right:solid windowtext 1.0pt;padding:0in 5.4pt 0in 5.4pt;height:13.8pt;\">\n  <p style=\"margin:0in;font-size:11pt;font-family:Aptos, sans-serif;\"><span style=\"font-family:&quot;Arial&quot;,sans-serif;color:#1D1D1D;\">&nbsp;</span> </p>\n  </td>\n  <td width=221 style=\"width:166.0pt;border-top:none;border-left:none;border-bottom:solid windowtext 1.0pt;border-right:solid windowtext 1.0pt;padding:0in 5.4pt 0in 5.4pt;height:13.8pt;\">\n  <p style=\"margin:0in;font-size:11pt;font-family:Aptos, sans-serif;\"><span style=\"font-family:&quot;Arial&quot;,sans-serif;color:#1D1D1D;\">(((ch(20)-ch(18))/ch(18))*100)</span> </p>\n  </td>\n  <td width=83 style=\"width:62.0pt;border-top:none;border-left:none;border-bottom:solid windowtext 1.0pt;border-right:solid windowtext 1.0pt;padding:0in 5.4pt 0in 5.4pt;height:13.8pt;\">\n  <p style=\"margin:0in;font-size:11pt;font-family:Aptos, sans-serif;\"><span style=\"font-family:&quot;Arial&quot;,sans-serif;color:#1D1D1D;\">&nbsp;</span> </p>\n  </td>\n </tr></tbody></table><br> </div>",
                "Effort": 13911,
                "Id": 126173,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": 110729,
                "Priority": 2,
                "Relations": [],
                "Requester": "Clark Kelly (FE MES P UPE SH)",
                "ResolvedDate": null,
                "Revision": 19,
                "RiskReductionMinusOpportunityEnablement": 13911,
                "StartDate": null,
                "State": "Active",
                "Tags": "EAF; EDA; InfinityQS; OI; OI Metrology Viewer",
                "TargetDate": null,
                "TimeCriticality": 20152,
                "Title": "New 14 point thickness formula",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-10-04T18:12:12.783Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Ouellette Jonathan (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-04T18:28:04.6Z",
                "ClosedDate": "2024-10-04T18:27:53.86Z",
                "CommentCount": 0,
                "CreatedDate": "2024-10-04T18:12:06.887Z",
                "Description": null,
                "Effort": null,
                "Id": 126434,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.3",
                "Parent": null,
                "Priority": 4,
                "Relations": [],
                "Requester": "Fuentes Jessica (FE MES P OPR)",
                "ResolvedDate": "2024-10-04T18:27:53.86Z",
                "Revision": 7,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": null,
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Invalid Character in Reactor Status -> Work Order value",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": null,
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": 5683,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-10-04T22:51:36Z",
                "Description": "<div>When a lot is fully rejected, but not done using the auto reject, an inventory transaction is not created. This causes the WIP to stay open in FabTime </div>",
                "Effort": 13380,
                "Id": 126451,
                "IterationPath": "ART SPS",
                "Parent": 125995,
                "Priority": 2,
                "Relations": [],
                "Requester": "Fuentes Jessica (FE MES P OPR)",
                "ResolvedDate": null,
                "Revision": 16,
                "RiskReductionMinusOpportunityEnablement": 5683,
                "StartDate": null,
                "State": "New",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": 8000,
                "Title": "Reject Inventory Transaction for Non auto rejects",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2024-10-08T18:18:28.39Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Ouellette Jonathan (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-20T16:04:30.89Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-10-02T16:13:40.957Z",
                "Description": null,
                "Effort": null,
                "Id": 125995,
                "IterationPath": "ART SPS",
                "Parent": null,
                "Priority": 2,
                "Relations": [],
                "Requester": "Fuentes Jessica (FE MES P OPR)",
                "ResolvedDate": null,
                "Revision": 10,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Active",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "OpenInsight WIP Remediation",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-10-07T21:27:27.2Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-31T17:03:48.347Z",
                "ClosedDate": "2024-10-31T15:11:15.807Z",
                "CommentCount": 0,
                "CreatedDate": "2024-10-07T20:37:44.577Z",
                "Description": "<div>Shifts need to be renamed from 1, 2, 3, 4 to A, B, C, D to align with company standards. </div>",
                "Effort": null,
                "Id": 127036,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.4",
                "Parent": 110731,
                "Priority": 1,
                "Relations": [],
                "Requester": "Fuentes Jessica (FE MES P OPR)",
                "ResolvedDate": "2024-10-22T16:13:07.113Z",
                "Revision": 12,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": 1,
                "Title": "Align Shift Nomenclature",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:01:55.633Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-07T17:01:55.633Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:28:09.19Z",
                "Description": "<div><div style=\"box-sizing:border-box;\">Umbrella Epic to capture demand on capacity and visibility of efforts required by IT OS or FI Process Framework.&nbsp;<br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\"><br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\">Examples are: Stealth migration, Win 206 OS upgrade, RHEL upgrade, Creation of UA Orderables, Establishing Service Products and the support processes.&nbsp; </div><div style=\"box-sizing:border-box;\"><br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\">Features should be created for specific topics.&nbsp; </div><br> </div>",
                "Effort": null,
                "Id": 110731,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 2,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 9,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Compliance",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-10-08T18:12:53.743Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Ouellette Jonathan (CSC FI SPS MESLEO)",
                "BusinessValue": 8380,
                "ChangedDate": "2025-01-17T16:07:56.167Z",
                "ClosedDate": "2025-01-17T16:07:56.167Z",
                "CommentCount": 1,
                "CreatedDate": "2024-10-08T18:12:39.993Z",
                "Description": "<div>Provide a scheduled method to perform full OI system backups </div>",
                "Effort": 13456,
                "Id": 127504,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.3",
                "Parent": 126018,
                "Priority": 2,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": "2025-01-17T16:07:56.167Z",
                "Revision": 22,
                "RiskReductionMinusOpportunityEnablement": 8456,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": 13000,
                "Title": "Process for full system backups.",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2024-10-08T18:17:50.437Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Ouellette Jonathan (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-28T13:24:58.19Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-10-03T00:00:14.323Z",
                "Description": null,
                "Effort": null,
                "Id": 126018,
                "IterationPath": "ART SPS\\2024\\PI4",
                "Parent": null,
                "Priority": 2,
                "Relations": [],
                "Requester": "Becker Chad (FE MES QM)",
                "ResolvedDate": null,
                "Revision": 4,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Active",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "OI Archive",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\LEO",
                "AssignedTo": "Phares Mike (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-24T17:49:31.343Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-10-08T22:56:27.59Z",
                "Description": "<div><div style=\"box-sizing:border-box;\">This feature is to implement the standard UWM solution in LEO with the ability to receive emaps from source wafer fab when shipments are made to Leominster.&nbsp; </div><div style=\"box-sizing:border-box;\"><br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\"><span style=\"box-sizing:border-box;display:inline !important;\">Supports adoption of target system standards.</span> </div> </div>",
                "Effort": null,
                "Id": 127519,
                "IterationPath": "ART SPS",
                "Parent": 109728,
                "Priority": 2,
                "Relations": [],
                "Requester": "Pagkaliwangan Angelo (PSS HiRel OP ENG)",
                "ResolvedDate": null,
                "Revision": 7,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "New",
                "Tags": "ART SPS\\MES; UWM",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "UWM @ LEO - Stealth Go Live",
                "Violation": null,
                "WeightedShortestJobFirst": 21,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-24T17:48:28.74Z",
                "AreaPath": "ART SPS\\LEO",
                "AssignedTo": "Phares Mike (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-24T17:48:28.74Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-09T18:24:44.023Z",
                "Description": "<div><div style=\"box-sizing:border-box;\">This feature is to implement the standard UWM solution in LEO with the ability to receive emaps from source wafer fab when shipments are made to Leominster.&nbsp; </div><div style=\"box-sizing:border-box;\"><span style=\"display:inline !important;\"><br></span> </div><div style=\"box-sizing:border-box;\"><span style=\"display:inline !important;\">Includes dependencies on other ART and IT OS.&nbsp;&nbsp;</span><br> </div><div style=\"box-sizing:border-box;\"><br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\"><span style=\"box-sizing:border-box;display:inline !important;\">Supports adoption of target system standards.&nbsp; &nbsp;</span> </div><br> </div>",
                "Effort": null,
                "Id": 109728,
                "IterationPath": "ART SPS",
                "Parent": null,
                "Priority": 2,
                "Relations": [],
                "Requester": "Pagkaliwangan Angelo (PSS HiRel OP ENG)",
                "ResolvedDate": null,
                "Revision": 12,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Active",
                "Tags": null,
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "UWM @LEO",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-10-24T04:14:33.4Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": 15200,
                "ChangedDate": "2024-10-24T15:26:15.29Z",
                "ClosedDate": "2024-10-24T15:26:15.29Z",
                "CommentCount": 2,
                "CreatedDate": "2024-10-09T19:15:33.203Z",
                "Description": "<div>Prove out In Place Upgrade with support from IT OS.&nbsp; </div><div><br> </div><div>Initial servers/owners: </div><div><ul><li>LEO Tableau - Travis&nbsp; </li><li>MES Utility Server - Jonathan </li><li>MES Infinity IQS - Mike </li> </ul> </div>",
                "Effort": 12800,
                "Id": 128016,
                "IterationPath": "ART SPS",
                "Parent": 110752,
                "Priority": 3,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": "2024-10-24T15:26:15.29Z",
                "Revision": 12,
                "RiskReductionMinusOpportunityEnablement": 15200,
                "StartDate": null,
                "State": "Closed",
                "Tags": null,
                "TargetDate": null,
                "TimeCriticality": 10500,
                "Title": "Windows 2016 upgrade - IPU PoC",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2024-09-12T22:55:00.607Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-07T17:06:05.113Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T23:41:08.26Z",
                "Description": "<div>Identify, plan, test and implement server upgrades to 2022 as mandated by IT OS </div>",
                "Effort": null,
                "Id": 110752,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 3,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 8,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-01T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2025-12-18T23:00:00Z",
                "TimeCriticality": null,
                "Title": "Windows 2016 upgrade",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-10-24T14:36:16.963Z",
                "AreaPath": "ART SPS\\LEO",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-24T17:32:46.67Z",
                "ClosedDate": "2024-10-24T14:36:16.963Z",
                "CommentCount": 1,
                "CreatedDate": "2024-10-09T19:35:18.953Z",
                "Description": "<div>Prove out In Place Upgrade with support from IT OS.&nbsp; </div><div><br> </div><div>Initial Servers/Owners:&nbsp; </div><div><ul><li>LEO Tableau - Travis&nbsp; </li><li>MES Utility Server - Jonathan </li><li>MES Infinity QS - Mike&nbsp; </li> </ul> </div>",
                "Effort": null,
                "Id": 128017,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.4",
                "Parent": 109726,
                "Priority": 3,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": "2024-10-24T14:36:16.963Z",
                "Revision": 5,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": null,
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Windows 2016 upgrade - IPU PoC",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2024-08-09T18:10:38.49Z",
                "AreaPath": "ART SPS\\LEO",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-07T17:08:47.7Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-09T18:10:30.717Z",
                "Description": "<div><div style=\"box-sizing:border-box;\">Umbrella Epic to capture demand on capacity and visibility of efforts required by IT OS or FI Process Framework.&nbsp;<br> </div><div style=\"box-sizing:border-box;\"><br> </div><div style=\"box-sizing:border-box;\">Examples are: Stealth migration, Win 206 OS upgrade, RHEL upgrade, Creation of UA Orderables, Establishing Service Products and the support processes.&nbsp; </div><div style=\"box-sizing:border-box;\"><br> </div><div style=\"box-sizing:border-box;\">Features should be created for specific topics.&nbsp; </div><br> </div>",
                "Effort": null,
                "Id": 109726,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 2,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 9,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "LEO Compliance",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-10-16T17:41:55.47Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-20T22:15:00.933Z",
                "ClosedDate": "2024-10-16T17:41:55.47Z",
                "CommentCount": 1,
                "CreatedDate": "2024-10-10T23:05:26.623Z",
                "Description": null,
                "Effort": null,
                "Id": 128460,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Chow Bobby (FE CF OPC MM EPI)",
                "ResolvedDate": "2024-10-16T17:41:55.47Z",
                "Revision": 5,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Reactor number intermittently removed from RDS records",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": null,
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\LEO",
                "AssignedTo": "Belasco Bradd (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-23T18:42:05.01Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-10-14T18:33:57.76Z",
                "Description": "<div><span><span style=\"display:inline !important;\">Following completion of production installation and IT buy-off, deploy the RHEL 9-based YieldHUB upgrade on the EC network and successfully complete all unit and user testing scenarios. &nbsp;When finished we should be ready to schedule the go-live</span><br></span><span></span><br> </div>",
                "Effort": null,
                "Id": 129212,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": 109726,
                "Priority": 2,
                "Relations": [],
                "Requester": null,
                "ResolvedDate": null,
                "Revision": 10,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "New",
                "Tags": "YieldHUB",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "YieldHub RHEL9 upgrade - Production Deployment",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2024-08-09T18:10:38.49Z",
                "AreaPath": "ART SPS\\LEO",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-07T17:08:47.7Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-09T18:10:30.717Z",
                "Description": "<div><div style=\"box-sizing:border-box;\">Umbrella Epic to capture demand on capacity and visibility of efforts required by IT OS or FI Process Framework.&nbsp;<br> </div><div style=\"box-sizing:border-box;\"><br> </div><div style=\"box-sizing:border-box;\">Examples are: Stealth migration, Win 206 OS upgrade, RHEL upgrade, Creation of UA Orderables, Establishing Service Products and the support processes.&nbsp; </div><div style=\"box-sizing:border-box;\"><br> </div><div style=\"box-sizing:border-box;\">Features should be created for specific topics.&nbsp; </div><br> </div>",
                "Effort": null,
                "Id": 109726,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 2,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 9,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "LEO Compliance",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Tucker Chase (CSC FI SPS MESLEO)",
                "BusinessValue": 8076,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-10-14T19:34:09.817Z",
                "Description": "<div>Give an MRB originator the ability to create multiple actions at the same time. </div>",
                "Effort": 3456,
                "Id": 129218,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 2,
                "Relations": [],
                "Requester": "McIntyre Juanita (FE MES QM)",
                "ResolvedDate": null,
                "Revision": 19,
                "RiskReductionMinusOpportunityEnablement": 8076,
                "StartDate": null,
                "State": "New",
                "Tags": "Fab Approval",
                "TargetDate": null,
                "TimeCriticality": 5835,
                "Title": "Create Multiple MRB Actions Simultaneously",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2025-01-06T22:25:10.63Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Phares Mike (CSC FI SPS MESLEO)",
                "BusinessValue": 5531,
                "ChangedDate": "2025-01-06T22:25:10.63Z",
                "ClosedDate": null,
                "CommentCount": 3,
                "CreatedDate": "2024-10-15T14:20:10.54Z",
                "Description": "<div>All&nbsp;<span style=\"font-size:10.0pt;font-family:&quot;Arial&quot;,sans-serif;\">ServicePortfolioManager application for Mesa and Leominster have been requested.</span> </div>",
                "Effort": 2683,
                "Id": 129630,
                "IterationPath": "ART SPS",
                "Parent": 110731,
                "Priority": 3,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": "2025-01-06T22:25:10.63Z",
                "Revision": 22,
                "RiskReductionMinusOpportunityEnablement": 5531,
                "StartDate": null,
                "State": "Resolved",
                "Tags": "ADO",
                "TargetDate": null,
                "TimeCriticality": 1304,
                "Title": "Migrate MESA_FI to FactoryIntegration",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:01:55.633Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-07T17:01:55.633Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:28:09.19Z",
                "Description": "<div><div style=\"box-sizing:border-box;\">Umbrella Epic to capture demand on capacity and visibility of efforts required by IT OS or FI Process Framework.&nbsp;<br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\"><br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\">Examples are: Stealth migration, Win 206 OS upgrade, RHEL upgrade, Creation of UA Orderables, Establishing Service Products and the support processes.&nbsp; </div><div style=\"box-sizing:border-box;\"><br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\">Features should be created for specific topics.&nbsp; </div><br> </div>",
                "Effort": null,
                "Id": 110731,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 2,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 9,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Compliance",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Phares Mike (CSC FI SPS MESLEO)",
                "BusinessValue": 5456,
                "ChangedDate": "2024-12-18T18:17:40.73Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-10-15T14:23:22.357Z",
                "Description": null,
                "Effort": 5304,
                "Id": 129631,
                "IterationPath": "ART SPS",
                "Parent": 110731,
                "Priority": 3,
                "Relations": [],
                "Requester": "Cousten Mark (FE MES P UPE)",
                "ResolvedDate": null,
                "Revision": 17,
                "RiskReductionMinusOpportunityEnablement": 5456,
                "StartDate": null,
                "State": "New",
                "Tags": "EAF",
                "TargetDate": null,
                "TimeCriticality": 1228,
                "Title": "EAF Management Server v3.3.0",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:01:55.633Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-07T17:01:55.633Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:28:09.19Z",
                "Description": "<div><div style=\"box-sizing:border-box;\">Umbrella Epic to capture demand on capacity and visibility of efforts required by IT OS or FI Process Framework.&nbsp;<br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\"><br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\">Examples are: Stealth migration, Win 206 OS upgrade, RHEL upgrade, Creation of UA Orderables, Establishing Service Products and the support processes.&nbsp; </div><div style=\"box-sizing:border-box;\"><br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\">Features should be created for specific topics.&nbsp; </div><br> </div>",
                "Effort": null,
                "Id": 110731,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 2,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 9,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Compliance",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Phares Mike (CSC FI SPS MESLEO)",
                "BusinessValue": 5380,
                "ChangedDate": "2024-12-18T18:17:40.73Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-10-15T16:42:01.763Z",
                "Description": null,
                "Effort": 5000,
                "Id": 129640,
                "IterationPath": "ART SPS",
                "Parent": 110731,
                "Priority": 3,
                "Relations": [],
                "Requester": "Cousten Mark (FE MES P UPE)",
                "ResolvedDate": null,
                "Revision": 17,
                "RiskReductionMinusOpportunityEnablement": 5380,
                "StartDate": null,
                "State": "New",
                "Tags": "EDA",
                "TargetDate": null,
                "TimeCriticality": 1152,
                "Title": "EA DataFramework v4.20.1",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:01:55.633Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-07T17:01:55.633Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:28:09.19Z",
                "Description": "<div><div style=\"box-sizing:border-box;\">Umbrella Epic to capture demand on capacity and visibility of efforts required by IT OS or FI Process Framework.&nbsp;<br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\"><br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\">Examples are: Stealth migration, Win 206 OS upgrade, RHEL upgrade, Creation of UA Orderables, Establishing Service Products and the support processes.&nbsp; </div><div style=\"box-sizing:border-box;\"><br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\">Features should be created for specific topics.&nbsp; </div><br> </div>",
                "Effort": null,
                "Id": 110731,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 2,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 9,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Compliance",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\LEO",
                "AssignedTo": "Phares Mike (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-15T16:46:09.613Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-10-15T16:46:09.613Z",
                "Description": null,
                "Effort": null,
                "Id": 129642,
                "IterationPath": "ART SPS",
                "Parent": 109726,
                "Priority": 3,
                "Relations": [],
                "Requester": "Pagkaliwangan Angelo (PSS HiRel OP ENG)",
                "ResolvedDate": null,
                "Revision": 1,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "New",
                "Tags": "EAF",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "EAF Management Server v3.3.0",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2024-08-09T18:10:38.49Z",
                "AreaPath": "ART SPS\\LEO",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-07T17:08:47.7Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-09T18:10:30.717Z",
                "Description": "<div><div style=\"box-sizing:border-box;\">Umbrella Epic to capture demand on capacity and visibility of efforts required by IT OS or FI Process Framework.&nbsp;<br> </div><div style=\"box-sizing:border-box;\"><br> </div><div style=\"box-sizing:border-box;\">Examples are: Stealth migration, Win 206 OS upgrade, RHEL upgrade, Creation of UA Orderables, Establishing Service Products and the support processes.&nbsp; </div><div style=\"box-sizing:border-box;\"><br> </div><div style=\"box-sizing:border-box;\">Features should be created for specific topics.&nbsp; </div><br> </div>",
                "Effort": null,
                "Id": 109726,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 2,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 9,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "LEO Compliance",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-12-12T23:58:19.74Z",
                "AreaPath": "ART SPS\\LEO",
                "AssignedTo": "Phares Mike (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-12-12T23:58:19.74Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-10-18T15:20:28.217Z",
                "Description": "<div>Go through Cyber risk assessment to be able to use EAF for tool communication at Leominster </div>",
                "Effort": null,
                "Id": 132022,
                "IterationPath": "ART SPS",
                "Parent": 128425,
                "Priority": 4,
                "Relations": [],
                "Requester": "Pagkaliwangan Angelo (PSS HiRel OP ENG)",
                "ResolvedDate": "2024-12-12T23:58:19.74Z",
                "Revision": 6,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Resolved",
                "Tags": "EAF",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "EAF @ LEO - Stealth Prod",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2024-12-12T23:58:44.8Z",
                "AreaPath": "ART SPS\\LEO",
                "AssignedTo": "Phares Mike (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-12-12T23:58:44.8Z",
                "ClosedDate": "2024-12-12T23:58:44.8Z",
                "CommentCount": 0,
                "CreatedDate": "2024-10-10T14:19:54.8Z",
                "Description": null,
                "Effort": null,
                "Id": 128425,
                "IterationPath": "ART SPS",
                "Parent": null,
                "Priority": 2,
                "Relations": [],
                "Requester": "Pagkaliwangan Angelo (PSS HiRel OP ENG)",
                "ResolvedDate": "2024-12-12T23:58:44.8Z",
                "Revision": 7,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "EAF",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "EAF @ LEO",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": 5304,
                "ChangedDate": "2024-10-31T15:00:00.77Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-10-18T16:15:05.34Z",
                "Description": null,
                "Effort": 13076,
                "Id": 132028,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 2,
                "Relations": [],
                "Requester": "Holland Justin (FE MES P OPR SH C)",
                "ResolvedDate": null,
                "Revision": 18,
                "RiskReductionMinusOpportunityEnablement": 5304,
                "StartDate": null,
                "State": "New",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": 1076,
                "Title": "Remove requirement for Makeup Boxes getting FQA'ed to override quantity less than 25. Change to require only the Wafer Counter quantity is the same as what OI expects the quantity to be",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-10-24T12:55:53.687Z",
                "AreaPath": "ART SPS\\LEO",
                "AssignedTo": "Buuck Travis (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-06T17:27:06.273Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-10-22T16:08:32.383Z",
                "Description": "<div><div style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\">This feature is to implement the Camstar Recipes proof of concept for the Leominster site, as well as evaluate barcode scanning and Tool Plans in assembly where relevant. </div><div style=\"box-sizing:border-box;\"><br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\">Supports adoption of target system standards.&nbsp; </div><div style=\"box-sizing:border-box;\"> </div> </div>",
                "Effort": 5,
                "Id": 134700,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": 109724,
                "Priority": 1,
                "Relations": [],
                "Requester": "Piermarini Alexander (PSS HiRel OP PROD MS)",
                "ResolvedDate": null,
                "Revision": 9,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Active",
                "Tags": "Camstar",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Create Recipe Matrix, eval BC scanning, Tool Plan",
                "Violation": null,
                "WeightedShortestJobFirst": 3,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:08:00.113Z",
                "AreaPath": "ART SPS\\LEO",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-07T17:08:00.113Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-09T17:56:59.233Z",
                "Description": "<div>Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp; </div>",
                "Effort": null,
                "Id": 109724,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "LEO Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-12-12T17:50:59.53Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Phares Mike (CSC FI SPS MESLEO)",
                "BusinessValue": 20228,
                "ChangedDate": "2025-01-16T20:27:52.3Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-10-23T16:08:22.647Z",
                "Description": "<div>After a TECN expires or is canceled, a task needs to be created for the Originator to confirm that the process was returned to its original state. This confirmation should include a comment, a record of who completed the task, and a timestamp of when the task was completed. </div>",
                "Effort": 5911,
                "Id": 135470,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": 110729,
                "Priority": 1,
                "Relations": [],
                "Requester": "McIntyre Juanita (FE MES QM)",
                "ResolvedDate": null,
                "Revision": 21,
                "RiskReductionMinusOpportunityEnablement": 20304,
                "StartDate": null,
                "State": "Active",
                "Tags": "Fab Approval",
                "TargetDate": null,
                "TimeCriticality": 20304,
                "Title": "TECN Expiration/Cancellation Completion Task",
                "Violation": null,
                "WeightedShortestJobFirst": 4,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Tucker Chase (CSC FI SPS MESLEO)",
                "BusinessValue": 3759,
                "ChangedDate": "2024-12-18T18:17:40.73Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-10-23T16:22:02.677Z",
                "Description": "<div>Add Category field and Training Notification sections to the ECN &quot;Print PDF&quot; function </div>",
                "Effort": 3076,
                "Id": 135474,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 3,
                "Relations": [],
                "Requester": "McIntyre Juanita (FE MES QM)",
                "ResolvedDate": null,
                "Revision": 14,
                "RiskReductionMinusOpportunityEnablement": 3152,
                "StartDate": null,
                "State": "New",
                "Tags": "Fab Approval",
                "TargetDate": null,
                "TimeCriticality": 3076,
                "Title": "Add Category and Training Notification to ECN PDF",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2025-01-24T17:17:06.85Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": 1987,
                "ChangedDate": "2025-01-24T17:17:06.85Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-10-24T04:22:19.6Z",
                "Description": "<div><div style=\"box-sizing:border-box;\">Umbrella Epic to capture demand on capacity for Operations support including; admin tasks, user setup, issues and incidents, routine updates/upgrades, systems monitoring, vendor engagement, production meetings, on-call support.&nbsp; </div><div style=\"box-sizing:border-box;\"><br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\">Breakdown of activities is not required. </div><br><br> </div>",
                "Effort": 20531,
                "Id": 135679,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": 110730,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 13,
                "RiskReductionMinusOpportunityEnablement": 1987,
                "StartDate": null,
                "State": "Active",
                "Tags": "Mesa",
                "TargetDate": null,
                "TimeCriticality": 2228,
                "Title": "MES Operations Support PI4",
                "Violation": null,
                "WeightedShortestJobFirst": 0,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2024-08-14T22:26:48.44Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-07T17:05:52.08Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:26:41.517Z",
                "Description": "<div><div style=\"box-sizing:border-box;\">Umbrella Epic to capture demand on capacity for Operations support including; admin tasks, user setup, issues and incidents, routine updates/upgrades, systems monitoring, vendor engagement, production meetings, on-call support.&nbsp; </div><div style=\"box-sizing:border-box;\"><br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\">Breakdown of activities is not required. </div><br> </div>",
                "Effort": null,
                "Id": 110730,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 10,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Operations Support",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-12-13T14:19:03.89Z",
                "AreaPath": "ART SPS\\LEO",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-12-13T14:19:03.89Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-10-24T04:40:35.537Z",
                "Description": "<div><div style=\"box-sizing:border-box;\">Umbrella Epic to capture demand on capacity for Operations support including; admin tasks, user setup, issues and incidents, routine updates/upgrades, systems monitoring, vendor engagement, production meetings, on-call support.&nbsp; </div><div style=\"box-sizing:border-box;\"><br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\">Breakdown of activities is not required. </div><br> </div>",
                "Effort": null,
                "Id": 135686,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": 109725,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 3,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Active",
                "Tags": null,
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "LEO Operations Support PI4",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:08:34.2Z",
                "AreaPath": "ART SPS\\LEO",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-07T17:08:34.2Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-09T18:01:23.153Z",
                "Description": "<div><div style=\"box-sizing:border-box;\">Umbrella Epic to capture demand on capacity for Operations support including; admin tasks, user setup, issues and incidents, routine updates/upgrades, systems monitoring, vendor engagement, production meetings, on-call support.&nbsp; </div><div style=\"box-sizing:border-box;\"><br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\">Breakdown of activities is not required. </div><br> </div>",
                "Effort": null,
                "Id": 109725,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 8,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "LEO Operations Support",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-12-17T07:49:25.81Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Tucker Chase (CSC FI SPS MESLEO)",
                "BusinessValue": 20456,
                "ChangedDate": "2024-12-17T07:49:25.81Z",
                "ClosedDate": "2024-12-17T07:49:25.81Z",
                "CommentCount": 1,
                "CreatedDate": "2024-10-24T21:00:39.293Z",
                "Description": "<div>Biorad thickness data upload routine was never set up to upload for multiple layers. Currently only support 1 layer.&nbsp; </div><div><br> </div><div>See Work Order 173128, PSN is 4537, which ran on R32 during the week of October 20, 2024 for an example multi-layer non-epipro work order. </div>",
                "Effort": 3380,
                "Id": 136468,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.1",
                "Parent": 110729,
                "Priority": 1,
                "Relations": [],
                "Requester": "Holland Justin (FE MES P OPR SH C)",
                "ResolvedDate": "2024-12-17T07:49:25.81Z",
                "Revision": 23,
                "RiskReductionMinusOpportunityEnablement": 13531,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": 20380,
                "Title": "Allow for dual layer thickness data upload for Non-EpiPro Biorad data",
                "Violation": null,
                "WeightedShortestJobFirst": 20,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-10-25T19:45:46.733Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Ouellette Jonathan (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-25T22:34:03.46Z",
                "ClosedDate": "2024-10-25T22:34:03.46Z",
                "CommentCount": 0,
                "CreatedDate": "2024-10-25T19:45:18.433Z",
                "Description": null,
                "Effort": null,
                "Id": 137492,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.4",
                "Parent": null,
                "Priority": 4,
                "Relations": [],
                "Requester": null,
                "ResolvedDate": "2024-10-25T22:34:03.46Z",
                "Revision": 6,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": null,
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "RDS Test metrology calculations on the RDS_TEST form are calculating erroneous resistivity values",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": null,
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-10-25T19:58:17.63Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-29T22:39:52.137Z",
                "ClosedDate": "2024-10-29T22:39:52.137Z",
                "CommentCount": 3,
                "CreatedDate": "2024-10-25T19:56:24.413Z",
                "Description": null,
                "Effort": null,
                "Id": 137494,
                "IterationPath": "ART SPS\\2024\\PI3\\Sprint 3.4",
                "Parent": null,
                "Priority": 4,
                "Relations": [],
                "Requester": null,
                "ResolvedDate": "2024-10-29T22:39:52.137Z",
                "Revision": 9,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": null,
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "COC PDF files are failing to generate post OI 10 migration",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": null,
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-11-05T15:22:38.94Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-11-06T00:59:28.797Z",
                "ClosedDate": "2024-11-06T00:59:28.797Z",
                "CommentCount": 0,
                "CreatedDate": "2024-10-25T22:34:57.19Z",
                "Description": null,
                "Effort": null,
                "Id": 137522,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.1",
                "Parent": null,
                "Priority": 4,
                "Relations": [],
                "Requester": "Sperling Jonathon (FE MES P OPR SH A)",
                "ResolvedDate": "2024-11-06T00:59:28.797Z",
                "Revision": 8,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": null,
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "RDS Load signatures are intermittently being erased",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": null,
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Phares Mike (CSC FI SPS MESLEO)",
                "BusinessValue": 1000,
                "ChangedDate": "2025-01-23T21:15:07.19Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-10-28T13:30:08.037Z",
                "Description": null,
                "Effort": 1000,
                "Id": 139137,
                "IterationPath": "ART SPS",
                "Parent": 139131,
                "Priority": 2,
                "Relations": [],
                "Requester": "Becker Chad (FE MES QM)",
                "ResolvedDate": null,
                "Revision": 13,
                "RiskReductionMinusOpportunityEnablement": 1000,
                "StartDate": null,
                "State": "New",
                "Tags": "FDC",
                "TargetDate": null,
                "TimeCriticality": 1000,
                "Title": "FDC @ Mesa",
                "Violation": null,
                "WeightedShortestJobFirst": 1,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Phares Mike (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-10-28T13:32:11.37Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-10-28T13:24:57.533Z",
                "Description": null,
                "Effort": null,
                "Id": 139131,
                "IterationPath": "ART SPS",
                "Parent": null,
                "Priority": 2,
                "Relations": [],
                "Requester": "Becker Chad (FE MES QM)",
                "ResolvedDate": null,
                "Revision": 4,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "New",
                "Tags": "FDC",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "FDC @ Mesa",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-11-11T20:36:25.857Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-11-11T20:36:25.857Z",
                "ClosedDate": "2024-11-11T20:36:25.857Z",
                "CommentCount": 0,
                "CreatedDate": "2024-11-05T15:29:10.083Z",
                "Description": null,
                "Effort": null,
                "Id": 150121,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.1",
                "Parent": null,
                "Priority": 4,
                "Relations": [],
                "Requester": null,
                "ResolvedDate": "2024-11-11T20:36:25.857Z",
                "Revision": 4,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": null,
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Empty cassettes are not marked as complete causing work order events to not close",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": null,
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": null,
                "ChangedDate": "2024-12-18T18:17:40.73Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-11-11T23:05:50.343Z",
                "Description": "<div>Specific reactor aborts (specific mode categories selected during mode changes) need to trigger their respective NICA OCAP checklist. The NICA document(s) have not yet been created. Currently work instruction &quot;EpiMSA WI-002202 Rev A Process Interruption - Abort - Alarm Checklist&quot; is being used located in MesaDocs (see path below). </div><div><br> </div><div><span style=\"display:inline !important;\">\\\\messdv003.infineon.com\\MesaDocs\\1. Mesa Released Documents\\Manufacturing\\Reactor\\Work Instructions\\</span><span style=\"display:inline !important;\">EpiMSA WI-0022-2 Rev A Process Interruption - Abort - Alarm Checklist</span><br> </div>",
                "Effort": null,
                "Id": 175188,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 4,
                "Relations": [],
                "Requester": "Fuentes Jessica (FE MES P OPR)",
                "ResolvedDate": null,
                "Revision": 7,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "New",
                "Tags": "NICA; OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Automate specific Aborts to trigger NICA OCAP Checklists",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-11-12T20:14:27.72Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Tucker Chase (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-11-12T20:18:25.923Z",
                "ClosedDate": "2024-11-12T20:18:25.923Z",
                "CommentCount": 0,
                "CreatedDate": "2024-11-12T20:13:00.127Z",
                "Description": null,
                "Effort": null,
                "Id": 184280,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.1",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "McIntyre Juanita (FE MES QM)",
                "ResolvedDate": "2024-11-12T20:18:25.923Z",
                "Revision": 4,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "Fab Approval",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "OOO Expiration worker not resetting approval roles correctly",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": null,
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": null,
                "ChangedDate": "2024-12-18T18:17:40.73Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-11-13T22:17:55.337Z",
                "Description": "<div><b>Enhancement comes as a result of an audit finding.</b> </div><div><p style=\"margin:0in 0in 0.0001pt;font-size:11pt;font-family:Aptos;\"><span style=\"font-size:10pt;font-family:Arial, sans-serif;\">When a calibration is performed such as for Tencor, biorad, or a HgCV tools. We\nuse Open Insight to print the calibration sticker rather than having to hand\nwrite it. The metrology team has to record the calibration in OI, so my\nsuggestion would be using this information to trigger the label to print to\nsmaller zebra printer (MESZBRPRT008) we currently have by the supervisor’s\ndesk. </span> </p><p style=\"margin:0in 0in 0.0001pt;font-size:11pt;font-family:Aptos;\"><span style=\"font-size:10.0pt;font-family:&quot;Arial&quot;,sans-serif;\">&nbsp;</span> </p><p style=\"margin:0in 0in 0.0001pt;font-size:11pt;font-family:Aptos;\"><span style=\"font-size:10.0pt;font-family:&quot;Arial&quot;,sans-serif;\">We\nwould want to print the calibration label with at least:</span> </p><ul style=\"margin-bottom:0in;margin-top:0in;\">\n <li style=\"margin:0in 0in 0.0001pt;font-size:11pt;font-family:Aptos;\"><span style=\"font-size:10.0pt;font-family:&quot;Arial&quot;,sans-serif;\">Tool ID# (e.g. Tencor #1)</span> </li>\n <li style=\"margin:0in 0in 0.0001pt;font-size:11pt;font-family:Aptos;\"><span style=\"font-size:10.0pt;font-family:&quot;Arial&quot;,sans-serif;\">Last Calibration Date</span> </li>\n <li style=\"margin:0in 0in 0.0001pt;font-size:11pt;font-family:Aptos;\"><span style=\"font-size:10.0pt;font-family:&quot;Arial&quot;,sans-serif;\">Expiration Date (or Next Calibration Due Date)</span> </li>\n <li style=\"margin:0in 0in 0.0001pt;font-size:11pt;font-family:Aptos;\"><span style=\"font-size:10pt;font-family:Arial, sans-serif;\">User who completed the calibration.</span> </li> </ul><br> </div><div><b><img src=\"https://tfs.intra.infineon.com/tfs/FactoryIntegration/0d06e969-e1f5-4835-a359-620d557c7595/_apis/wit/attachments/c7df4afa-922c-498f-8638-17d7601005ec?fileName=image.png\" alt=Image><br></b> </div>",
                "Effort": null,
                "Id": 184797,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 4,
                "Relations": [],
                "Requester": "Sperling Jonathon (FE MES P OPR SH A)",
                "ResolvedDate": null,
                "Revision": 7,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "New",
                "Tags": null,
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Print metrology tool Calibration label from OI",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-11-19T00:20:36.887Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-11-22T16:12:54.27Z",
                "ClosedDate": "2024-11-22T16:12:54.27Z",
                "CommentCount": 3,
                "CreatedDate": "2024-11-18T18:30:43.267Z",
                "Description": null,
                "Effort": null,
                "Id": 185952,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.1",
                "Parent": null,
                "Priority": 4,
                "Relations": [],
                "Requester": null,
                "ResolvedDate": "2024-11-22T16:12:54.27Z",
                "Revision": 10,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI; SAP",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Add logging to obj_SAP SFTP calls to help troubleshoot failed SAP transactions",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": null,
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-11-18T20:19:14.223Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Ouellette Jonathan (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-11-18T20:19:30.41Z",
                "ClosedDate": "2024-11-18T20:19:14.223Z",
                "CommentCount": 0,
                "CreatedDate": "2024-11-18T20:18:07.827Z",
                "Description": null,
                "Effort": null,
                "Id": 185953,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.1",
                "Parent": null,
                "Priority": 4,
                "Relations": [],
                "Requester": "Fuentes Jessica (FE MES P OPR)",
                "ResolvedDate": "2024-11-18T20:19:14.223Z",
                "Revision": 5,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": null,
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "PM Notifications kept sending out repeatedly until PM was completed",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": null,
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2025-01-22T15:58:47.267Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Phares Mike (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T15:58:47.267Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-11-18T22:01:51.843Z",
                "Description": null,
                "Effort": null,
                "Id": 185957,
                "IterationPath": "ART SPS",
                "Parent": 110731,
                "Priority": 4,
                "Relations": [],
                "Requester": "Cousten Mark (FE MES P UPE)",
                "ResolvedDate": null,
                "Revision": 6,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Active",
                "Tags": "EAF",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "EAF Runtime Release 2.58.0.0",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:01:55.633Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-07T17:01:55.633Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:28:09.19Z",
                "Description": "<div><div style=\"box-sizing:border-box;\">Umbrella Epic to capture demand on capacity and visibility of efforts required by IT OS or FI Process Framework.&nbsp;<br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\"><br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\">Examples are: Stealth migration, Win 206 OS upgrade, RHEL upgrade, Creation of UA Orderables, Establishing Service Products and the support processes.&nbsp; </div><div style=\"box-sizing:border-box;\"><br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\">Features should be created for specific topics.&nbsp; </div><br> </div>",
                "Effort": null,
                "Id": 110731,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 2,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 9,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Compliance",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-11-26T17:56:47.553Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Ouellette Jonathan (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-11-27T03:49:22.68Z",
                "ClosedDate": "2024-11-27T03:49:22.68Z",
                "CommentCount": 0,
                "CreatedDate": "2024-11-22T16:14:25.84Z",
                "Description": null,
                "Effort": null,
                "Id": 187494,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.2",
                "Parent": 135682,
                "Priority": 4,
                "Relations": [],
                "Requester": null,
                "ResolvedDate": "2024-11-27T03:49:19.6Z",
                "Revision": 10,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Semi Annual Reactor PMs recorded in Reactor Logs are not marking the PM as complete on the Reactor PMs due list",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": {
                "ActivatedDate": "2024-11-23T00:27:31.12Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-20T22:15:24.27Z",
                "ClosedDate": "2024-12-17T07:14:15.377Z",
                "CommentCount": 0,
                "CreatedDate": "2024-10-24T04:25:34.473Z",
                "Description": null,
                "Effort": null,
                "Id": 135682,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.2",
                "Parent": 135679,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": "2024-12-17T07:14:15.377Z",
                "Revision": 5,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "Mesa",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "MES Operations Support 2024\\PI4\\Sprint 4.2",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "User Story"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-12-13T01:02:27.853Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-12-13T01:02:27.853Z",
                "ClosedDate": "2024-12-13T01:02:27.853Z",
                "CommentCount": 0,
                "CreatedDate": "2024-11-22T16:14:59.28Z",
                "Description": null,
                "Effort": null,
                "Id": 187495,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.2",
                "Parent": null,
                "Priority": 4,
                "Relations": [],
                "Requester": null,
                "ResolvedDate": "2024-12-13T01:02:27.853Z",
                "Revision": 6,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Peeling off cassettes does not trigger released and received quantities to update in the work order",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": null,
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-12-03T21:10:12.18Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-12-03T21:10:12.18Z",
                "ClosedDate": "2024-12-03T21:10:12.18Z",
                "CommentCount": 0,
                "CreatedDate": "2024-11-22T16:16:01.883Z",
                "Description": null,
                "Effort": null,
                "Id": 187496,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.2",
                "Parent": 135682,
                "Priority": 4,
                "Relations": [],
                "Requester": null,
                "ResolvedDate": "2024-12-03T21:10:12.18Z",
                "Revision": 6,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Packaging Challenge Calibration due in October did not send out notifications when overdue",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": {
                "ActivatedDate": "2024-11-23T00:27:31.12Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-20T22:15:24.27Z",
                "ClosedDate": "2024-12-17T07:14:15.377Z",
                "CommentCount": 0,
                "CreatedDate": "2024-10-24T04:25:34.473Z",
                "Description": null,
                "Effort": null,
                "Id": 135682,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.2",
                "Parent": 135679,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": "2024-12-17T07:14:15.377Z",
                "Revision": 5,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "Mesa",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "MES Operations Support 2024\\PI4\\Sprint 4.2",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "User Story"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": null,
                "ChangedDate": "2024-12-18T18:17:40.73Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-11-22T18:00:07.1Z",
                "Description": null,
                "Effort": null,
                "Id": 187502,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 4,
                "Relations": [],
                "Requester": "Holland Justin (FE MES P OPR SH C)",
                "ResolvedDate": null,
                "Revision": 4,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "New",
                "Tags": "OI; OI Web Services",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Use desktop scanners to scan cleanroom badges for username and password verification",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": null,
                "ChangedDate": "2024-12-18T18:17:40.73Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-11-22T18:01:01.72Z",
                "Description": null,
                "Effort": null,
                "Id": 187503,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 4,
                "Relations": [],
                "Requester": "Holland Justin (FE MES P OPR SH C)",
                "ResolvedDate": null,
                "Revision": 4,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "New",
                "Tags": "IQS",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Use desktop barcode scanners for SPC input fields like RDS, PSN, and Reactor No",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": null,
                "ChangedDate": "2024-12-18T18:17:40.73Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-11-22T18:02:28.93Z",
                "Description": "<div>Feature similar to SPV second user verification feature.&nbsp; </div>",
                "Effort": null,
                "Id": 187504,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 4,
                "Relations": [],
                "Requester": "Holland Justin (FE MES P OPR SH C)",
                "ResolvedDate": null,
                "Revision": 4,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "New",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "When switching from cleanup mode on HTRs require a second user verification of reactor recipe",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-12-13T16:26:37.317Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-12-13T22:25:15.69Z",
                "ClosedDate": "2024-12-13T22:25:15.69Z",
                "CommentCount": 0,
                "CreatedDate": "2024-11-25T23:48:56.99Z",
                "Description": null,
                "Effort": null,
                "Id": 188281,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.2",
                "Parent": null,
                "Priority": 4,
                "Relations": [],
                "Requester": null,
                "ResolvedDate": "2024-12-13T22:25:15.69Z",
                "Revision": 9,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Clean & Inspect form does not close on write event",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": null,
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-11-27T18:29:27.757Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Ouellette Jonathan (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T20:38:38.42Z",
                "ClosedDate": "2025-01-22T20:38:38.42Z",
                "CommentCount": 0,
                "CreatedDate": "2024-11-27T18:28:20.877Z",
                "Description": null,
                "Effort": 2,
                "Id": 199351,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.3",
                "Parent": 110731,
                "Priority": 2,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": "2025-01-22T20:38:38.42Z",
                "Revision": 8,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "Mesa Reporting Services",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Migrate Mesa reporting services git repo to Factory Integration",
                "Violation": null,
                "WeightedShortestJobFirst": 1,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:01:55.633Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-07T17:01:55.633Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:28:09.19Z",
                "Description": "<div><div style=\"box-sizing:border-box;\">Umbrella Epic to capture demand on capacity and visibility of efforts required by IT OS or FI Process Framework.&nbsp;<br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\"><br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\">Examples are: Stealth migration, Win 206 OS upgrade, RHEL upgrade, Creation of UA Orderables, Establishing Service Products and the support processes.&nbsp; </div><div style=\"box-sizing:border-box;\"><br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\">Features should be created for specific topics.&nbsp; </div><br> </div>",
                "Effort": null,
                "Id": 110731,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 2,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 9,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Compliance",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-12-02T23:54:27.357Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Ouellette Jonathan (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-12-10T15:52:34.127Z",
                "ClosedDate": "2024-12-10T15:52:34.127Z",
                "CommentCount": 0,
                "CreatedDate": "2024-12-02T23:53:33.727Z",
                "Description": null,
                "Effort": null,
                "Id": 200658,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.2",
                "Parent": null,
                "Priority": 4,
                "Relations": [],
                "Requester": "Clark Kelly (FE MES P UPE SH)",
                "ResolvedDate": "2024-12-02T23:54:27.357Z",
                "Revision": 5,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": null,
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Prod Metrology tests not getting added to Gen 5 lots",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": null,
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T16:57:20.067Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-12-06T16:34:12.5Z",
                "Description": "<div>Currently the wafer size of a reactor needs to be changed manually on top of selecting a reactor log service to install a different susceptor. This should be modified such that the susceptor size of a reactor is instead read from the installed susceptor react item.&nbsp; </div>",
                "Effort": null,
                "Id": 202208,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 4,
                "Relations": [],
                "Requester": "Henderson Susan (FE MES FM)",
                "ResolvedDate": null,
                "Revision": 4,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "New",
                "Tags": "OI; OI Web Services",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Modify the Wafer Size property of the Reactor to be read from the installed susceptor size",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-12-10T15:52:08.45Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Ouellette Jonathan (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-12-10T15:52:08.45Z",
                "ClosedDate": "2024-12-10T15:52:08.45Z",
                "CommentCount": 0,
                "CreatedDate": "2024-12-10T15:51:36.877Z",
                "Description": null,
                "Effort": null,
                "Id": 205255,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.2",
                "Parent": null,
                "Priority": 4,
                "Relations": [],
                "Requester": null,
                "ResolvedDate": "2024-12-10T15:52:08.45Z",
                "Revision": 4,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": null,
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Override is being performed in Scan App, but override options not going away once override is completed",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": null,
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-12-12T18:07:32.57Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Ouellette Jonathan (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-12-12T21:45:56.5Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2024-12-12T18:06:31.33Z",
                "Description": null,
                "Effort": null,
                "Id": 207116,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.2",
                "Parent": null,
                "Priority": 4,
                "Relations": [],
                "Requester": "Becker Chad (FE MES QM)",
                "ResolvedDate": "2024-12-12T21:45:56.5Z",
                "Revision": 5,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Resolved",
                "Tags": null,
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "EPP COA Formatting Issue",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": null,
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2024-12-13T20:27:51.383Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Ouellette Jonathan (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2024-12-18T22:18:17.957Z",
                "ClosedDate": "2024-12-18T22:18:17.957Z",
                "CommentCount": 0,
                "CreatedDate": "2024-12-13T20:27:44.343Z",
                "Description": null,
                "Effort": null,
                "Id": 207473,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.3",
                "Parent": null,
                "Priority": 4,
                "Relations": [],
                "Requester": null,
                "ResolvedDate": "2024-12-18T22:18:17.957Z",
                "Revision": 6,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": null,
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Irrelevant zone data being sent in customer COC for EPP lots",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": null,
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\LEO",
                "AssignedTo": "Belasco Bradd (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-20T22:50:44.217Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-12-13T20:49:17.837Z",
                "Description": "<div><a href=\"https://tfs.intra.infineon.com/tfs/ManufacturingIT_Teams/LEO_FI/_git/Leominster-Serial-Log-Framework-461\">https://tfs.intra.infineon.com/tfs/ManufacturingIT_Teams/LEO_FI/_git/Leominster-Serial-Log-Framework-461</a><br> </div>",
                "Effort": null,
                "Id": 207476,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": 109726,
                "Priority": 2,
                "Relations": [],
                "Requester": "Saller Florian (CSC FI MQT LMS)",
                "ResolvedDate": null,
                "Revision": 7,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "New",
                "Tags": "ADO",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Migrate LEO_FI to FactoryIntegration ADO Collection",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2024-08-09T18:10:38.49Z",
                "AreaPath": "ART SPS\\LEO",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-07T17:08:47.7Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-09T18:10:30.717Z",
                "Description": "<div><div style=\"box-sizing:border-box;\">Umbrella Epic to capture demand on capacity and visibility of efforts required by IT OS or FI Process Framework.&nbsp;<br> </div><div style=\"box-sizing:border-box;\"><br> </div><div style=\"box-sizing:border-box;\">Examples are: Stealth migration, Win 206 OS upgrade, RHEL upgrade, Creation of UA Orderables, Establishing Service Products and the support processes.&nbsp; </div><div style=\"box-sizing:border-box;\"><br> </div><div style=\"box-sizing:border-box;\">Features should be created for specific topics.&nbsp; </div><br> </div>",
                "Effort": null,
                "Id": 109726,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 2,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 9,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "LEO Compliance",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T16:57:38.63Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-12-18T18:17:39.643Z",
                "Description": "<div>Require 100% centerpoint thickness on a lot when the MU flag is toggled for that lot.&nbsp; </div>",
                "Effort": null,
                "Id": 210045,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 4,
                "Relations": [],
                "Requester": "Sperling Jonathon (FE MES P OPR SH A)",
                "ResolvedDate": null,
                "Revision": 7,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "New",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "When a  lot becomes a MU box require 100% centerpoint thickness",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2025-01-22T17:42:31.893Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Mitchem Dakota (CSC FI SPS MESLEO External)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:42:31.893Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-12-20T23:08:11.713Z",
                "Description": null,
                "Effort": null,
                "Id": 211058,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 4,
                "Relations": [],
                "Requester": "O'Toole Derek (FE MES P MNT SH)",
                "ResolvedDate": null,
                "Revision": 6,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Active",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Reactor Mode Change records are intermittently not being closed leading to an inability to change the mode of a reactor",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": null,
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2025-01-06T22:42:33.16Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Ouellette Jonathan (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-08T19:15:26.05Z",
                "ClosedDate": "2025-01-08T19:15:26.05Z",
                "CommentCount": 0,
                "CreatedDate": "2025-01-06T22:37:30.56Z",
                "Description": null,
                "Effort": null,
                "Id": 212435,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 4,
                "Relations": [],
                "Requester": null,
                "ResolvedDate": "2025-01-06T22:42:33.16Z",
                "Revision": 5,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": null,
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Mesa Reporting Services Not working after shutdown",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": null,
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": null,
                "ChangedDate": "2025-01-15T18:10:44.187Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2025-01-15T18:09:53.717Z",
                "Description": "<div>CoolMOS parts require inspection of the tool every x runs. OpenInsight needs to be able to track the number of cassettes ran on a particular reactor when a CoolMOS part is running. Once x number of cassettes have been unloaded, OpenInsight should automatically place the tool into MAINTENANCE_UNSCHEDULED (or perhaps WAITIING_FOR_MAINTENANCE) and add a service to the REACTOR_LOG for that mode change.&nbsp; </div>",
                "Effort": null,
                "Id": 216303,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 4,
                "Relations": [],
                "Requester": "O'Toole Derek (FE MES P MNT SH)",
                "ResolvedDate": null,
                "Revision": 3,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "New",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Automate tool mode change on CoolMOS run frequency",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2025-01-16T19:21:25.537Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-16T19:23:02.93Z",
                "ClosedDate": "2025-01-16T19:23:02.93Z",
                "CommentCount": 0,
                "CreatedDate": "2025-01-16T19:21:19.317Z",
                "Description": null,
                "Effort": null,
                "Id": 217108,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 4,
                "Relations": [],
                "Requester": "O'Toole Derek (FE MES P MNT SH)",
                "ResolvedDate": "2025-01-16T19:23:02.93Z",
                "Revision": 7,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "NICA; OI; OI Web Services",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "NICA checklist orders cannot be created for reactor 20.",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": null,
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Mitchem Dakota (CSC FI SPS MESLEO External)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:51:44.327Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2025-01-16T19:23:36.413Z",
                "Description": null,
                "Effort": null,
                "Id": 217109,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 4,
                "Relations": [],
                "Requester": "Chavira Sebastian (FE CF OPC MM EPI MLOG SHI)",
                "ResolvedDate": null,
                "Revision": 6,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "New",
                "Tags": "OI; SAP",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "SAP batch number failed to save to WO_MAT record",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": null,
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Mitchem Dakota (CSC FI SPS MESLEO External)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:51:23.06Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2025-01-16T19:37:47.147Z",
                "Description": null,
                "Effort": null,
                "Id": 217110,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 4,
                "Relations": [],
                "Requester": "Chow Bobby (FE CF OPC MM EPI)",
                "ResolvedDate": null,
                "Revision": 5,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "New",
                "Tags": "OI; SAP",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Production order number was not assigned to newly created work order record",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": null,
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-17T16:02:38.53Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2025-01-16T20:53:27.82Z",
                "Description": "<div>Individual OpenInsight servers for each developer are needed due to a two user limit on MESTSA01EC imposed by ITOS (due to Remote Desktop Services licenses not being issued). Furthermore, only one developer can debug web API requests at any given time.&nbsp; </div>",
                "Effort": null,
                "Id": 217114,
                "IterationPath": "ART SPS",
                "Parent": 110731,
                "Priority": 2,
                "Relations": [],
                "Requester": "Stieber Daniel (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 7,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "New",
                "Tags": null,
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Setup OI Dev Servers for each Developer",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:01:55.633Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-07T17:01:55.633Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:28:09.19Z",
                "Description": "<div><div style=\"box-sizing:border-box;\">Umbrella Epic to capture demand on capacity and visibility of efforts required by IT OS or FI Process Framework.&nbsp;<br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\"><br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\">Examples are: Stealth migration, Win 206 OS upgrade, RHEL upgrade, Creation of UA Orderables, Establishing Service Products and the support processes.&nbsp; </div><div style=\"box-sizing:border-box;\"><br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\">Features should be created for specific topics.&nbsp; </div><br> </div>",
                "Effort": null,
                "Id": 110731,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 2,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 9,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Compliance",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2025-01-20T15:13:02.877Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Ouellette Jonathan (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-20T18:25:30.987Z",
                "ClosedDate": "2025-01-20T18:25:30.987Z",
                "CommentCount": 0,
                "CreatedDate": "2025-01-20T15:12:56.353Z",
                "Description": null,
                "Effort": null,
                "Id": 218321,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 4,
                "Relations": [],
                "Requester": "Chow Bobby (FE CF OPC MM EPI)",
                "ResolvedDate": "2025-01-20T18:25:30.987Z",
                "Revision": 6,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": null,
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Missing Part Change Metrics from Mesa Reporting Services",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": null,
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": null,
                "ChangedDate": "2025-01-21T23:08:07.173Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2025-01-21T23:04:44.403Z",
                "Description": "<div>Add a new tab to the reactor log form (and OI Wizard page) for reactor ratios. Reactors can have up to 16 ratios depending on the reactor type. Upon adding a particular service ID to a reactor log (ask requestor for more details), reactor ratios will be required to be entered on the ratio tab in order to sign the reactor log. </div>",
                "Effort": null,
                "Id": 218979,
                "IterationPath": "ART SPS",
                "Parent": null,
                "Priority": 4,
                "Relations": [],
                "Requester": "O'Toole Derek (FE MES P MNT SH)",
                "ResolvedDate": null,
                "Revision": 4,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "New",
                "Tags": "OI; OI Web Services",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Require and record reactor ratios in Reactor Log on when performing certain services",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Parent": null,
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2025-01-22T16:22:26.327Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Tucker Chase (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T19:04:17.27Z",
                "ClosedDate": "2025-01-22T19:04:17.27Z",
                "CommentCount": 0,
                "CreatedDate": "2025-01-22T16:21:34.633Z",
                "Description": null,
                "Effort": null,
                "Id": 219629,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "McIntyre Juanita (FE MES QM)",
                "ResolvedDate": "2025-01-22T19:04:17.27Z",
                "Revision": 4,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": "Fab Approval",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "MRB not generating approvals after QA pre-approval",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": null,
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T19:01:05.6Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2025-01-22T19:01:05.6Z",
                "Description": "<div>Use ePortal IFAM ECC | Former IR 100 ERP on mobile scanners. This will allow shipping department to scan cassettes and the shelf location for greater accuracy and fewer human errors. </div>",
                "Effort": null,
                "Id": 219637,
                "IterationPath": "ART SPS",
                "Parent": 110729,
                "Priority": 2,
                "Relations": [],
                "Requester": "Eschenauer Scott (FE CF OPC MM EPI MLOG REC)",
                "ResolvedDate": null,
                "Revision": 1,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "New",
                "Tags": "SAP",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Setup SAP on Mobile Scanners",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:06:55.11Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T17:03:59.963Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:24:37.91Z",
                "Description": "<div><span style=\"display:inline !important;\">Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp;&nbsp;</span> </div>",
                "Effort": null,
                "Id": 110729,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2025-01-22T23:08:36.48Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Stieber Daniel (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-22T23:12:00.42Z",
                "ClosedDate": "2025-01-22T23:12:00.42Z",
                "CommentCount": 0,
                "CreatedDate": "2025-01-22T23:08:21.543Z",
                "Description": null,
                "Effort": null,
                "Id": 219660,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": 110730,
                "Priority": 4,
                "Relations": [],
                "Requester": null,
                "ResolvedDate": "2025-01-22T23:12:00.42Z",
                "Revision": 4,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Closed",
                "Tags": null,
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Auto-hold makeup wafer service failed to place lot on hold",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": {
                "ActivatedDate": "2024-08-14T22:26:48.44Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-07T17:05:52.08Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-14T22:26:41.517Z",
                "Description": "<div><div style=\"box-sizing:border-box;\">Umbrella Epic to capture demand on capacity for Operations support including; admin tasks, user setup, issues and incidents, routine updates/upgrades, systems monitoring, vendor engagement, production meetings, on-call support.&nbsp; </div><div style=\"box-sizing:border-box;\"><br style=\"box-sizing:border-box;\"> </div><div style=\"box-sizing:border-box;\">Breakdown of activities is not required. </div><br> </div>",
                "Effort": null,
                "Id": 110730,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 10,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "MES Operations Support",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": null,
                "ChangedDate": "2025-01-24T16:06:17.127Z",
                "ClosedDate": null,
                "CommentCount": 1,
                "CreatedDate": "2025-01-23T15:45:18.627Z",
                "Description": "<div><p style=\"margin:0in 0in 0.0001pt;font-size:11pt;font-family:Calibri, sans-serif;\"><span style=\"font-size:10.0pt;font-family:&quot;Arial&quot;,sans-serif;\">EpiSil\nhas requested that we add 3 columns to the CSV file for transfer when we ship\nto EpiSil.</span> </p><p style=\"margin:0in 0in 0.0001pt;font-size:11pt;font-family:Calibri, sans-serif;\"><span style=\"font-size:10.0pt;font-family:&quot;Arial&quot;,sans-serif;\">Zone, pocket, WMOKey, Out Cass No, Out Slot No</span> </p><br> </div>",
                "Effort": null,
                "Id": 220257,
                "IterationPath": "ART SPS",
                "Parent": null,
                "Priority": 2,
                "Relations": [],
                "Requester": "Becker Chad (FE MES QM)",
                "ResolvedDate": null,
                "Revision": 6,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "New",
                "Tags": null,
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "Add New Fields to EpiPro COC for EpiSil",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Feature"
            },
            "Parent": null,
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": null,
                "BusinessValue": null,
                "ChangedDate": "2025-01-24T00:03:47.587Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2025-01-24T00:00:49.293Z",
                "Description": null,
                "Effort": null,
                "Id": 220506,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 4,
                "Relations": [],
                "Requester": "Bardo Grey (FE MES P OPR SH C)",
                "ResolvedDate": null,
                "Revision": 3,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "New",
                "Tags": "OI",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "EpiPro RDS Layer record contents unexpectedly cleared out by OI user session",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": null,
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": "2025-01-24T15:56:41.907Z",
                "AreaPath": "ART SPS\\MES",
                "AssignedTo": "Tucker Chase (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-24T15:56:41.907Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2025-01-24T15:55:34.903Z",
                "Description": null,
                "Effort": null,
                "Id": 221109,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 2,
                "Relations": [],
                "Requester": "McIntyre Juanita (FE MES QM)",
                "ResolvedDate": null,
                "Revision": 4,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": null,
                "State": "Active",
                "Tags": "Fab Approval",
                "TargetDate": null,
                "TimeCriticality": null,
                "Title": "OOO expiration not resetting user roles",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Bug"
            },
            "Parent": null,
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\LEO",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": 2,
                "ChangedDate": "2025-01-24T18:46:35.597Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2025-01-24T18:46:35.597Z",
                "Description": "new report creation for materials. in support of reaction team<br>",
                "Effort": 2,
                "Id": 221119,
                "IterationPath": "ART SPS\\2025\\PI5",
                "Parent": 109724,
                "Priority": 2,
                "Relations": [],
                "Requester": "Piermarini Alexander (PSS HiRel OP PROD MS)",
                "ResolvedDate": null,
                "Revision": 1,
                "RiskReductionMinusOpportunityEnablement": 4,
                "StartDate": "2025-02-04T23:00:00Z",
                "State": "New",
                "Tags": null,
                "TargetDate": "2025-05-01T22:00:00Z",
                "TimeCriticality": 4,
                "Title": "new report creation for materials. in support of reaction team",
                "Violation": null,
                "WeightedShortestJobFirst": 5,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:08:00.113Z",
                "AreaPath": "ART SPS\\LEO",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-07T17:08:00.113Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-09T17:56:59.233Z",
                "Description": "<div>Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp; </div>",
                "Effort": null,
                "Id": 109724,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "LEO Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        },
        {
            "WorkItem": {
                "ActivatedDate": null,
                "AreaPath": "ART SPS\\LEO",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": 6,
                "ChangedDate": "2025-01-24T19:07:14.45Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2025-01-24T19:07:14.45Z",
                "Description": "<div><span style=\"font-size:10.0pt;font-family:&quot;Arial&quot;,sans-serif;\">fixture and insertion\ntracking. document solution proposal.</span><br> </div>",
                "Effort": 2,
                "Id": 221123,
                "IterationPath": "ART SPS\\2025\\PI5",
                "Parent": 109724,
                "Priority": 2,
                "Relations": [],
                "Requester": "Piermarini Alexander (PSS HiRel OP PROD MS)",
                "ResolvedDate": null,
                "Revision": 1,
                "RiskReductionMinusOpportunityEnablement": 2,
                "StartDate": "2025-02-04T23:00:00Z",
                "State": "New",
                "Tags": null,
                "TargetDate": "2025-05-01T22:00:00Z",
                "TimeCriticality": 2,
                "Title": "fixture and insertion tracking. document solution proposal.",
                "Violation": null,
                "WeightedShortestJobFirst": 5,
                "WorkItemType": "Feature"
            },
            "Parent": {
                "ActivatedDate": "2025-01-07T17:08:00.113Z",
                "AreaPath": "ART SPS\\LEO",
                "AssignedTo": "Jarsey Martha (CSC FI SPS MESLEO)",
                "BusinessValue": null,
                "ChangedDate": "2025-01-07T17:08:00.113Z",
                "ClosedDate": null,
                "CommentCount": 0,
                "CreatedDate": "2024-08-09T17:56:59.233Z",
                "Description": "<div>Umbrella Epic to represent local requests where effort is &lt; 1 qtr and there are no cross department dependencies.&nbsp; </div>",
                "Effort": null,
                "Id": 109724,
                "IterationPath": "ART SPS\\2024\\PI4\\Sprint 4.4",
                "Parent": null,
                "Priority": 1,
                "Relations": [],
                "Requester": "Jarsey Martha (CSC FI SPS MESLEO)",
                "ResolvedDate": null,
                "Revision": 11,
                "RiskReductionMinusOpportunityEnablement": null,
                "StartDate": "2024-08-04T22:00:00Z",
                "State": "Active",
                "Tags": null,
                "TargetDate": "2024-10-24T22:00:00Z",
                "TimeCriticality": null,
                "Title": "LEO Small Local Enhancements",
                "Violation": null,
                "WeightedShortestJobFirst": null,
                "WorkItemType": "Epic"
            },
            "Children": [],
            "Related": [],
            "Successors": []
        }
    ];
}

function getExampleDataB() {
    return {
        "110741": {
            "CostOfDelay": null,
            "BusinessValue": null,
            "Effort": {
                "InverseAverage": 3,
                "ValueCount": 2,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 6
            },
            "Id": 110741,
            "SortPriority": null,
            "SortPriorityGroup": null,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 3,
                "ValueCount": 1,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 3
            },
            "SortOrder": 0,
            "TimeCriticality": {
                "InverseAverage": 4,
                "ValueCount": 1,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 2
            },
            "WeightedShortestJobFirst": null
        },
        "110771": {
            "CostOfDelay": null,
            "BusinessValue": null,
            "Effort": {
                "InverseAverage": 3,
                "ValueCount": 2,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 6
            },
            "Id": 110771,
            "SortPriority": null,
            "SortPriorityGroup": null,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 3,
                "ValueCount": 1,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 3
            },
            "SortOrder": 1,
            "TimeCriticality": {
                "InverseAverage": 3,
                "ValueCount": 1,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 3
            },
            "WeightedShortestJobFirst": null
        },
        "110801": {
            "CostOfDelay": null,
            "BusinessValue": null,
            "Effort": {
                "InverseAverage": 4,
                "ValueCount": 1,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 2
            },
            "Id": 110801,
            "SortPriority": null,
            "SortPriorityGroup": null,
            "RiskReductionOpportunityEnablement": null,
            "SortOrder": 2,
            "TimeCriticality": null,
            "WeightedShortestJobFirst": null
        },
        "123057": {
            "CostOfDelay": null,
            "BusinessValue": null,
            "Effort": {
                "InverseAverage": 3.5,
                "ValueCount": 2,
                "FibonacciAverage": 4,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 5
            },
            "Id": 123057,
            "SortPriority": null,
            "SortPriorityGroup": null,
            "RiskReductionOpportunityEnablement": null,
            "SortOrder": 3,
            "TimeCriticality": null,
            "WeightedShortestJobFirst": null
        },
        "123061": {
            "CostOfDelay": null,
            "BusinessValue": null,
            "Effort": {
                "InverseAverage": 4,
                "ValueCount": 2,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 4
            },
            "Id": 123061,
            "SortPriority": null,
            "SortPriorityGroup": null,
            "RiskReductionOpportunityEnablement": null,
            "SortOrder": 4,
            "TimeCriticality": null,
            "WeightedShortestJobFirst": null
        },
        "126019": {
            "CostOfDelay": null,
            "BusinessValue": null,
            "Effort": {
                "InverseAverage": 4,
                "ValueCount": 3,
                "FibonacciAverage": 5.33333,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 6
            },
            "Id": 126019,
            "SortPriority": null,
            "SortPriorityGroup": null,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 3,
                "ValueCount": 1,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 3
            },
            "SortOrder": 5,
            "TimeCriticality": {
                "InverseAverage": 4,
                "ValueCount": 1,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 2
            },
            "WeightedShortestJobFirst": null
        },
        "126451": {
            "CostOfDelay": null,
            "BusinessValue": null,
            "Effort": {
                "InverseAverage": 3.5,
                "ValueCount": 2,
                "FibonacciAverage": 4,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 5
            },
            "Id": 126451,
            "SortPriority": null,
            "SortPriorityGroup": null,
            "RiskReductionOpportunityEnablement": null,
            "SortOrder": 6,
            "TimeCriticality": null,
            "WeightedShortestJobFirst": null
        },
        "129631": {
            "CostOfDelay": null,
            "BusinessValue": null,
            "Effort": {
                "InverseAverage": 3.5,
                "ValueCount": 2,
                "FibonacciAverage": 4,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 5
            },
            "Id": 129631,
            "SortPriority": null,
            "SortPriorityGroup": null,
            "RiskReductionOpportunityEnablement": null,
            "SortOrder": 7,
            "TimeCriticality": null,
            "WeightedShortestJobFirst": null
        },
        "129640": {
            "CostOfDelay": null,
            "BusinessValue": null,
            "Effort": {
                "InverseAverage": 2.5,
                "ValueCount": 2,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 5,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 7
            },
            "Id": 129640,
            "SortPriority": null,
            "SortPriorityGroup": null,
            "RiskReductionOpportunityEnablement": null,
            "SortOrder": 8,
            "TimeCriticality": null,
            "WeightedShortestJobFirst": null
        },
        "135679": {
            "CostOfDelay": null,
            "BusinessValue": null,
            "Effort": {
                "InverseAverage": 5,
                "ValueCount": 1,
                "FibonacciAverage": 8,
                "InverseValue": 1,
                "ValueMaximum": 1,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 1
            },
            "Id": 135679,
            "SortPriority": null,
            "SortPriorityGroup": null,
            "RiskReductionOpportunityEnablement": null,
            "SortOrder": 9,
            "TimeCriticality": null,
            "WeightedShortestJobFirst": null
        },
        "139137": {
            "CostOfDelay": null,
            "BusinessValue": null,
            "Effort": {
                "InverseAverage": 5,
                "ValueCount": 2,
                "FibonacciAverage": 8,
                "InverseValue": 1,
                "ValueMaximum": 1,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 2
            },
            "Id": 139137,
            "SortPriority": null,
            "SortPriorityGroup": null,
            "RiskReductionOpportunityEnablement": null,
            "SortOrder": 10,
            "TimeCriticality": null,
            "WeightedShortestJobFirst": null
        },
        "199351": {
            "CostOfDelay": null,
            "BusinessValue": null,
            "Effort": {
                "InverseAverage": 1,
                "ValueCount": 2,
                "FibonacciAverage": 1,
                "InverseValue": 5,
                "ValueMaximum": 5,
                "ValueMinimum": 5,
                "Notifications": null,
                "ValueSum": 10
            },
            "Id": 199351,
            "SortPriority": null,
            "SortPriorityGroup": null,
            "RiskReductionOpportunityEnablement": null,
            "SortOrder": 11,
            "TimeCriticality": null,
            "WeightedShortestJobFirst": null
        },
        "110775": {
            "CostOfDelay": null,
            "BusinessValue": {
                "InverseAverage": 5,
                "ValueCount": 1,
                "FibonacciAverage": 8,
                "InverseValue": 1,
                "ValueMaximum": 1,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 1
            },
            "Effort": {
                "InverseAverage": 3.5,
                "ValueCount": 2,
                "FibonacciAverage": 4,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 5
            },
            "Id": 110775,
            "SortPriority": null,
            "SortPriorityGroup": null,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 5,
                "ValueCount": 1,
                "FibonacciAverage": 8,
                "InverseValue": 1,
                "ValueMaximum": 1,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 1
            },
            "SortOrder": 12,
            "TimeCriticality": null,
            "WeightedShortestJobFirst": null
        },
        "126005": {
            "CostOfDelay": null,
            "BusinessValue": {
                "InverseAverage": 3,
                "ValueCount": 1,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 3
            },
            "Effort": {
                "InverseAverage": 3,
                "ValueCount": 2,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 6
            },
            "Id": 126005,
            "SortPriority": null,
            "SortPriorityGroup": null,
            "RiskReductionOpportunityEnablement": null,
            "SortOrder": 13,
            "TimeCriticality": null,
            "WeightedShortestJobFirst": null
        },
        "217114": {
            "CostOfDelay": null,
            "BusinessValue": {
                "InverseAverage": 3,
                "ValueCount": 1,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 3
            },
            "Effort": {
                "InverseAverage": 3.5,
                "ValueCount": 2,
                "FibonacciAverage": 4,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 5
            },
            "Id": 217114,
            "SortPriority": null,
            "SortPriorityGroup": null,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 3,
                "ValueCount": 1,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 3
            },
            "SortOrder": 14,
            "TimeCriticality": null,
            "WeightedShortestJobFirst": null
        },
        "110740": {
            "CostOfDelay": 24,
            "BusinessValue": {
                "InverseAverage": 5,
                "ValueCount": 2,
                "FibonacciAverage": 8,
                "InverseValue": 1,
                "ValueMaximum": 9,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 10
            },
            "Effort": {
                "InverseAverage": 3,
                "ValueCount": 2,
                "FibonacciAverage": 4.5,
                "InverseValue": 3,
                "ValueMaximum": 5,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 6
            },
            "Id": 110740,
            "SortPriority": 1,
            "SortPriorityGroup": 1,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 5,
                "ValueCount": 1,
                "FibonacciAverage": 8,
                "InverseValue": 1,
                "ValueMaximum": 1,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 1
            },
            "SortOrder": 15,
            "TimeCriticality": {
                "InverseAverage": 5,
                "ValueCount": 1,
                "FibonacciAverage": 8,
                "InverseValue": 1,
                "ValueMaximum": 1,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 1
            },
            "WeightedShortestJobFirst": 5.33333
        },
        "126007": {
            "CostOfDelay": 24,
            "BusinessValue": {
                "InverseAverage": 5,
                "ValueCount": 2,
                "FibonacciAverage": 8,
                "InverseValue": 1,
                "ValueMaximum": 1,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 2
            },
            "Effort": {
                "InverseAverage": 3,
                "ValueCount": 2,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 6
            },
            "Id": 126007,
            "SortPriority": 1,
            "SortPriorityGroup": 1,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 5,
                "ValueCount": 2,
                "FibonacciAverage": 8,
                "InverseValue": 1,
                "ValueMaximum": 1,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 2
            },
            "SortOrder": 16,
            "TimeCriticality": {
                "InverseAverage": 5,
                "ValueCount": 2,
                "FibonacciAverage": 8,
                "InverseValue": 1,
                "ValueMaximum": 1,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 2
            },
            "WeightedShortestJobFirst": 8
        },
        "135470": {
            "CostOfDelay": 24,
            "BusinessValue": {
                "InverseAverage": 5,
                "ValueCount": 2,
                "FibonacciAverage": 8,
                "InverseValue": 1,
                "ValueMaximum": 9,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 10
            },
            "Effort": {
                "InverseAverage": 4,
                "ValueCount": 1,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 2
            },
            "Id": 135470,
            "SortPriority": 1,
            "SortPriorityGroup": 1,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 5,
                "ValueCount": 1,
                "FibonacciAverage": 8,
                "InverseValue": 1,
                "ValueMaximum": 1,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 1
            },
            "SortOrder": 17,
            "TimeCriticality": {
                "InverseAverage": 5,
                "ValueCount": 1,
                "FibonacciAverage": 8,
                "InverseValue": 1,
                "ValueMaximum": 1,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 1
            },
            "WeightedShortestJobFirst": 4.8
        },
        "175188": {
            "CostOfDelay": 24,
            "BusinessValue": {
                "InverseAverage": 5,
                "ValueCount": 2,
                "FibonacciAverage": 8,
                "InverseValue": 1,
                "ValueMaximum": 1,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 2
            },
            "Effort": {
                "InverseAverage": 3.66667,
                "ValueCount": 3,
                "FibonacciAverage": 4.33333,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 7
            },
            "Id": 175188,
            "SortPriority": 1,
            "SortPriorityGroup": 1,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 5,
                "ValueCount": 2,
                "FibonacciAverage": 8,
                "InverseValue": 1,
                "ValueMaximum": 1,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 2
            },
            "SortOrder": 18,
            "TimeCriticality": {
                "InverseAverage": 5,
                "ValueCount": 2,
                "FibonacciAverage": 8,
                "InverseValue": 1,
                "ValueMaximum": 1,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 2
            },
            "WeightedShortestJobFirst": 5.53847
        },
        "185957": {
            "CostOfDelay": 24,
            "BusinessValue": {
                "InverseAverage": 5,
                "ValueCount": 1,
                "FibonacciAverage": 8,
                "InverseValue": 1,
                "ValueMaximum": 1,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 1
            },
            "Effort": {
                "InverseAverage": 4,
                "ValueCount": 2,
                "FibonacciAverage": 5.5,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 4
            },
            "Id": 185957,
            "SortPriority": 1,
            "SortPriorityGroup": 1,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 5,
                "ValueCount": 1,
                "FibonacciAverage": 8,
                "InverseValue": 1,
                "ValueMaximum": 1,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 1
            },
            "SortOrder": 19,
            "TimeCriticality": {
                "InverseAverage": 5,
                "ValueCount": 1,
                "FibonacciAverage": 8,
                "InverseValue": 1,
                "ValueMaximum": 1,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 1
            },
            "WeightedShortestJobFirst": 4.36364
        },
        "110976": {
            "CostOfDelay": 21,
            "BusinessValue": {
                "InverseAverage": 5,
                "ValueCount": 2,
                "FibonacciAverage": 8,
                "InverseValue": 1,
                "ValueMaximum": 1,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 2
            },
            "Effort": {
                "InverseAverage": 5,
                "ValueCount": 2,
                "FibonacciAverage": 8,
                "InverseValue": 1,
                "ValueMaximum": 1,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 2
            },
            "Id": 110976,
            "SortPriority": 1,
            "SortPriorityGroup": 1,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 4.5,
                "ValueCount": 2,
                "FibonacciAverage": 6.5,
                "InverseValue": 1,
                "ValueMaximum": 2,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 3
            },
            "SortOrder": 20,
            "TimeCriticality": {
                "InverseAverage": 4.5,
                "ValueCount": 2,
                "FibonacciAverage": 6.5,
                "InverseValue": 1,
                "ValueMaximum": 2,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 3
            },
            "WeightedShortestJobFirst": 2.625
        },
        "210045": {
            "CostOfDelay": 21,
            "BusinessValue": {
                "InverseAverage": 4.5,
                "ValueCount": 2,
                "FibonacciAverage": 6.5,
                "InverseValue": 1,
                "ValueMaximum": 2,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 3
            },
            "Effort": {
                "InverseAverage": 3,
                "ValueCount": 2,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 6
            },
            "Id": 210045,
            "SortPriority": 1,
            "SortPriorityGroup": 1,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 5,
                "ValueCount": 2,
                "FibonacciAverage": 8,
                "InverseValue": 1,
                "ValueMaximum": 1,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 2
            },
            "SortOrder": 21,
            "TimeCriticality": {
                "InverseAverage": 4.5,
                "ValueCount": 2,
                "FibonacciAverage": 6.5,
                "InverseValue": 1,
                "ValueMaximum": 2,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 3
            },
            "WeightedShortestJobFirst": 7
        },
        "110785": {
            "CostOfDelay": 19.5,
            "BusinessValue": {
                "InverseAverage": 4.5,
                "ValueCount": 2,
                "FibonacciAverage": 6.5,
                "InverseValue": 1,
                "ValueMaximum": 2,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 3
            },
            "Effort": {
                "InverseAverage": 4,
                "ValueCount": 2,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 4
            },
            "Id": 110785,
            "SortPriority": 1,
            "SortPriorityGroup": 2,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 4.5,
                "ValueCount": 2,
                "FibonacciAverage": 6.5,
                "InverseValue": 1,
                "ValueMaximum": 2,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 3
            },
            "SortOrder": 22,
            "TimeCriticality": {
                "InverseAverage": 4.5,
                "ValueCount": 2,
                "FibonacciAverage": 6.5,
                "InverseValue": 1,
                "ValueMaximum": 2,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 3
            },
            "WeightedShortestJobFirst": 3.9
        },
        "110795": {
            "CostOfDelay": 19.5,
            "BusinessValue": {
                "InverseAverage": 4.5,
                "ValueCount": 2,
                "FibonacciAverage": 6.5,
                "InverseValue": 1,
                "ValueMaximum": 2,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 3
            },
            "Effort": {
                "InverseAverage": 2.5,
                "ValueCount": 2,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 5,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 7
            },
            "Id": 110795,
            "SortPriority": 1,
            "SortPriorityGroup": 2,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 4.5,
                "ValueCount": 2,
                "FibonacciAverage": 6.5,
                "InverseValue": 1,
                "ValueMaximum": 2,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 3
            },
            "SortOrder": 23,
            "TimeCriticality": {
                "InverseAverage": 4.5,
                "ValueCount": 2,
                "FibonacciAverage": 6.5,
                "InverseValue": 1,
                "ValueMaximum": 2,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 3
            },
            "WeightedShortestJobFirst": 6.5
        },
        "126008": {
            "CostOfDelay": 19.5,
            "BusinessValue": {
                "InverseAverage": 4.5,
                "ValueCount": 2,
                "FibonacciAverage": 6.5,
                "InverseValue": 1,
                "ValueMaximum": 2,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 3
            },
            "Effort": {
                "InverseAverage": 3.5,
                "ValueCount": 2,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 4,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 5
            },
            "Id": 126008,
            "SortPriority": 1,
            "SortPriorityGroup": 2,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 4.5,
                "ValueCount": 2,
                "FibonacciAverage": 6.5,
                "InverseValue": 1,
                "ValueMaximum": 2,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 3
            },
            "SortOrder": 24,
            "TimeCriticality": {
                "InverseAverage": 4.5,
                "ValueCount": 2,
                "FibonacciAverage": 6.5,
                "InverseValue": 1,
                "ValueMaximum": 2,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 3
            },
            "WeightedShortestJobFirst": 3.9
        },
        "110779": {
            "CostOfDelay": 18.5,
            "BusinessValue": {
                "InverseAverage": 4.5,
                "ValueCount": 2,
                "FibonacciAverage": 6.5,
                "InverseValue": 1,
                "ValueMaximum": 2,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 3
            },
            "Effort": {
                "InverseAverage": 2,
                "ValueCount": 1,
                "FibonacciAverage": 2,
                "InverseValue": 4,
                "ValueMaximum": 4,
                "ValueMinimum": 4,
                "Notifications": null,
                "ValueSum": 4
            },
            "Id": 110779,
            "SortPriority": 1,
            "SortPriorityGroup": 2,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 4,
                "ValueCount": 2,
                "FibonacciAverage": 5.5,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 4
            },
            "SortOrder": 25,
            "TimeCriticality": {
                "InverseAverage": 4.5,
                "ValueCount": 2,
                "FibonacciAverage": 6.5,
                "InverseValue": 1,
                "ValueMaximum": 2,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 3
            },
            "WeightedShortestJobFirst": 9.25
        },
        "126020": {
            "CostOfDelay": 18,
            "BusinessValue": {
                "InverseAverage": 4.5,
                "ValueCount": 2,
                "FibonacciAverage": 6.5,
                "InverseValue": 1,
                "ValueMaximum": 2,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 3
            },
            "Effort": {
                "InverseAverage": 1.5,
                "ValueCount": 2,
                "FibonacciAverage": 1.5,
                "InverseValue": 4,
                "ValueMaximum": 5,
                "ValueMinimum": 4,
                "Notifications": null,
                "ValueSum": 9
            },
            "Id": 126020,
            "SortPriority": 1,
            "SortPriorityGroup": 2,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 4,
                "ValueCount": 2,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 4
            },
            "SortOrder": 26,
            "TimeCriticality": {
                "InverseAverage": 4.5,
                "ValueCount": 2,
                "FibonacciAverage": 6.5,
                "InverseValue": 1,
                "ValueMaximum": 2,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 3
            },
            "WeightedShortestJobFirst": 12
        },
        "126021": {
            "CostOfDelay": 18,
            "BusinessValue": {
                "InverseAverage": 4.5,
                "ValueCount": 2,
                "FibonacciAverage": 6.5,
                "InverseValue": 1,
                "ValueMaximum": 2,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 3
            },
            "Effort": {
                "InverseAverage": 4.66667,
                "ValueCount": 3,
                "FibonacciAverage": 7,
                "InverseValue": 1,
                "ValueMaximum": 2,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 4
            },
            "Id": 126021,
            "SortPriority": 1,
            "SortPriorityGroup": 2,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 4,
                "ValueCount": 2,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 4
            },
            "SortOrder": 27,
            "TimeCriticality": {
                "InverseAverage": 4.5,
                "ValueCount": 2,
                "FibonacciAverage": 6.5,
                "InverseValue": 1,
                "ValueMaximum": 2,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 3
            },
            "WeightedShortestJobFirst": 2.57143
        },
        "126022": {
            "CostOfDelay": 18,
            "BusinessValue": {
                "InverseAverage": 4.5,
                "ValueCount": 2,
                "FibonacciAverage": 6.5,
                "InverseValue": 1,
                "ValueMaximum": 2,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 3
            },
            "Effort": {
                "InverseAverage": 4.33333,
                "ValueCount": 3,
                "FibonacciAverage": 6,
                "InverseValue": 1,
                "ValueMaximum": 2,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 5
            },
            "Id": 126022,
            "SortPriority": 1,
            "SortPriorityGroup": 2,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 4,
                "ValueCount": 2,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 4
            },
            "SortOrder": 28,
            "TimeCriticality": {
                "InverseAverage": 4.5,
                "ValueCount": 2,
                "FibonacciAverage": 6.5,
                "InverseValue": 1,
                "ValueMaximum": 2,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 3
            },
            "WeightedShortestJobFirst": 3
        },
        "111882": {
            "CostOfDelay": 17,
            "BusinessValue": {
                "InverseAverage": 4,
                "ValueCount": 2,
                "FibonacciAverage": 5.5,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 4
            },
            "Effort": {
                "InverseAverage": 3.33333,
                "ValueCount": 3,
                "FibonacciAverage": 3.66667,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 8
            },
            "Id": 111882,
            "SortPriority": 1,
            "SortPriorityGroup": 2,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 4,
                "ValueCount": 2,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 4
            },
            "SortOrder": 29,
            "TimeCriticality": {
                "InverseAverage": 4.5,
                "ValueCount": 2,
                "FibonacciAverage": 6.5,
                "InverseValue": 1,
                "ValueMaximum": 2,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 3
            },
            "WeightedShortestJobFirst": 4.63636
        },
        "110807": {
            "CostOfDelay": 17,
            "BusinessValue": {
                "InverseAverage": 3.5,
                "ValueCount": 2,
                "FibonacciAverage": 4,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 5
            },
            "Effort": {
                "InverseAverage": 3.5,
                "ValueCount": 2,
                "FibonacciAverage": 4,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 5
            },
            "Id": 110807,
            "SortPriority": 1,
            "SortPriorityGroup": 3,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 4,
                "ValueCount": 1,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 2
            },
            "SortOrder": 30,
            "TimeCriticality": {
                "InverseAverage": 5,
                "ValueCount": 1,
                "FibonacciAverage": 8,
                "InverseValue": 1,
                "ValueMaximum": 1,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 1
            },
            "WeightedShortestJobFirst": 4.25
        },
        "110797": {
            "CostOfDelay": 16.5,
            "BusinessValue": {
                "InverseAverage": 4.5,
                "ValueCount": 2,
                "FibonacciAverage": 6.5,
                "InverseValue": 1,
                "ValueMaximum": 2,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 3
            },
            "Effort": {
                "InverseAverage": 3.5,
                "ValueCount": 2,
                "FibonacciAverage": 4,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 5
            },
            "Id": 110797,
            "SortPriority": 1,
            "SortPriorityGroup": 3,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 3,
                "ValueCount": 2,
                "FibonacciAverage": 3.5,
                "InverseValue": 3,
                "ValueMaximum": 4,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 6
            },
            "SortOrder": 31,
            "TimeCriticality": {
                "InverseAverage": 4.5,
                "ValueCount": 2,
                "FibonacciAverage": 6.5,
                "InverseValue": 1,
                "ValueMaximum": 2,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 3
            },
            "WeightedShortestJobFirst": 4.125
        },
        "110748": {
            "CostOfDelay": 16,
            "BusinessValue": {
                "InverseAverage": 3,
                "ValueCount": 1,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 3
            },
            "Effort": {
                "InverseAverage": 3.33333,
                "ValueCount": 3,
                "FibonacciAverage": 4,
                "InverseValue": 2,
                "ValueMaximum": 4,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 8
            },
            "Id": 110748,
            "SortPriority": 1,
            "SortPriorityGroup": 3,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 4,
                "ValueCount": 1,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 2
            },
            "SortOrder": 32,
            "TimeCriticality": {
                "InverseAverage": 5,
                "ValueCount": 1,
                "FibonacciAverage": 8,
                "InverseValue": 1,
                "ValueMaximum": 1,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 1
            },
            "WeightedShortestJobFirst": 4
        },
        "110776": {
            "CostOfDelay": 15.5,
            "BusinessValue": {
                "InverseAverage": 4.5,
                "ValueCount": 2,
                "FibonacciAverage": 6.5,
                "InverseValue": 1,
                "ValueMaximum": 2,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 3
            },
            "Effort": {
                "InverseAverage": 1.5,
                "ValueCount": 2,
                "FibonacciAverage": 1.5,
                "InverseValue": 4,
                "ValueMaximum": 5,
                "ValueMinimum": 4,
                "Notifications": null,
                "ValueSum": 9
            },
            "Id": 110776,
            "SortPriority": 1,
            "SortPriorityGroup": 3,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 4,
                "ValueCount": 1,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 2
            },
            "SortOrder": 33,
            "TimeCriticality": {
                "InverseAverage": 3.5,
                "ValueCount": 2,
                "FibonacciAverage": 4,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 5
            },
            "WeightedShortestJobFirst": 10.33333
        },
        "132028": {
            "CostOfDelay": 15.5,
            "BusinessValue": {
                "InverseAverage": 4.5,
                "ValueCount": 2,
                "FibonacciAverage": 6.5,
                "InverseValue": 1,
                "ValueMaximum": 2,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 3
            },
            "Effort": {
                "InverseAverage": 2,
                "ValueCount": 2,
                "FibonacciAverage": 2,
                "InverseValue": 4,
                "ValueMaximum": 4,
                "ValueMinimum": 4,
                "Notifications": null,
                "ValueSum": 8
            },
            "Id": 132028,
            "SortPriority": 1,
            "SortPriorityGroup": 3,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 4,
                "ValueCount": 1,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 2
            },
            "SortOrder": 34,
            "TimeCriticality": {
                "InverseAverage": 3.5,
                "ValueCount": 2,
                "FibonacciAverage": 4,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 5
            },
            "WeightedShortestJobFirst": 7.75
        },
        "110746": {
            "CostOfDelay": 15,
            "BusinessValue": {
                "InverseAverage": 4,
                "ValueCount": 1,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 2
            },
            "Effort": {
                "InverseAverage": 3.33333,
                "ValueCount": 3,
                "FibonacciAverage": 3.66667,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 8
            },
            "Id": 110746,
            "SortPriority": 1,
            "SortPriorityGroup": 3,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 4,
                "ValueCount": 1,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 2
            },
            "SortOrder": 35,
            "TimeCriticality": {
                "InverseAverage": 4,
                "ValueCount": 1,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 2
            },
            "WeightedShortestJobFirst": 4.09091
        },
        "110747": {
            "CostOfDelay": 15,
            "BusinessValue": {
                "InverseAverage": 4,
                "ValueCount": 1,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 2
            },
            "Effort": {
                "InverseAverage": 2.5,
                "ValueCount": 2,
                "FibonacciAverage": 2.5,
                "InverseValue": 3,
                "ValueMaximum": 4,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 7
            },
            "Id": 110747,
            "SortPriority": 1,
            "SortPriorityGroup": 3,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 4,
                "ValueCount": 1,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 2
            },
            "SortOrder": 36,
            "TimeCriticality": {
                "InverseAverage": 4,
                "ValueCount": 1,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 2
            },
            "WeightedShortestJobFirst": 6
        },
        "110749": {
            "CostOfDelay": 15,
            "BusinessValue": {
                "InverseAverage": 4,
                "ValueCount": 1,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 2
            },
            "Effort": {
                "InverseAverage": 4,
                "ValueCount": 1,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 2
            },
            "Id": 110749,
            "SortPriority": 1,
            "SortPriorityGroup": 3,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 4,
                "ValueCount": 1,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 2
            },
            "SortOrder": 37,
            "TimeCriticality": {
                "InverseAverage": 4,
                "ValueCount": 1,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 2
            },
            "WeightedShortestJobFirst": 3
        },
        "110757": {
            "CostOfDelay": 15,
            "BusinessValue": {
                "InverseAverage": 4,
                "ValueCount": 2,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 4
            },
            "Effort": {
                "InverseAverage": 3.66667,
                "ValueCount": 3,
                "FibonacciAverage": 4.33333,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 7
            },
            "Id": 110757,
            "SortPriority": 1,
            "SortPriorityGroup": 4,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 4,
                "ValueCount": 1,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 2
            },
            "SortOrder": 38,
            "TimeCriticality": {
                "InverseAverage": 4,
                "ValueCount": 2,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 4
            },
            "WeightedShortestJobFirst": 3.46154
        },
        "110759": {
            "CostOfDelay": 15,
            "BusinessValue": {
                "InverseAverage": 4,
                "ValueCount": 1,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 2
            },
            "Effort": {
                "InverseAverage": 3,
                "ValueCount": 2,
                "FibonacciAverage": 3.5,
                "InverseValue": 3,
                "ValueMaximum": 4,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 6
            },
            "Id": 110759,
            "SortPriority": 2,
            "SortPriorityGroup": 4,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 4,
                "ValueCount": 1,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 2
            },
            "SortOrder": 39,
            "TimeCriticality": {
                "InverseAverage": 4,
                "ValueCount": 1,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 2
            },
            "WeightedShortestJobFirst": 4.28571
        },
        "110760": {
            "CostOfDelay": 15,
            "BusinessValue": {
                "InverseAverage": 4,
                "ValueCount": 1,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 2
            },
            "Effort": {
                "InverseAverage": 5,
                "ValueCount": 1,
                "FibonacciAverage": 8,
                "InverseValue": 1,
                "ValueMaximum": 1,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 1
            },
            "Id": 110760,
            "SortPriority": 2,
            "SortPriorityGroup": 4,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 4,
                "ValueCount": 1,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 2
            },
            "SortOrder": 40,
            "TimeCriticality": {
                "InverseAverage": 4,
                "ValueCount": 1,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 2
            },
            "WeightedShortestJobFirst": 1.875
        },
        "110772": {
            "CostOfDelay": 15,
            "BusinessValue": {
                "InverseAverage": 4,
                "ValueCount": 1,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 2
            },
            "Effort": {
                "InverseAverage": 2.66667,
                "ValueCount": 3,
                "FibonacciAverage": 2.66667,
                "InverseValue": 3,
                "ValueMaximum": 4,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 10
            },
            "Id": 110772,
            "SortPriority": 2,
            "SortPriorityGroup": 4,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 4,
                "ValueCount": 1,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 2
            },
            "SortOrder": 41,
            "TimeCriticality": {
                "InverseAverage": 4,
                "ValueCount": 1,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 2
            },
            "WeightedShortestJobFirst": 5.62499
        },
        "126173": {
            "CostOfDelay": 15,
            "BusinessValue": {
                "InverseAverage": 4,
                "ValueCount": 2,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 4
            },
            "Effort": {
                "InverseAverage": 4.5,
                "ValueCount": 2,
                "FibonacciAverage": 6.5,
                "InverseValue": 1,
                "ValueMaximum": 2,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 3
            },
            "Id": 126173,
            "SortPriority": 2,
            "SortPriorityGroup": 4,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 4,
                "ValueCount": 2,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 4
            },
            "SortOrder": 42,
            "TimeCriticality": {
                "InverseAverage": 4,
                "ValueCount": 2,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 4
            },
            "WeightedShortestJobFirst": 2.30769
        },
        "187504": {
            "CostOfDelay": 15,
            "BusinessValue": {
                "InverseAverage": 4,
                "ValueCount": 2,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 4
            },
            "Effort": {
                "InverseAverage": 3,
                "ValueCount": 3,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 9
            },
            "Id": 187504,
            "SortPriority": 2,
            "SortPriorityGroup": 4,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 4,
                "ValueCount": 2,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 4
            },
            "SortOrder": 43,
            "TimeCriticality": {
                "InverseAverage": 4,
                "ValueCount": 2,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 4
            },
            "WeightedShortestJobFirst": 5
        },
        "110768": {
            "CostOfDelay": 15,
            "BusinessValue": {
                "InverseAverage": 3.5,
                "ValueCount": 2,
                "FibonacciAverage": 4,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 5
            },
            "Effort": {
                "InverseAverage": 3.5,
                "ValueCount": 2,
                "FibonacciAverage": 4,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 5
            },
            "Id": 110768,
            "SortPriority": 2,
            "SortPriorityGroup": 4,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 3,
                "ValueCount": 1,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 3
            },
            "SortOrder": 44,
            "TimeCriticality": {
                "InverseAverage": 5,
                "ValueCount": 1,
                "FibonacciAverage": 8,
                "InverseValue": 1,
                "ValueMaximum": 1,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 1
            },
            "WeightedShortestJobFirst": 3.75
        },
        "219637": {
            "CostOfDelay": 14.5,
            "BusinessValue": {
                "InverseAverage": 4.5,
                "ValueCount": 2,
                "FibonacciAverage": 6.5,
                "InverseValue": 1,
                "ValueMaximum": 2,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 3
            },
            "Effort": {
                "InverseAverage": 4.5,
                "ValueCount": 2,
                "FibonacciAverage": 6.5,
                "InverseValue": 1,
                "ValueMaximum": 2,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 3
            },
            "Id": 219637,
            "SortPriority": 2,
            "SortPriorityGroup": 4,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 3,
                "ValueCount": 2,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 6
            },
            "SortOrder": 45,
            "TimeCriticality": {
                "InverseAverage": 4,
                "ValueCount": 2,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 4
            },
            "WeightedShortestJobFirst": 2.23077
        },
        "110806": {
            "CostOfDelay": 14.5,
            "BusinessValue": {
                "InverseAverage": 3.5,
                "ValueCount": 2,
                "FibonacciAverage": 4,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 5
            },
            "Effort": {
                "InverseAverage": 3,
                "ValueCount": 2,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 6
            },
            "Id": 110806,
            "SortPriority": 2,
            "SortPriorityGroup": 5,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 4,
                "ValueCount": 2,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 4
            },
            "SortOrder": 46,
            "TimeCriticality": {
                "InverseAverage": 4,
                "ValueCount": 2,
                "FibonacciAverage": 5.5,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 4
            },
            "WeightedShortestJobFirst": 4.83333
        },
        "220257": {
            "CostOfDelay": 14.5,
            "BusinessValue": {
                "InverseAverage": 3.5,
                "ValueCount": 2,
                "FibonacciAverage": 4,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 5
            },
            "Effort": null,
            "Id": 220257,
            "SortPriority": 2,
            "SortPriorityGroup": 5,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 4,
                "ValueCount": 2,
                "FibonacciAverage": 5.5,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 4
            },
            "SortOrder": 47,
            "TimeCriticality": {
                "InverseAverage": 4,
                "ValueCount": 1,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 2
            },
            "WeightedShortestJobFirst": null
        },
        "110737": {
            "CostOfDelay": 14,
            "BusinessValue": {
                "InverseAverage": 4,
                "ValueCount": 2,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 4
            },
            "Effort": {
                "InverseAverage": 3.66667,
                "ValueCount": 3,
                "FibonacciAverage": 4.33333,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 7
            },
            "Id": 110737,
            "SortPriority": 2,
            "SortPriorityGroup": 5,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 3.5,
                "ValueCount": 2,
                "FibonacciAverage": 4,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 5
            },
            "SortOrder": 48,
            "TimeCriticality": {
                "InverseAverage": 4,
                "ValueCount": 2,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 4
            },
            "WeightedShortestJobFirst": 3.23077
        },
        "110754": {
            "CostOfDelay": 14,
            "BusinessValue": {
                "InverseAverage": 4,
                "ValueCount": 1,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 2
            },
            "Effort": {
                "InverseAverage": 1.5,
                "ValueCount": 3,
                "FibonacciAverage": 1.5,
                "InverseValue": 4,
                "ValueMaximum": 9,
                "ValueMinimum": 4,
                "Notifications": null,
                "ValueSum": 18
            },
            "Id": 110754,
            "SortPriority": 2,
            "SortPriorityGroup": 5,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 4,
                "ValueCount": 1,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 2
            },
            "SortOrder": 49,
            "TimeCriticality": {
                "InverseAverage": 3.5,
                "ValueCount": 2,
                "FibonacciAverage": 4,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 5
            },
            "WeightedShortestJobFirst": 9.33333
        },
        "110758": {
            "CostOfDelay": 14,
            "BusinessValue": {
                "InverseAverage": 4,
                "ValueCount": 2,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 4
            },
            "Effort": {
                "InverseAverage": 2.5,
                "ValueCount": 2,
                "FibonacciAverage": 2.5,
                "InverseValue": 3,
                "ValueMaximum": 4,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 7
            },
            "Id": 110758,
            "SortPriority": 2,
            "SortPriorityGroup": 5,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 4,
                "ValueCount": 1,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 2
            },
            "SortOrder": 50,
            "TimeCriticality": {
                "InverseAverage": 3.5,
                "ValueCount": 2,
                "FibonacciAverage": 4,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 5
            },
            "WeightedShortestJobFirst": 5.6
        },
        "120987": {
            "CostOfDelay": 14,
            "BusinessValue": {
                "InverseAverage": 4,
                "ValueCount": 2,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 4
            },
            "Effort": {
                "InverseAverage": 3.66667,
                "ValueCount": 3,
                "FibonacciAverage": 4.33333,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 7
            },
            "Id": 120987,
            "SortPriority": 2,
            "SortPriorityGroup": 5,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 3.5,
                "ValueCount": 2,
                "FibonacciAverage": 4,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 5
            },
            "SortOrder": 51,
            "TimeCriticality": {
                "InverseAverage": 4,
                "ValueCount": 2,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 4
            },
            "WeightedShortestJobFirst": 3.23077
        },
        "109734": {
            "CostOfDelay": 14,
            "BusinessValue": {
                "InverseAverage": 3.5,
                "ValueCount": 2,
                "FibonacciAverage": 4,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 5
            },
            "Effort": {
                "InverseAverage": 2,
                "ValueCount": 2,
                "FibonacciAverage": 2,
                "InverseValue": 4,
                "ValueMaximum": 5,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 8
            },
            "Id": 109734,
            "SortPriority": 2,
            "SortPriorityGroup": 5,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 4,
                "ValueCount": 1,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 2
            },
            "SortOrder": 52,
            "TimeCriticality": {
                "InverseAverage": 4,
                "ValueCount": 2,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 4
            },
            "WeightedShortestJobFirst": 7
        },
        "109735": {
            "CostOfDelay": 14,
            "BusinessValue": {
                "InverseAverage": 3.5,
                "ValueCount": 2,
                "FibonacciAverage": 4,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 5
            },
            "Effort": {
                "InverseAverage": 2.5,
                "ValueCount": 2,
                "FibonacciAverage": 2.5,
                "InverseValue": 3,
                "ValueMaximum": 4,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 7
            },
            "Id": 109735,
            "SortPriority": 2,
            "SortPriorityGroup": 5,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 4,
                "ValueCount": 1,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 2
            },
            "SortOrder": 53,
            "TimeCriticality": {
                "InverseAverage": 4,
                "ValueCount": 2,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 4
            },
            "WeightedShortestJobFirst": 5.6
        },
        "110790": {
            "CostOfDelay": 14,
            "BusinessValue": {
                "InverseAverage": 3.5,
                "ValueCount": 2,
                "FibonacciAverage": 4,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 5
            },
            "Effort": {
                "InverseAverage": 3,
                "ValueCount": 2,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 6
            },
            "Id": 110790,
            "SortPriority": 2,
            "SortPriorityGroup": 6,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 4,
                "ValueCount": 1,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 2
            },
            "SortOrder": 54,
            "TimeCriticality": {
                "InverseAverage": 4,
                "ValueCount": 2,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 4
            },
            "WeightedShortestJobFirst": 4.66667
        },
        "216303": {
            "CostOfDelay": 14,
            "BusinessValue": {
                "InverseAverage": 3.5,
                "ValueCount": 2,
                "FibonacciAverage": 4,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 5
            },
            "Effort": {
                "InverseAverage": 3.5,
                "ValueCount": 2,
                "FibonacciAverage": 4,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 5
            },
            "Id": 216303,
            "SortPriority": 2,
            "SortPriorityGroup": 6,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 4,
                "ValueCount": 2,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 4
            },
            "SortOrder": 55,
            "TimeCriticality": {
                "InverseAverage": 4,
                "ValueCount": 2,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 4
            },
            "WeightedShortestJobFirst": 3.5
        },
        "110742": {
            "CostOfDelay": 13,
            "BusinessValue": {
                "InverseAverage": 4,
                "ValueCount": 1,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 2
            },
            "Effort": {
                "InverseAverage": 4,
                "ValueCount": 3,
                "FibonacciAverage": 5.33333,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 6
            },
            "Id": 110742,
            "SortPriority": 2,
            "SortPriorityGroup": 6,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 3,
                "ValueCount": 1,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 3
            },
            "SortOrder": 56,
            "TimeCriticality": {
                "InverseAverage": 4,
                "ValueCount": 1,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 2
            },
            "WeightedShortestJobFirst": 2.4375
        },
        "110750": {
            "CostOfDelay": 13,
            "BusinessValue": {
                "InverseAverage": 4,
                "ValueCount": 1,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 2
            },
            "Effort": {
                "InverseAverage": 2,
                "ValueCount": 2,
                "FibonacciAverage": 2,
                "InverseValue": 4,
                "ValueMaximum": 4,
                "ValueMinimum": 4,
                "Notifications": null,
                "ValueSum": 8
            },
            "Id": 110750,
            "SortPriority": 2,
            "SortPriorityGroup": 6,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 3,
                "ValueCount": 1,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 3
            },
            "SortOrder": 57,
            "TimeCriticality": {
                "InverseAverage": 4,
                "ValueCount": 1,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 2
            },
            "WeightedShortestJobFirst": 6.5
        },
        "110756": {
            "CostOfDelay": 13,
            "BusinessValue": {
                "InverseAverage": 4,
                "ValueCount": 2,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 4
            },
            "Effort": {
                "InverseAverage": 3,
                "ValueCount": 3,
                "FibonacciAverage": 3.33333,
                "InverseValue": 3,
                "ValueMaximum": 4,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 9
            },
            "Id": 110756,
            "SortPriority": 2,
            "SortPriorityGroup": 6,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 3,
                "ValueCount": 1,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 3
            },
            "SortOrder": 58,
            "TimeCriticality": {
                "InverseAverage": 4,
                "ValueCount": 2,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 4
            },
            "WeightedShortestJobFirst": 3.9
        },
        "110764": {
            "CostOfDelay": 13,
            "BusinessValue": {
                "InverseAverage": 4,
                "ValueCount": 1,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 2
            },
            "Effort": {
                "InverseAverage": 3,
                "ValueCount": 2,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 6
            },
            "Id": 110764,
            "SortPriority": 2,
            "SortPriorityGroup": 6,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 3,
                "ValueCount": 1,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 3
            },
            "SortOrder": 59,
            "TimeCriticality": {
                "InverseAverage": 4,
                "ValueCount": 1,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 2
            },
            "WeightedShortestJobFirst": 4.33333
        },
        "110765": {
            "CostOfDelay": 13,
            "BusinessValue": {
                "InverseAverage": 4,
                "ValueCount": 1,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 2
            },
            "Effort": {
                "InverseAverage": 3.5,
                "ValueCount": 2,
                "FibonacciAverage": 4,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 5
            },
            "Id": 110765,
            "SortPriority": 2,
            "SortPriorityGroup": 6,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 3,
                "ValueCount": 1,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 3
            },
            "SortOrder": 60,
            "TimeCriticality": {
                "InverseAverage": 4,
                "ValueCount": 1,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 2
            },
            "WeightedShortestJobFirst": 3.25
        },
        "110796": {
            "CostOfDelay": 13,
            "BusinessValue": {
                "InverseAverage": 4,
                "ValueCount": 1,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 2
            },
            "Effort": {
                "InverseAverage": 3.33333,
                "ValueCount": 3,
                "FibonacciAverage": 3.66667,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 8
            },
            "Id": 110796,
            "SortPriority": 2,
            "SortPriorityGroup": 6,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 3,
                "ValueCount": 1,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 3
            },
            "SortOrder": 61,
            "TimeCriticality": {
                "InverseAverage": 4,
                "ValueCount": 2,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 4
            },
            "WeightedShortestJobFirst": 3.54545
        },
        "218979": {
            "CostOfDelay": 13,
            "BusinessValue": {
                "InverseAverage": 3.5,
                "ValueCount": 2,
                "FibonacciAverage": 4,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 5
            },
            "Effort": {
                "InverseAverage": 3,
                "ValueCount": 1,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 3
            },
            "Id": 218979,
            "SortPriority": 2,
            "SortPriorityGroup": 7,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 4,
                "ValueCount": 2,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 4
            },
            "SortOrder": 62,
            "TimeCriticality": {
                "InverseAverage": 3.5,
                "ValueCount": 2,
                "FibonacciAverage": 4,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 5
            },
            "WeightedShortestJobFirst": 4.33333
        },
        "110767": {
            "CostOfDelay": 12,
            "BusinessValue": {
                "InverseAverage": 4,
                "ValueCount": 2,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 4
            },
            "Effort": {
                "InverseAverage": 3,
                "ValueCount": 1,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 3
            },
            "Id": 110767,
            "SortPriority": 2,
            "SortPriorityGroup": 7,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 3,
                "ValueCount": 1,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 3
            },
            "SortOrder": 63,
            "TimeCriticality": {
                "InverseAverage": 3.5,
                "ValueCount": 2,
                "FibonacciAverage": 4,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 5
            },
            "WeightedShortestJobFirst": 4
        },
        "129218": {
            "CostOfDelay": 12,
            "BusinessValue": {
                "InverseAverage": 4,
                "ValueCount": 2,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 9,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 11
            },
            "Effort": {
                "InverseAverage": 3,
                "ValueCount": 2,
                "FibonacciAverage": 3.5,
                "InverseValue": 3,
                "ValueMaximum": 4,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 6
            },
            "Id": 129218,
            "SortPriority": 3,
            "SortPriorityGroup": 7,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 3,
                "ValueCount": 1,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 3
            },
            "SortOrder": 64,
            "TimeCriticality": {
                "InverseAverage": 3.5,
                "ValueCount": 2,
                "FibonacciAverage": 4,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 5
            },
            "WeightedShortestJobFirst": 3.42857
        },
        "109737": {
            "CostOfDelay": 12,
            "BusinessValue": {
                "InverseAverage": 3.5,
                "ValueCount": 2,
                "FibonacciAverage": 4,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 5
            },
            "Effort": {
                "InverseAverage": 2.66667,
                "ValueCount": 3,
                "FibonacciAverage": 2.66667,
                "InverseValue": 3,
                "ValueMaximum": 4,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 10
            },
            "Id": 109737,
            "SortPriority": 3,
            "SortPriorityGroup": 7,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 4,
                "ValueCount": 1,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 2
            },
            "SortOrder": 65,
            "TimeCriticality": {
                "InverseAverage": 3,
                "ValueCount": 2,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 6
            },
            "WeightedShortestJobFirst": 4.49999
        },
        "110738": {
            "CostOfDelay": 12,
            "BusinessValue": {
                "InverseAverage": 3.5,
                "ValueCount": 2,
                "FibonacciAverage": 4,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 5
            },
            "Effort": {
                "InverseAverage": 2.5,
                "ValueCount": 2,
                "FibonacciAverage": 2.5,
                "InverseValue": 3,
                "ValueMaximum": 4,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 7
            },
            "Id": 110738,
            "SortPriority": 3,
            "SortPriorityGroup": 7,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 4,
                "ValueCount": 2,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 4
            },
            "SortOrder": 66,
            "TimeCriticality": {
                "InverseAverage": 3,
                "ValueCount": 2,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 6
            },
            "WeightedShortestJobFirst": 4.8
        },
        "110787": {
            "CostOfDelay": 12,
            "BusinessValue": {
                "InverseAverage": 3.5,
                "ValueCount": 2,
                "FibonacciAverage": 4,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 5
            },
            "Effort": {
                "InverseAverage": 3,
                "ValueCount": 3,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 9
            },
            "Id": 110787,
            "SortPriority": 3,
            "SortPriorityGroup": 7,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 3.5,
                "ValueCount": 2,
                "FibonacciAverage": 4,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 5
            },
            "SortOrder": 67,
            "TimeCriticality": {
                "InverseAverage": 3.5,
                "ValueCount": 2,
                "FibonacciAverage": 4,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 5
            },
            "WeightedShortestJobFirst": 4
        },
        "110793": {
            "CostOfDelay": 12,
            "BusinessValue": {
                "InverseAverage": 3.5,
                "ValueCount": 2,
                "FibonacciAverage": 4,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 5
            },
            "Effort": {
                "InverseAverage": 2,
                "ValueCount": 2,
                "FibonacciAverage": 2,
                "InverseValue": 4,
                "ValueMaximum": 4,
                "ValueMinimum": 4,
                "Notifications": null,
                "ValueSum": 8
            },
            "Id": 110793,
            "SortPriority": 3,
            "SortPriorityGroup": 7,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 3,
                "ValueCount": 2,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 6
            },
            "SortOrder": 68,
            "TimeCriticality": {
                "InverseAverage": 4,
                "ValueCount": 2,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 4
            },
            "WeightedShortestJobFirst": 6
        },
        "126003": {
            "CostOfDelay": 12,
            "BusinessValue": {
                "InverseAverage": 3.5,
                "ValueCount": 2,
                "FibonacciAverage": 4,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 5
            },
            "Effort": {
                "InverseAverage": 3,
                "ValueCount": 2,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 6
            },
            "Id": 126003,
            "SortPriority": 3,
            "SortPriorityGroup": 7,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 2.5,
                "ValueCount": 2,
                "FibonacciAverage": 2.5,
                "InverseValue": 3,
                "ValueMaximum": 4,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 7
            },
            "SortOrder": 69,
            "TimeCriticality": {
                "InverseAverage": 4,
                "ValueCount": 2,
                "FibonacciAverage": 5.5,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 4
            },
            "WeightedShortestJobFirst": 4
        },
        "202208": {
            "CostOfDelay": 11.5,
            "BusinessValue": {
                "InverseAverage": 3.5,
                "ValueCount": 2,
                "FibonacciAverage": 4,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 5
            },
            "Effort": {
                "InverseAverage": 2.5,
                "ValueCount": 2,
                "FibonacciAverage": 2.5,
                "InverseValue": 3,
                "ValueMaximum": 4,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 7
            },
            "Id": 202208,
            "SortPriority": 3,
            "SortPriorityGroup": 8,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 2.5,
                "ValueCount": 2,
                "FibonacciAverage": 2.5,
                "InverseValue": 3,
                "ValueMaximum": 4,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 7
            },
            "SortOrder": 70,
            "TimeCriticality": {
                "InverseAverage": 4,
                "ValueCount": 2,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 4
            },
            "WeightedShortestJobFirst": 4.6
        },
        "110766": {
            "CostOfDelay": 11,
            "BusinessValue": {
                "InverseAverage": 4,
                "ValueCount": 2,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 4
            },
            "Effort": {
                "InverseAverage": 5,
                "ValueCount": 2,
                "FibonacciAverage": 8,
                "InverseValue": 1,
                "ValueMaximum": 1,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 2
            },
            "Id": 110766,
            "SortPriority": 3,
            "SortPriorityGroup": 8,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 3,
                "ValueCount": 1,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 3
            },
            "SortOrder": 71,
            "TimeCriticality": {
                "InverseAverage": 3,
                "ValueCount": 2,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 6
            },
            "WeightedShortestJobFirst": 1.375
        },
        "110751": {
            "CostOfDelay": 11,
            "BusinessValue": {
                "InverseAverage": 3.5,
                "ValueCount": 2,
                "FibonacciAverage": 4,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 5
            },
            "Effort": {
                "InverseAverage": 3,
                "ValueCount": 3,
                "FibonacciAverage": 3.33333,
                "InverseValue": 3,
                "ValueMaximum": 4,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 9
            },
            "Id": 110751,
            "SortPriority": 3,
            "SortPriorityGroup": 8,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 3,
                "ValueCount": 1,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 3
            },
            "SortOrder": 72,
            "TimeCriticality": {
                "InverseAverage": 3.5,
                "ValueCount": 2,
                "FibonacciAverage": 4,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 5
            },
            "WeightedShortestJobFirst": 3.3
        },
        "110755": {
            "CostOfDelay": 10.5,
            "BusinessValue": {
                "InverseAverage": 4,
                "ValueCount": 2,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 4
            },
            "Effort": {
                "InverseAverage": 2.66667,
                "ValueCount": 3,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 5,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 10
            },
            "Id": 110755,
            "SortPriority": 3,
            "SortPriorityGroup": 8,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 2.5,
                "ValueCount": 2,
                "FibonacciAverage": 2.5,
                "InverseValue": 3,
                "ValueMaximum": 4,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 7
            },
            "SortOrder": 73,
            "TimeCriticality": {
                "InverseAverage": 3,
                "ValueCount": 2,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 6
            },
            "WeightedShortestJobFirst": 3.5
        },
        "187502": {
            "CostOfDelay": 10.5,
            "BusinessValue": {
                "InverseAverage": 4,
                "ValueCount": 2,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 4
            },
            "Effort": {
                "InverseAverage": 2,
                "ValueCount": 2,
                "FibonacciAverage": 2,
                "InverseValue": 4,
                "ValueMaximum": 4,
                "ValueMinimum": 4,
                "Notifications": null,
                "ValueSum": 8
            },
            "Id": 187502,
            "SortPriority": 3,
            "SortPriorityGroup": 8,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 2.5,
                "ValueCount": 2,
                "FibonacciAverage": 2.5,
                "InverseValue": 3,
                "ValueMaximum": 4,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 7
            },
            "SortOrder": 74,
            "TimeCriticality": {
                "InverseAverage": 3,
                "ValueCount": 2,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 6
            },
            "WeightedShortestJobFirst": 5.25
        },
        "187503": {
            "CostOfDelay": 10.5,
            "BusinessValue": {
                "InverseAverage": 4,
                "ValueCount": 2,
                "FibonacciAverage": 5,
                "InverseValue": 2,
                "ValueMaximum": 2,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 4
            },
            "Effort": {
                "InverseAverage": 3,
                "ValueCount": 1,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 3
            },
            "Id": 187503,
            "SortPriority": 3,
            "SortPriorityGroup": 8,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 2.5,
                "ValueCount": 2,
                "FibonacciAverage": 2.5,
                "InverseValue": 3,
                "ValueMaximum": 4,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 7
            },
            "SortOrder": 75,
            "TimeCriticality": {
                "InverseAverage": 3,
                "ValueCount": 2,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 6
            },
            "WeightedShortestJobFirst": 3.5
        },
        "110773": {
            "CostOfDelay": 10,
            "BusinessValue": {
                "InverseAverage": 3.5,
                "ValueCount": 2,
                "FibonacciAverage": 4,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 5
            },
            "Effort": {
                "InverseAverage": 2.5,
                "ValueCount": 2,
                "FibonacciAverage": 2.5,
                "InverseValue": 3,
                "ValueMaximum": 4,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 7
            },
            "Id": 110773,
            "SortPriority": 3,
            "SortPriorityGroup": 8,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 3,
                "ValueCount": 1,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 3
            },
            "SortOrder": 76,
            "TimeCriticality": {
                "InverseAverage": 3,
                "ValueCount": 2,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 6
            },
            "WeightedShortestJobFirst": 4
        },
        "109733": {
            "CostOfDelay": 9,
            "BusinessValue": {
                "InverseAverage": 3,
                "ValueCount": 2,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 6
            },
            "Effort": {
                "InverseAverage": 3.5,
                "ValueCount": 2,
                "FibonacciAverage": 4,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 5
            },
            "Id": 109733,
            "SortPriority": 3,
            "SortPriorityGroup": 8,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 3,
                "ValueCount": 1,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 3
            },
            "SortOrder": 77,
            "TimeCriticality": {
                "InverseAverage": 3,
                "ValueCount": 2,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 6
            },
            "WeightedShortestJobFirst": 2.25
        },
        "110762": {
            "CostOfDelay": 9,
            "BusinessValue": {
                "InverseAverage": 3,
                "ValueCount": 1,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 3
            },
            "Effort": {
                "InverseAverage": 2.5,
                "ValueCount": 2,
                "FibonacciAverage": 2.5,
                "InverseValue": 3,
                "ValueMaximum": 4,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 7
            },
            "Id": 110762,
            "SortPriority": 3,
            "SortPriorityGroup": 9,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 3,
                "ValueCount": 1,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 3
            },
            "SortOrder": 78,
            "TimeCriticality": {
                "InverseAverage": 3,
                "ValueCount": 1,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 3
            },
            "WeightedShortestJobFirst": 3.6
        },
        "110777": {
            "CostOfDelay": 9,
            "BusinessValue": {
                "InverseAverage": 3,
                "ValueCount": 2,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 6
            },
            "Effort": {
                "InverseAverage": 2,
                "ValueCount": 2,
                "FibonacciAverage": 2,
                "InverseValue": 4,
                "ValueMaximum": 5,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 8
            },
            "Id": 110777,
            "SortPriority": 3,
            "SortPriorityGroup": 9,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 3,
                "ValueCount": 1,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 3
            },
            "SortOrder": 79,
            "TimeCriticality": {
                "InverseAverage": 3,
                "ValueCount": 2,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 6
            },
            "WeightedShortestJobFirst": 4.5
        },
        "110781": {
            "CostOfDelay": 9,
            "BusinessValue": {
                "InverseAverage": 3,
                "ValueCount": 1,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 3
            },
            "Effort": {
                "InverseAverage": 3,
                "ValueCount": 2,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 6
            },
            "Id": 110781,
            "SortPriority": 3,
            "SortPriorityGroup": 9,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 3,
                "ValueCount": 1,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 3
            },
            "SortOrder": 80,
            "TimeCriticality": {
                "InverseAverage": 3,
                "ValueCount": 1,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 3
            },
            "WeightedShortestJobFirst": 3
        },
        "135474": {
            "CostOfDelay": 9,
            "BusinessValue": {
                "InverseAverage": 3,
                "ValueCount": 2,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 6
            },
            "Effort": {
                "InverseAverage": 3.5,
                "ValueCount": 2,
                "FibonacciAverage": 4,
                "InverseValue": 2,
                "ValueMaximum": 3,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 5
            },
            "Id": 135474,
            "SortPriority": 3,
            "SortPriorityGroup": 9,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 3,
                "ValueCount": 1,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 3
            },
            "SortOrder": 81,
            "TimeCriticality": {
                "InverseAverage": 3,
                "ValueCount": 1,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 3
            },
            "WeightedShortestJobFirst": 2.25
        },
        "110769": {
            "CostOfDelay": 8.5,
            "BusinessValue": {
                "InverseAverage": 3,
                "ValueCount": 2,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 6
            },
            "Effort": {
                "InverseAverage": 1,
                "ValueCount": 2,
                "FibonacciAverage": 1,
                "InverseValue": 5,
                "ValueMaximum": 5,
                "ValueMinimum": 5,
                "Notifications": null,
                "ValueSum": 10
            },
            "Id": 110769,
            "SortPriority": 3,
            "SortPriorityGroup": 9,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 3,
                "ValueCount": 1,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 3
            },
            "SortOrder": 82,
            "TimeCriticality": {
                "InverseAverage": 2.5,
                "ValueCount": 2,
                "FibonacciAverage": 2.5,
                "InverseValue": 3,
                "ValueMaximum": 4,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 7
            },
            "WeightedShortestJobFirst": 8.5
        },
        "110774": {
            "CostOfDelay": 8.5,
            "BusinessValue": {
                "InverseAverage": 3,
                "ValueCount": 2,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 6
            },
            "Effort": {
                "InverseAverage": 2.5,
                "ValueCount": 2,
                "FibonacciAverage": 2.5,
                "InverseValue": 3,
                "ValueMaximum": 4,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 7
            },
            "Id": 110774,
            "SortPriority": 3,
            "SortPriorityGroup": 9,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 3,
                "ValueCount": 1,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 3
            },
            "SortOrder": 83,
            "TimeCriticality": {
                "InverseAverage": 2.5,
                "ValueCount": 2,
                "FibonacciAverage": 2.5,
                "InverseValue": 3,
                "ValueMaximum": 4,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 7
            },
            "WeightedShortestJobFirst": 3.4
        },
        "110804": {
            "CostOfDelay": 8.5,
            "BusinessValue": {
                "InverseAverage": 3,
                "ValueCount": 2,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 6
            },
            "Effort": {
                "InverseAverage": 3,
                "ValueCount": 2,
                "FibonacciAverage": 3.5,
                "InverseValue": 3,
                "ValueMaximum": 4,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 6
            },
            "Id": 110804,
            "SortPriority": 3,
            "SortPriorityGroup": 9,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 3,
                "ValueCount": 1,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 3
            },
            "SortOrder": 84,
            "TimeCriticality": {
                "InverseAverage": 2.5,
                "ValueCount": 2,
                "FibonacciAverage": 2.5,
                "InverseValue": 3,
                "ValueMaximum": 4,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 7
            },
            "WeightedShortestJobFirst": 2.42857
        },
        "110743": {
            "CostOfDelay": 8,
            "BusinessValue": {
                "InverseAverage": 2.5,
                "ValueCount": 2,
                "FibonacciAverage": 2.5,
                "InverseValue": 3,
                "ValueMaximum": 4,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 7
            },
            "Effort": {
                "InverseAverage": 5,
                "ValueCount": 3,
                "FibonacciAverage": 8,
                "InverseValue": 1,
                "ValueMaximum": 1,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 3
            },
            "Id": 110743,
            "SortPriority": 3,
            "SortPriorityGroup": 9,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 3,
                "ValueCount": 1,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 3
            },
            "SortOrder": 85,
            "TimeCriticality": {
                "InverseAverage": 2.5,
                "ValueCount": 2,
                "FibonacciAverage": 2.5,
                "InverseValue": 3,
                "ValueMaximum": 4,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 7
            },
            "WeightedShortestJobFirst": 1
        },
        "184797": {
            "CostOfDelay": 8,
            "BusinessValue": {
                "InverseAverage": 2.5,
                "ValueCount": 2,
                "FibonacciAverage": 2.5,
                "InverseValue": 3,
                "ValueMaximum": 4,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 7
            },
            "Effort": {
                "InverseAverage": 1.5,
                "ValueCount": 2,
                "FibonacciAverage": 1.5,
                "InverseValue": 4,
                "ValueMaximum": 5,
                "ValueMinimum": 4,
                "Notifications": null,
                "ValueSum": 9
            },
            "Id": 184797,
            "SortPriority": 3,
            "SortPriorityGroup": 9,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 3,
                "ValueCount": 2,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 6
            },
            "SortOrder": 86,
            "TimeCriticality": {
                "InverseAverage": 2.5,
                "ValueCount": 2,
                "FibonacciAverage": 2.5,
                "InverseValue": 3,
                "ValueMaximum": 4,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 7
            },
            "WeightedShortestJobFirst": 5.33333
        },
        "109736": {
            "CostOfDelay": 7.5,
            "BusinessValue": {
                "InverseAverage": 2.5,
                "ValueCount": 2,
                "FibonacciAverage": 2.5,
                "InverseValue": 3,
                "ValueMaximum": 4,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 7
            },
            "Effort": {
                "InverseAverage": 3,
                "ValueCount": 1,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 3
            },
            "Id": 109736,
            "SortPriority": 3,
            "SortPriorityGroup": 9,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 3,
                "ValueCount": 1,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 3
            },
            "SortOrder": 87,
            "TimeCriticality": {
                "InverseAverage": 2,
                "ValueCount": 2,
                "FibonacciAverage": 2,
                "InverseValue": 4,
                "ValueMaximum": 5,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 8
            },
            "WeightedShortestJobFirst": 2.5
        },
        "110744": {
            "CostOfDelay": 6,
            "BusinessValue": {
                "InverseAverage": 2,
                "ValueCount": 2,
                "FibonacciAverage": 2,
                "InverseValue": 4,
                "ValueMaximum": 4,
                "ValueMinimum": 4,
                "Notifications": null,
                "ValueSum": 8
            },
            "Effort": {
                "InverseAverage": 5,
                "ValueCount": 3,
                "FibonacciAverage": 8,
                "InverseValue": 1,
                "ValueMaximum": 1,
                "ValueMinimum": 1,
                "Notifications": null,
                "ValueSum": 3
            },
            "Id": 110744,
            "SortPriority": 3,
            "SortPriorityGroup": 9,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 2,
                "ValueCount": 1,
                "FibonacciAverage": 2,
                "InverseValue": 4,
                "ValueMaximum": 4,
                "ValueMinimum": 4,
                "Notifications": null,
                "ValueSum": 4
            },
            "SortOrder": 88,
            "TimeCriticality": {
                "InverseAverage": 2,
                "ValueCount": 2,
                "FibonacciAverage": 2,
                "InverseValue": 4,
                "ValueMaximum": 4,
                "ValueMinimum": 4,
                "Notifications": null,
                "ValueSum": 8
            },
            "WeightedShortestJobFirst": 0.75
        },
        "110745": {
            "CostOfDelay": 6,
            "BusinessValue": {
                "InverseAverage": 2,
                "ValueCount": 1,
                "FibonacciAverage": 2,
                "InverseValue": 4,
                "ValueMaximum": 4,
                "ValueMinimum": 4,
                "Notifications": null,
                "ValueSum": 4
            },
            "Effort": {
                "InverseAverage": 3,
                "ValueCount": 3,
                "FibonacciAverage": 3.33333,
                "InverseValue": 3,
                "ValueMaximum": 4,
                "ValueMinimum": 2,
                "Notifications": null,
                "ValueSum": 9
            },
            "Id": 110745,
            "SortPriority": 3,
            "SortPriorityGroup": 9,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 2,
                "ValueCount": 1,
                "FibonacciAverage": 2,
                "InverseValue": 4,
                "ValueMaximum": 4,
                "ValueMinimum": 4,
                "Notifications": null,
                "ValueSum": 4
            },
            "SortOrder": 89,
            "TimeCriticality": {
                "InverseAverage": 2,
                "ValueCount": 2,
                "FibonacciAverage": 2,
                "InverseValue": 4,
                "ValueMaximum": 4,
                "ValueMinimum": 4,
                "Notifications": null,
                "ValueSum": 8
            },
            "WeightedShortestJobFirst": 1.8
        },
        "110786": {
            "CostOfDelay": 5,
            "BusinessValue": {
                "InverseAverage": 2.5,
                "ValueCount": 2,
                "FibonacciAverage": 2.5,
                "InverseValue": 3,
                "ValueMaximum": 4,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 7
            },
            "Effort": {
                "InverseAverage": 3,
                "ValueCount": 2,
                "FibonacciAverage": 3,
                "InverseValue": 3,
                "ValueMaximum": 3,
                "ValueMinimum": 3,
                "Notifications": null,
                "ValueSum": 6
            },
            "Id": 110786,
            "SortPriority": 3,
            "SortPriorityGroup": 9,
            "RiskReductionOpportunityEnablement": {
                "InverseAverage": 1,
                "ValueCount": 1,
                "FibonacciAverage": 1,
                "InverseValue": 5,
                "ValueMaximum": 5,
                "ValueMinimum": 5,
                "Notifications": null,
                "ValueSum": 5
            },
            "SortOrder": 90,
            "TimeCriticality": {
                "InverseAverage": 1.5,
                "ValueCount": 2,
                "FibonacciAverage": 1.5,
                "InverseValue": 4,
                "ValueMaximum": 5,
                "ValueMinimum": 4,
                "Notifications": null,
                "ValueSum": 9
            },
            "WeightedShortestJobFirst": 1.66667
        }
    };
}

// #endregion Example

// #region Test

if (typeof document == 'undefined') {
    const username = '';
    const machineId = '';
    const fromHtml = false;
    const signalRUrl = "/signalr";
    const apiUrl = "https://eaf-dev.mes.infineon.com/api/v1/ado/";
    const windowLocationHRef = "https://eaf-dev.mes.infineon.com/html/cod.html?site=MES";
    const workItems = {
        a: "https://eaf-dev.mes.infineon.com/markdown/bugs-features-with-parents.json?v=2025-04-14-08-10",
        b: "https://eaf-dev.mes.infineon.com/markdown/{}.json?v=2025-04-14-08-10"
    };
    const b = {
        page: "business",
        description: "Value",
        th: "Business Value",
        span: "What is the relative value to the Customer or business?<br>• Do our users prefer this over that?<br>• What is the revenue impact on our business?<br>• Is there a potential penalty or other negative effects if we delay?"
    };
    const r = {
        page: "risk",
        description: "Risk",
        th: "Risk Reduction and/or Opportunity Enablement",
        span: "What else does this do for our business?<br>• Reduce the risk of this or future delivery?<br>• Is there value in the information we will receive?<br>• Enable new business opportunities?"
    };
    const t = {
        page: "time",
        description: "Critical",
        th: "Time Criticality",
        span: "How does user/business value decay over time?<br>• Is there a fixed deadline?<br>• Will they wait for us or move to another Solution?<br>• What is the current effect on Customer satisfaction?"
    };
    const c = {
        page: "cod",
        description: "CoD",
        th: "Cost of Delay (CoD)",
        span: "Cost of Delay (CoD) is the money lost by delaying or not doing a job for a specific time. It's a measure of the economic value of a job over time."
    };
    const e = {
        page: "effort",
        description: "Effort",
        th: "Effort",
        span: "Effort"
    };
    const w = {
        page: "wsjf",
        description: "WSJF",
        th: "Weightest Shortest Job First calculation (WSJF)",
        span: "Weightest Shortest Job First calculation (see @SCALE formula)"
    };
    const dataA = getExampleDataA();
    const dataB = getExampleDataB();
    _windowLocationHRef = windowLocationHRef;
    const records = getRecords(b, r, t, c, e, w, dataA, dataB);
    console.log(dataA.length);
    if (dataA.length > 0)
        console.log(dataA[0]);
    setRecords(fromHtml, b, r, t, c, e, w, records);
    initIndex(fromHtml, username, machineId, windowLocationHRef, workItems, b, r, t, c, e, w, apiUrl, signalRUrl);
}

// #endregion Test